/****************************************************************************/
/* T  vF SD J[hƂ̒ʐMɊւhCo								*/
/*   F VC++ŃfobO邽߂̃hCoB								*/
/*              @ŎsƂ͎@p̃hCogp邱			*/
/* 쐬F 2005.02.06														*/
/* Copyright    resove														*/
/****************************************************************************/

#include "stdafx.h"
#include "cardAccess.h"
#include "RfDriverInterface.h"
#include "DrvSdCard.h"
#include "DrvErrCode.h"
#include "TraceOut.h"
#include <conio.h>

/********************************************************************/
/* }N															*/
/********************************************************************/
#define SD_DRV_VERSION		(0x0003)			/* hCoo[W */
#define SD_DRV_TYPE			"Vcpp simulation."	/* hCo^Cv	*/

/********************************************************************/
/* ϐ															*/
/********************************************************************/
static DWORD driveNo = -1;
static unsigned long cardSize = 0UL;			/* J[hTCY		*/
static unsigned short blockSize = 0;			/* ubNTCY	*/
static cardAccess cardAccessObj;				/* VC++p̃X^u	*/
static HANDLE handle = INVALID_HANDLE_VALUE;	/* hCunh	*/
static unsigned short lastReadLen = 0;			/* Ō read  */

/********************************************************************/
/* O֐^錾													*/
/********************************************************************/

/********************************************************************/
/* ֐^錾													*/
/********************************************************************/
static unsigned short 
	WriteSdOneBlock( unsigned long address,
					 char * writeData );		/* 1ubN */
static unsigned short
	WriteSdMultiBlock( unsigned long address,
						unsigned short num,
						char * writeData );	/* ubN */
static unsigned short
	ReadSdOneBlock( unsigned long address,
					char * readData );			/* 1ubNǂݍ */
static unsigned short
	ReadSdSmallData( unsigned long address,
						unsigned short len,
						char * readData );		/* 1ubNǂݍ */

static unsigned short
	ReadSdMultiBlock( unsigned long address,
						unsigned short num,
						char * readData );		/* ubNǂݍ */

/****************************************************************************/
/* T  v																	*/
/*       hCo														*/
/* p[^																*/
/*       Ȃ																*/
/* ߂l																	*/
/*       TRUE F														*/
/*       FALSEFs														*/
/*   																	*/
/*       ubNTCYAJ[hTCY߂								*/
/****************************************************************************/
unsigned short InitSdCard( void )
{
	blockSize = 0;
	cardSize = 0UL;
	unsigned short ret = SD_ERR_INIT_RESET_TIMEOUT;

	// ȌI
	if( handle != INVALID_HANDLE_VALUE )
	{
		ConcludeSdCard();
	}

	if( driveNo == -1 )
	{
		/* ZbgꂽȂ */
		driveNo = cardAccessObj.selectDrive();					/* hCuI */ 
	}

	if( driveNo != -1 )
	{
		handle = cardAccessObj.openDrive( driveNo );			/* I[v */
		if( handle != INVALID_HANDLE_VALUE )
		{
			blockSize = (unsigned short)cardAccessObj.getSectorSize( handle );			/* ZN^[TCY擾 */
			cardSize = (unsigned long)cardAccessObj.getDriveSize( handle );		/* J[hŜ̃TCY擾 */
			ret = SD_OK;
		}
		else
		{
			driveNo = -1;										/* sĂ̎̉xI */
		}
	}
	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*        hCȍI													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        SD_OK o[W擾											*/
/*   																	*/
/*        hCo̎gp~Bwindowsł close B				*/
/****************************************************************************/
unsigned short ConcludeSdCard( void )
{
	unsigned short success = SD_ERR_WRITE_OTHER;
	

	if( handle != INVALID_HANDLE_VALUE )
	{
		if( cardAccessObj.closeDrive( handle ) )		/* N[Y */
		{
			success = SD_OK;
		}
		handle = INVALID_HANDLE_VALUE;
	}

	return success;
}

/****************************************************************************/
/* T  v																	*/
/*        Iȏ݂Ȃ										*/
/* p[^																*/
/*        addrFރJ[h̃AhX									*/
/*        buffFރf[^												*/
/*        len Fޒ												*/
/* ߂l																	*/
/*        F SD_OK														*/
/*   																	*/
/*        w肳ꂽf[^J[hɏ								*/
/****************************************************************************/
unsigned short WriteSdPhysical( unsigned long addr, char * buff, unsigned short len )
{
	unsigned short retCode = SD_ERR_DRV_INITIAL;
	unsigned short blockSize;
	unsigned long cardSize;
	unsigned short blockNum;

	blockSize = GetSdBlockSize();
	cardSize = GetSdCardSize();

	if( ( blockSize != 0 ) && ( cardSize != 0UL ) )
	{
		retCode = SD_OK;
		blockNum = len / blockSize;

		/* AhX`FbN */
		if( addr % (unsigned long)blockSize )
		{
			retCode = SD_ERR_REQ_ADDRESS;
		}
		else if( len % blockSize )					retCode = SD_ERR_REQ_LEN;
		else if( (addr + (unsigned long)len) > cardSize)
		{
			retCode = SD_ERR_REQ_ADDRESS;
		}
		else if( blockNum == 0 )					retCode = SD_ERR_REQ_LEN;
		else if( blockNum == 1 )
		{
			retCode = WriteSdOneBlock( addr, buff );		/* 1 ubN */
		}
		else
		{
			retCode = WriteSdMultiBlock( addr, blockNum, buff );	/* ubN */
		}
	}

	return retCode;

}
/****************************************************************************/
/* T  v																	*/
/*        IȓǂݎȂ										*/
/* p[^																*/
/*        addrFǂݍރJ[h̃AhX									*/
/*        buffFǂݍރf[^												*/
/*        len Fǂݍޒ												*/
/* ߂l																	*/
/*        F SD_OK														*/
/*   																	*/
/*        傫R̓ǂݍ݂ɕʂĂB								*/
/*        P͊JnAhXubN̋EƍĂȂꍇɎ̋E	*/
/*       ł܂́AŜǂݍޕB										*/
/*        Q߂̓ubN̋EubNPʂœǂݍޕB			*/
/*        ŌɃf[^̂KubNEɍĂȂɍŌ̃ubN	*/
/*       EǂݍޕB												*/
/****************************************************************************/
unsigned short ReadSdPhysical( unsigned long addr, char * buff, unsigned short len)
{
	unsigned short retCode = SD_ERR_DRV_INITIAL;
	unsigned short blockSize;
	unsigned long cardSize;
	unsigned long blockBord;
	unsigned short currLen;
	unsigned short blockNum;

	blockSize = GetSdBlockSize();
	cardSize = GetSdCardSize();

	if( ( blockSize != 0 ) && ( cardSize != 0UL ) )
	{
		lastReadLen = len;						/* readKick ̃eXĝ߂ɕۑ */

		/* AhX`FbN */
		if( !len )	retCode = SD_ERR_REQ_LEN;
		else if( (addr + (unsigned long)len) > cardSize)
		{
			retCode = SD_ERR_REQ_ADDRESS;
		}
		else
		{
			retCode = SD_OK;
			if( addr % (unsigned long)blockSize )
			{
				/* JnAhXubN̋؂ƍĂȂ */
				/* ubN̋؂܂œǂݍ */
				blockBord = (addr / (unsigned long)blockSize) * (unsigned long)blockSize;	/* ubN̐擪AhX */
				blockBord += (unsigned long)blockSize;			/* ̃ubN擪 */
				currLen = len;
				if( (addr + (unsigned long)len) > blockBord ) currLen = (unsigned short)(blockBord - addr);
				retCode = ReadSdSmallData( addr, currLen, buff );

				/* c̃AhXA߂ */
				addr += currLen;
				buff += currLen;
				if( len > currLen )		len -= currLen;
				else len = 0;
			}
			/* ł addr ̓ubN̋؂ɍĂ͂ */
			blockNum = (len / blockSize);						/* ubN߂	*/
			if( blockNum && (retCode == SD_OK) )
			{
				if( blockNum == 1 )
				{
					retCode = ReadSdOneBlock( addr, buff );		/* 1 ubNǂݍ */
				}
				else
				{
					retCode = ReadSdMultiBlock( addr, blockNum, buff );	/* ubNǂݍ */
				}
				/* c̃AhXA߂ */
				len -= blockNum * blockSize;
				addr += blockNum * blockSize;
				buff += blockNum * blockSize;
			}
			if( len && (retCode == SD_OK) )
			{
				/* c̃f[^ǂݍ */
				retCode = ReadSdSmallData( addr, len, buff );
			}
		}
	}

	return retCode;

}

/****************************************************************************/
/* T  v																	*/
/*        readKick ̐i擾											*/
/* p[^																*/
/*        *len Fǂݎ肪I										*/
/* ߂l																	*/
/*        F SD_OK														*/
/*   																	*/
/*        readKick() ͎łȂ̂ő ReadSdPhysical() s	*/
/*       ReadSdPoll() ReadSdPhysycal() œǂ񂾃f[^ɕԂB		*/
/****************************************************************************/
unsigned short ReadSdPoll( unsigned short * len)
{
	*len = lastReadLen;
	return SD_OK;
}

/****************************************************************************/
/* T  v																	*/
/*       1ubN													*/
/* p[^																*/
/*       addressFރAhX											*/
/*       writeDataFރf[^											*/
/* ߂l																	*/
/*       TRUE F														*/
/*       FALSEFs														*/
/*   																	*/
/*       wAhXXV												*/
/****************************************************************************/
unsigned short WriteSdOneBlock( unsigned long address, char * writeData )
{
	unsigned short ret = SD_ERR_WRITE_PHYSICAL;
	if( handle != INVALID_HANDLE_VALUE )
	{
		if( (address + (unsigned long)blockSize) < cardSize )
		{

			bool cardRet;
			cardRet = cardAccessObj.updateSector( handle, address, (char*)writeData );
			if( cardRet )	ret = SD_OK;
		}
	}

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*       P̃ZN^P̒lŃNA									*/
/* p[^																*/
/*       addressFރAhX											*/
/*       writeDataFރf[^											*/
/* ߂l																	*/
/*       TRUE F														*/
/*       FALSEFs														*/
/*   																	*/
/*       wAhXXV												*/
/****************************************************************************/
unsigned short FillSdOneBlock( unsigned long address, char writeData )
{
	char *pWkBuff;
	pWkBuff = new char[blockSize];

	/* ރf[^쐬 */
	for(int i = 0; i < blockSize; ++i)
	{
		pWkBuff[i] = writeData;
	}

	unsigned short ret = SD_ERR_WRITE_PHYSICAL;
	if( handle != INVALID_HANDLE_VALUE )
	{
		if( (address + (unsigned long)blockSize) < cardSize )
		{

			bool cardRet;
			cardRet = cardAccessObj.updateSector( handle, address, (char*)pWkBuff );
			if( cardRet )	ret = SD_OK;
		}
	}
	delete[] pWkBuff;

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*       ubN												*/
/* p[^																*/
/*       addressFރAhX											*/
/*       numFރubN											*/
/*       writeDataFރf[^											*/
/* ߂l																	*/
/*       TRUE F														*/
/*       FALSEFs														*/
/*   																	*/
/*       wAhXXV												*/
/****************************************************************************/
unsigned short WriteSdMultiBlock( unsigned long address, unsigned short num, char * writeData )
{
	unsigned short ret = SD_OK;

	for( unsigned short i = 0; i < num; ++i )
	{
		ret = WriteSdOneBlock( address, writeData );
		if( ret != SD_OK )		break;
		writeData += blockSize;
		address += blockSize;
	}

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*       1ubNǂݍ													*/
/* p[^																*/
/*       addressFǂݍރAhX											*/
/*       readDataFǂݍ񂾃f[^											*/
/* ߂l																	*/
/*       TRUE F														*/
/*       FALSEFs														*/
/*   																	*/
/*       wAhXǂݍ											*/
/****************************************************************************/
unsigned short ReadSdOneBlock( unsigned long address, char * readData )
{
	unsigned short ret = SD_ERR_READ;
	if( handle != INVALID_HANDLE_VALUE )
	{
		if( (address + blockSize) < cardSize )
		{

			bool cardRet;
			char * sect;
			cardRet = cardAccessObj.getSector( handle, address, &sect );
			for( unsigned short i = 0; i < blockSize; ++i )
			{
				readData[i] = sect[i];
			}
			if( cardRet )	ret = SD_OK;
		}
	}

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*       1ubNǂݍ											*/
/* p[^																*/
/*       addressFǂݍރAhX											*/
/*       lenFǂݍޒ													*/
/*       readDataFǂݍ񂾃f[^											*/
/* ߂l																	*/
/*       SD_OKF														*/
/*       ȊOAs														*/
/*   																	*/
/*       wAhXǂݍ											*/
/*       ubNԂ܂ēǂނƂ͂łȂ							*/
/****************************************************************************/
unsigned short ReadSdSmallData( unsigned long address, unsigned short len, char * readData )
{
	unsigned long blockAddr = (address / blockSize) * blockSize;	// ubN̐擪߂

	unsigned short ret = SD_ERR_READ;
	if( handle != INVALID_HANDLE_VALUE )
	{
		if( (address + blockSize) < cardSize )
		{

			bool cardRet;
			char * sect;
			cardRet = cardAccessObj.getSector( handle, blockAddr, &sect );
			unsigned short i = (unsigned short)(address - blockAddr);
			unsigned short ix = 0;
			for( ; i < blockSize; ++i )
			{
				if( ix >= len )		break;
				readData[ix] = sect[i];
				ix++;
			}
			if( cardRet )	ret = SD_OK;
		}
	}

	return ret;

}

/****************************************************************************/
/* T  v																	*/
/*       ubNǂݍ												*/
/* p[^																*/
/*       addressFǂݍރAhX											*/
/*       numFǂݍރubN											*/
/*       readDataFǂݍ񂾃f[^											*/
/* ߂l																	*/
/*       SD_OKF														*/
/*       ȊOAs														*/
/*   																	*/
/*       wAhXǂݍ											*/
/*       ubNԂ܂ēǂނƂ͂łȂ							*/
/****************************************************************************/
unsigned short ReadSdMultiBlock( unsigned long address, unsigned short num, char * readData )
{
	unsigned short ret = SD_ERR_READ;


	for(unsigned short i = 0; i < num; ++i )
	{
		ret = ReadSdOneBlock( address, readData );
		if( ret != SD_OK )		break;
		readData += blockSize;
		address += blockSize;
	}

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*       ZN^TCY擾												*/
/* p[^																*/
/*       Ȃ																*/
/* ߂l																	*/
/*       ZN^TCY														*/
/*   																	*/
/*       ZN^TCY擾												*/
/****************************************************************************/
unsigned short GetSdBlockSize( void )
{
	return blockSize;
}

/****************************************************************************/
/* T  v																	*/
/*       foCX̃TCY擾										*/
/* p[^																*/
/*       Ȃ																*/
/* ߂l																	*/
/*       J[hTCY														*/
/*   																	*/
/*       foCXTCY擾											*/
/****************************************************************************/
unsigned long GetSdCardSize( void )
{
	return cardSize;
}

/****************************************************************************/
/* T  v																	*/
/*        hCõo[W擾									*/
/* p[^																*/
/*        verFo[Wi[̈											*/
/* ߂l																	*/
/*        SD_OK o[W擾											*/
/*   																	*/
/*        o[W擾												*/
/****************************************************************************/
void GetSdDrvVer( T_RF_DRV_VER * ver )
{
	ver->ver = SD_DRV_VERSION;							/* hCoo[W */
	ver->type = SD_DRV_TYPE;							/* hCo^Cv */
}

	
