/****************************************************************************/
/* T  vF t@CVXe												*/
/*   F t@CVXe̕i											*/
/*              AvP[VC^tF[X(RfInterface.c)gp֐	*/
/* 쐬F 2004.12.12														*/
/* XVF 2009.01.04														*/
/* Copyright	resove														*/
/****************************************************************************/
#include "RfDiskLayout.h"
#include "RfMiddle.h"
#include "RfControlBuff.h"
#include "RfGeneral.h"

/****************************************************************************/
/* [J`																*/
/****************************************************************************/

/* FAT ̌𑁂邽߂܂ĂȂNX^̐擪ێ	 */
static unsigned short nowFreeClust = 0;			/* 󂫃NX^̘Aʒu*/
												/* ŌɎgpNX^̎̃ZN^ */

/* FAT2 ɔf鎞AύX͈͂𕡎ʂ邽߂ɊoĂ */
static unsigned short noseUpdateClust = 0;		/* ύXNX^̍ŏ	*/
static unsigned short tailUpdateClust = 0;		/* ύXNX^̍Ō	*/

/* FAT  */
#define RF_F_CLUST_FREE			( 0 )			/* 󂫃NX^				*/
#define RF_F_CLUST_TERMINATE	( 0xffff )		/* I[NX^				*/
#define RF_F_CLUST_BROKEN		( 0xfffe )		/* ꂽNX^			*/

static T_RF_DRIVE_INFO rfDriveInfo;				/* hCu				*/
static unsigned short initialSignature = 0;		/* Ϗ				*/

enum e_char_mix
{
	E_CHAR_SMALL = 0,
	E_CHAR_LARGE,
	E_CHAR_MIX
};

/* V[gt@Cŋ镶 */
#define VALID_SHORT_CHAR	"@!#$%&'()-`~_^{}"

/****************************************************************************/
/* Oϐ																	*/
/****************************************************************************/
extern const unsigned short rfSameTimeFileNum;		/* ɃI[vłt@C */
extern T_RF_FCB rfFileControlBlock[];				/* FCB 					*/
extern const unsigned short rfNestDelDir;			/* lXg			*/
extern const T_RF_SYSTEM_FUNCTION rfSystemFunction;
extern unsigned short * const pRfLongName;			/* long name pobt@	*/

/****************************************************************************/
/* ֐																	*/
/****************************************************************************/
/* FCB  */
static unsigned short InitAllFcb( void );
/* hCu擾 */
static unsigned short makeDriveInfo( void );
static unsigned short judgeMbr( void );					/* MBR L			*/
static void clearSystemVariable( void );					/* VXeϐ	*/


/****************************************************************************/
/* READ/WRITE ֘A															*/
/****************************************************************************/
/* NX^ԍAhXɕϊ */
static unsigned long clusterToAddr( unsigned short cluster );
/* NX^ */
static unsigned short fillCluster( unsigned long addr, char val  );
/* obt@mہXVς݃f[^	*/
static unsigned short RfmWriteKick( T_RF_FCB * pFcb );		

/****************************************************************************/
/* fBNg֘A																*/
/****************************************************************************/
/* ŉw̃fBNg̃NX^ԍ擾 */
static unsigned short findLastDir( char * filePath, unsigned short lim, unsigned short * err );
/* fBNgt@C */
static unsigned long findFileByName( char * flName, unsigned short cluster, unsigned short * err );
/* V[gt@CŌ */
static unsigned long findShortName( char * entryName, unsigned short cluster, unsigned short * err );
/* V[gt@C̃`FbNƃfBNǧ`ɕϊ */
static unsigned short checkShortName( char * flName, char * findName, char * charType );
/* u.vAu..vt@C`FbN */
static unsigned short checkException( char * flName, char * findName );
/* 󂫃Gǧ */
static unsigned long findFreeEntry( unsigned short cluster, unsigned short * err );
/* VȃfBNgGg */
static unsigned short makeEntry( unsigned long addr, char * fileNm, unsigned char attr, unsigned short cluster );
/* FCB ŃfBNgGgXV */
static unsigned short updateEntry( T_RF_FCB * pFcb );
/* ϊ */
static void toDirTime( char * dirTime, T_RF_TIME * nowTime );
/* fBNg̍쐬tAAms  T_RF_TIME `ɕϊ		*/
static void fromDirCreateTime( T_RF_TIME * pRfTime, char * dirTime );
/* fBNg̍XVtA T_RF_TIME `ɕϊ			*/
static void fromDirUpdateTime( T_RF_TIME * pRfTime, char * dirTime );
/* fBNg̃ANZXt T_RF_TIME `ɕϊ			*/
static void fromDirAccessDate( T_RF_TIME * pRfTime, char * dirTime );

/* LȃfBNgGgT */
static unsigned short getNextValidEntry( T_RF_SEARCH_DIR * pDelDirInfo );
/* fBNgGgT */
static unsigned short getNextEntry( T_RF_SEARCH_DIR * pSearchDir );
/* fBNgGgNX^ŒT */
static unsigned short getNextEntryNarrow( T_RF_SEARCH_DIR * pDelDirInfo );
/* V[gt@CA */
static void connectionFlName( char * pConnect,  char * pSeparate);

/****************************************************************************/
/* FAT ֘A																	*/
/****************************************************************************/
/* 󂫃NX^T */
static unsigned short findFreeClust( unsigned short * err );
/* ̃NX^擾 */
static unsigned short getNextCluster( unsigned short cluster, unsigned short * errCode );
/* FAT12/16ӎ FAT ̓e擾 */
static unsigned short getFatVal( unsigned short cluster, unsigned short * errCode );
/* FAT12 wNX^̊Ǘ̈擾 */
static unsigned short getFat12Value( unsigned short cluster, unsigned short * errCode );
/* FAT16 wNX^̊Ǘ̈擾 */
static unsigned short getFat16Value( unsigned short cluster, unsigned short * errCode );
/* FAT12/16 ӎ FAT ̓eXV */
static unsigned short setFatVal( unsigned short cluster, unsigned short val );
/* FAT12̎wNX^Ǘ̈XV */
static unsigned short setFat12Value( unsigned short cluster, unsigned short val );
/* FAT16̎wNX^Ǘ̈XV */
static unsigned short setFat16Value( unsigned short cluster, unsigned short val );

/****************************************************************************/
/* ͊֘A																*/
/****************************************************************************/
/* SoCglgݗĂ */
static unsigned long makeULongData( char * pBuff);
/* QoCglgݗĂ */
static unsigned short makeUShortData( char * pBuff);
/* 񌟍 */
static unsigned short findChar( char * str, char target, unsigned short len );
/* t@CpX̃g[NT */
static unsigned short takeToken( unsigned short tokenNum, char * filePath, unsigned short * len );
/* Ō̃g[NT */
static unsigned short takeLastToken( char * filePath, unsigned short lim );
/* ŏ̃g[NT */
static unsigned short takeOneToken( char * filePath, unsigned short len );
/* \ȏ܂ޕ񂩒ׂ */
static enum e_char_mix checkCharMix( char * str, unsigned short len );
/* V[gt@CɎgĂ镶`FbN */
static unsigned short isValidShortChar( char * name, unsigned short len );

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* VXȅ ֘A													*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/

/****************************************************************************/
/* T  v																	*/
/*        t@CVXe										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*         MBR, BPB ǂݎX̏擾B擾͈ȉ̒ʂB	*/
/*              E[gfBNg̈ʒu									*/
/*              E[gfBNg̃TCY								*/
/*              EFAT ̈ʒu												*/
/*              EFAT ̃TCY												*/
/*              Et@CVXě`iFAT12/FAT16j						*/
/*              Ef[^̈̈ʒu											*/
/*              ENX^TCY											*/
/*              EubNiZN^jTCY									*/
/*              FCB 											*/
/****************************************************************************/
unsigned short RfmInit( void )
{
	unsigned short ret;

	clearSystemVariable();							/* VXeϐ	*/

	ret = InitAllFcb(  );							/* FCB 			*/

	if( ret == RF_OK )
	{
		ret = RfbInitBuff( );							/* obt@Ǘ	*/
		if( ret == RF_OK )
		{
			ret = makeDriveInfo( );						/* hCu擾		*/
			initialSignature = RF_SIGNATURE_VALUE;		/* ςݏ		*/
			if( ret == RF_OK )
			{
				ret = RfbReflect( );
			}
		}
	}

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*        VXe֘A̕ϐ									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void clearSystemVariable( void )
{
	initialSignature = 0;							/* ςݏ */
	rfDriveInfo.drvInit = FALSE;					/* Iȏ敪*/
	rfDriveInfo.mbrInit = FALSE;					/* MBR 擾ł敪		*/
	rfDriveInfo.bpbInit = FALSE;					/* BPB 擾ł敪		*/

	nowFreeClust = 2;								/* ݂̋󂫃NX^ */
	noseUpdateClust = 0;							/* ܂XVĂȂӖ̃[ */
	tailUpdateClust = 0;							/* ܂XVĂȂӖ̃[ */
	
}

/****************************************************************************/
/* T  v																	*/
/*        Ă邩ׂ										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        RF_OKF													*/
/*        RF_ERR_NOT_INITIALIZEFĂȂ							*/
/*   																	*/
/*        Ă邩ׂB									*/
/****************************************************************************/
unsigned short RfmIsInitConfirm( void )
{
	unsigned short ret = RF_ERR_NOT_INITIALIZE;

	if( ( initialSignature == RF_SIGNATURE_VALUE ) &&
		( rfDriveInfo.bpbInit != FALSE ) )
	{
		ret = RF_OK;
	}

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*        hCu쐬											*/
/* p[^																*/
/*        *errCode															*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR...Fsiڍׂ RfErrCode.hQƂ̂Ɓj					*/
/*   																	*/
/*        MBR, BPB ǂݎX̏擾B擾͈ȉ̒ʂB	*/
/*        E[gfBNg̈ʒu										*/
/*        E[gfBNg̃TCY										*/
/*        EFAT ̈ʒu														*/
/*        EFAT ̃TCY													*/
/*        Et@CVXě`iFAT12/FAT16j							*/
/*        Ef[^̈̈ʒu												*/
/*        ENX^TCY													*/
/*        EubNiZN^jTCY										*/
/****************************************************************************/
unsigned short makeDriveInfo( void )
{

	unsigned short err = RF_OK;
	char buff[4];
	unsigned long bpbAddr;
	unsigned short rootSectorNum;						/* ROOT ̃ZN^ */
	unsigned long totalSectorNum;						/* SZN^ */
	unsigned long bodySectorNum;						/* body ̃ZN^ */
	unsigned short reservedSector;						/* \ZN^ */
	unsigned long clusterNum;							/* NX^	*/

	/**************************/
	/* hCu擾 */
	/**************************/
	rfDriveInfo.bytesPerSector = drvGetBlockSize();		/* ZN^TCY擾 	*/
	rfDriveInfo.cardSize = drvGetCapacity();			/* J[hS̃TCY擾 */
	if( ( rfDriveInfo.bytesPerSector == 0 ) ||
		( rfDriveInfo.cardSize == 0UL )  )
	{
		err = RF_ERR_BUFF_INITIAL;
		goto ERR_EXIT;
	}
	rfDriveInfo.drvInit = TRUE;							/* 񂪎擾ł	*/

	/*****************/
	/* MBR `FbN		 */
	/*****************/
	err = judgeMbr();
	if( err != RF_OK )													goto ERR_EXIT;
	bpbAddr = rfDriveInfo.bpbSector *
						 (unsigned long)rfDriveInfo.bytesPerSector;

	/*****************/
	/* BPB `FbN	 */
	/*****************/
	err = RfbRead( bpbAddr+BPB_SIGNATURE, buff, 2 );
	if( err != RF_OK )													goto ERR_EXIT;
	if( makeUShortData( buff ) != RF_SIGNATURE_VALUE )
	{
		err = RF_ERR_BPB_SIGNATURE;
		goto ERR_EXIT;
	}

	/*****************/
	/* BPB e擾 */
	/*****************/
	
	err = RfbRead( bpbAddr+BPB_RSVD_SEC_CNT, buff, 2 );		/* \ZN^ */
	if( err != RF_OK )												goto ERR_EXIT;
	reservedSector = makeUShortData( buff );		/* 1FAT ̃ZN^ */
	if( reservedSector < 1 )
	{
		err = RF_ERR_RSVD_SECT_CNT;
		goto ERR_EXIT;
	}
	rfDriveInfo.fatPoint = bpbAddr + 
							(unsigned long)rfDriveInfo.bytesPerSector *
							(unsigned long)reservedSector;	/* FAT AhX */
	err = RfbRead( bpbAddr+BPB_SECTOR_PER_CLUSTER, buff, 1 );
	if( err != RF_OK )												goto ERR_EXIT;
	rfDriveInfo.sectorPerCluster = (unsigned char)buff[0];	/* NX^̃ZN^ */
	rfDriveInfo.bytesPerCluster = (unsigned long)rfDriveInfo.sectorPerCluster *
								  (unsigned long)rfDriveInfo.bytesPerSector;	/* NX^̃oCg */
	err = RfbRead( bpbAddr+BPB_SECTOR_PER_FAT, buff, 2 );
	if( err != RF_OK )												goto ERR_EXIT;
	rfDriveInfo.fatSize = makeUShortData( buff );			/* 1FAT ̃ZN^ */
	rfDriveInfo.fatSize *= (unsigned long)rfDriveInfo.bytesPerSector;	/* 1FAT ̃oCgɂ */

	err = RfbRead( bpbAddr+BPB_NUM_OF_FAT, buff, 1 );
	if( err != RF_OK )												goto ERR_EXIT;
	rfDriveInfo.fatNum = (unsigned short)(buff[0] &0x00ff);	/* FAT  */

	/* root AhX */
	rfDriveInfo.rootPoint =  (unsigned long)rfDriveInfo.fatSize *
							 (unsigned long)rfDriveInfo.fatNum +
							 (unsigned long)rfDriveInfo.fatPoint;
	err = RfbRead( bpbAddr+BPB_NUM_OF_ROOT, buff, 2 );
	if( err != RF_OK )												goto ERR_EXIT;
	rfDriveInfo.rootEntryNum = makeUShortData( buff );	/* ROOT Gg */

	/* body AhX */
	rootSectorNum = (unsigned short)(
					  rfDriveInfo.rootEntryNum *		/* ROOT ̃ZN^؂グČvZ */
					  DIR_RECORD_SIZE +
					  rfDriveInfo.bytesPerSector - 1) / rfDriveInfo.bytesPerSector;
	
	rfDriveInfo.bodyPoint = (unsigned long)rootSectorNum *
							 (unsigned long)rfDriveInfo.bytesPerSector +
							 (unsigned long)rfDriveInfo.rootPoint;
	/* SNX^ */
	err = RfbRead( bpbAddr+BPB_TOTAL_SECT, buff, 2 );
	if( err != RF_OK )												goto ERR_EXIT;
	totalSectorNum = (unsigned long)makeUShortData( buff );		/* TCY̑SZN^ */
	if( totalSectorNum == 0UL )
	{
		err = RfbRead( bpbAddr+BPB_LARGE_TOTAL_SECT, buff, 4 );
		if( err != RF_OK )											goto ERR_EXIT;
		totalSectorNum = makeULongData( buff );			/* 傫TCY̑SZN^ */
	}

	bodySectorNum = totalSectorNum -					/* body ̃ZN^ */
					 ( rfDriveInfo.bodyPoint - bpbAddr ) /
					 (unsigned long)rfDriveInfo.bytesPerSector;
	clusterNum = bodySectorNum /
				  (unsigned long)rfDriveInfo.sectorPerCluster;

	/* t@CVXe` */
	if( clusterNum <= RF_CLUSTER_NUM_FAT12 )
	{
		rfDriveInfo.fSystem = RF_F_SYSTEM_FAT12;
		rfDriveInfo.clusterNum = (unsigned short)clusterNum;
		err = RF_OK;
	}
	else if( clusterNum <= RF_CLUSTER_NUM_FAT16 )
	{
		rfDriveInfo.fSystem = RF_F_SYSTEM_FAT16;
		rfDriveInfo.clusterNum = (unsigned short)clusterNum;
		err = RF_OK;
	}
	else
	{
		rfDriveInfo.fSystem = RF_F_SYSTEM_UNKNOWN;
		err = RF_ERR_UNKNOWN_FILE_SYSTEM;				/* FAT12,FAT16 ŃT|[głȂt@CVXe */
		goto ERR_EXIT;
	}

	rfDriveInfo.bpbInit = TRUE;							/* BPB 擾ł	*/

ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        擪ZN^ MBR 肷										*/
/* p[^																*/
/*        *errCode															*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR...Fsiڍׂ RfErrCode.hQƂ̂Ɓj					*/
/*   																	*/
/*        擪ZN^ǂ MBR 邩肷BMBR ꍇ͈ȉ̐	*/
/*        ȂB													*/
/*         rfDriveInfo.mbrInit = 1;		MBR B							*/
/*         rfDriveInfo.bpbSector = bsr;	BSR ZN^ݒB					*/
/*        MBR Ȃꍇ͈ȉB											*/
/*         rfDriveInfo.mbrInit = 0;		MBR ȂB							*/
/*         rfDriveInfo.bpbSector = 0;	BSR ZN^ 0 B					*/
/*        擪ZN^ MBR Ɖ肵ăp[eBVR[hʒuɂȉ	*/
/*         MBR Ƃ݂ȂB											*/
/*         EVXeID 0 ȊO											*/
/*         EBSR ʒu 0 łȂ											*/
/*         Ep[eBVTCY 0x10 ȏ								*/
/*        擪ZN^ BSR Ƃ݂Ȃ͈̂ȉB								*/
/*         EBSR ʒu 0 													*/
/*         Ep[eBVTCY 0 										*/
/*                                                                          */
/*        u[gߗ̈ɃWv߂i[Ă BSR Ɣf	*/
/*          Ƃ񂪂邪Aɂ windows ͏̂悤ɓ삵Ă	*/
/*          ƂʂꂽB										*/
/****************************************************************************/
unsigned short judgeMbr( void )
{
	unsigned short err = RF_OK;
	unsigned long bpbSector = 0L;
	unsigned long bpbSize = 0L;
	char systemId = 0;
	char buff[4];

	err = RfbRead( MBR_SIGNATURE, buff, 2 );
	if( err != RF_OK )													goto ERR_EXIT;
	if( makeUShortData( buff ) != RF_SIGNATURE_VALUE )
	{
		err = RF_ERR_MBR_SIGNATURE;
		goto ERR_EXIT;
	}

	err = RfbRead( MBR_PARTITION_TABLE+MBR_PT_SYSTEM_ID, &systemId, 1 );	/* System ID 擾 */
	if( err != RF_OK )													goto ERR_EXIT;
	err = RfbRead( MBR_PARTITION_TABLE+MBR_PT_BPB_POINT, buff, 4 );	/* BSR ʒu擾 */
	if( err != RF_OK )													goto ERR_EXIT;
	bpbSector = makeULongData( buff );
	err = RfbRead( MBR_PARTITION_TABLE+MBR_PT_SECTOR_IN_PERTITION, 
															buff, 4 );	/* p[eBVTCY擾 */
	if( err != RF_OK )													goto ERR_EXIT;
	bpbSize = makeULongData( buff );


	if( ( bpbSector == 0UL ) && ( bpbSize == 0UL ) )
	{
		/* 擪 MBR ͖ BSR  */
		rfDriveInfo.bpbSector = 0L;						/* BPB ZN^ */
		rfDriveInfo.mbrInit = FALSE;					/* MBR ݂͑Ȃ	*/
	}
	else if( ( systemId != 0 ) && ( bpbSector != 0UL ) && ( bpbSize >= 0x10UL ) )
	{
		/* 擪 MBR ꍇ */
		rfDriveInfo.bpbSector = bpbSector;
		rfDriveInfo.mbrInit = TRUE;						/* MBR 擾ł	*/
	}
	else
	{
		err = RF_ERR_UNKNOWN_FILE_SYSTEM;				/* MBR or BSR s */
	}
ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        hCu擾											*/
/* p[^																*/
/*        T_RF_DRIVE_INFO \̂ւ̃|C^								*/
/* ߂l																	*/
/*        RF_OKF														*/
/*   																	*/
/*        hCu擾											*/
/*        hCu͓ɂǂ܂ł̏̃tOB	*/
/*       ̃tOɂLȃf[^قȂ̂Œӂ邱ƁI				*/
/****************************************************************************/
unsigned short RfmGetDriveInfo( T_RF_DRIVE_INFO * driveInfo )
{
	unsigned short cond = RF_OK;


	if( initialSignature != RF_SIGNATURE_VALUE )

	{
		cond = RF_ERR_NOT_INITIALIZE;
	}
	else
	{
		rfMemCpy( driveInfo, &rfDriveInfo, (unsigned long)sizeof(T_RF_DRIVE_INFO));
		cond = RF_OK;
	}
	return cond;
}

/****************************************************************************/
/* T  v																	*/
/*        gp FCB T												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         gp FCB TẴAhXԂ							*/
/*   																	*/
/****************************************************************************/
T_RF_FCB * RfmFindFreeFcb( void )
{
	unsigned short i = 0;
	T_RF_FCB * pFcb = NULL;

	/* FCB ̖gp̈T */
	for( i = 0; i < rfSameTimeFileNum; ++i )
	{
		if( rfFileControlBlock[i].useFlag == FALSE )
		{
			pFcb = &rfFileControlBlock[i];
			break;
		}
	}
	return pFcb;
}

/****************************************************************************/
/* T  v																	*/
/*        w肳ꂽGg|CgłɃI[vĂ邩ׂ		*/
/* p[^																*/
/*        fBNgGg̃AhX									*/
/* ߂l																	*/
/*         RF_OKFgpĂȂ											*/
/*         RF_ERR_ALREADY_OPENDFłɃI[vĂ					*/
/*   																	*/
/****************************************************************************/
unsigned short RfmCheckAlreadyOpen( unsigned long addr, T_RF_FCB * pFcb )
{
	unsigned short err = RF_OK;
	unsigned short i = 0;

	/* gp FCB œ̃t@CI[vĂ̂T */
	for( i = 0; i < rfSameTimeFileNum; ++i )
	{
		if( (rfFileControlBlock[i].useFlag != FALSE ) &&
			(&rfFileControlBlock[i] != pFcb) &&
			(rfFileControlBlock[i].brk.sr.entryAddr == addr ) )
		{
			err = RF_ERR_ALREADY_OPEND;
			break;
		}
	}
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        gp FCB T												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*         gp FCB TẴAhXԂ							*/
/*   																	*/
/****************************************************************************/
T_RF_FCB * RfmFindUseFcb( void )
{
	unsigned short i = 0;
	T_RF_FCB * pFcb = (T_RF_FCB *)0UL;

	/* FCB ̖gp̈T */
	for( i = 0; i < rfSameTimeFileNum; ++i )
	{
		if( rfFileControlBlock[i].useFlag != FALSE )
		{
			pFcb = &rfFileControlBlock[i];
			break;
		}
	}
	return pFcb;
}

/****************************************************************************/
/* T  v																	*/
/*        FCB ̏														*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        RF_OKF														*/
/*   																	*/
/*        FCB ̎gp敪𖢎gpɂ										*/
/****************************************************************************/
unsigned short InitAllFcb( void )
{
	unsigned short i;

	for( i = 0; i < rfSameTimeFileNum; ++i )
	{
		rfFileControlBlock[i].useFlag = FALSE;
	}
	return RF_OK;
}

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* OPEN/CLOSE ֘A															*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/

/****************************************************************************/
/* T  v																	*/
/*        gp FCB 											*/
/* p[^																*/
/*        pFcb    Fgp FCB											*/
/* ߂l																	*/
/*        RF_OKF														*/
/*   																	*/
/*        ꂩgp FCB B								*/
/****************************************************************************/
unsigned short RfmInitUseFcb( T_RF_FCB * pFcb )
{
	/* FCB  */
	pFcb->useFlag = TRUE;							/* gp敪				*/
	pFcb->canWriteFlag = (unsigned char)RfbIsCanWrite();	/* ݉ېݒ		*/
	pFcb->openMode = 0;								/* I[v[hNA			 */
	pFcb->brk.sr.curPoint = 0UL;					/* ݂̃t@C擪̃oCgʒu */
	pFcb->brk.sr.pointInCluster = 0;				/* NX^̈ʒu			*/
	pFcb->brk.sr.curCluster = 0;					/* ݈ʒu:NX^ԍ	*/
	pFcb->brk.sr.entryAddr = 0UL;					/* fBNgGg̃AhX	*/
	pFcb->brk.sr.firstCluster = 0;					/* 擪̃NX^ԍ		*/
	pFcb->brk.sr.totalLen = 0UL;					/* t@C̃g[^		*/

	return RF_OK;
}

/****************************************************************************/
/* T  v																	*/
/*        FCB J													*/
/* p[^																*/
/*        pFcbFJ FCB												*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_NOT_OPENEDFI[vĂȂ							*/
/*        RF_ERR_...F̑̏݃G[								*/
/*   																	*/
/*        N[YɎsBׂẴobt@𕨗IɏށB		*/
/*        FATAfBNgGgXVB								*/
/****************************************************************************/
unsigned short RfmReleaseFcb( T_RF_FCB * pFcb )
{
	unsigned short errCode = RF_ERR_NOT_OPENED;

	if( pFcb != NULL )
	{
		if( pFcb->useFlag != FALSE )
		{
			errCode = RfmFlush( pFcb );
			pFcb->useFlag = FALSE;					/* gpԂɂ	*/
		}
	}
	return errCode;
}

/****************************************************************************/
/* T  v																	*/
/*        t@CɕIɏ										*/
/* p[^																*/
/*        pFcbF FCB														*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...F̑̃G[										*/
/*   																	*/
/*        ׂẴobt@𕨗IɏށBĂȂobt@	*/
/*        ̂Ŏ read ͕IȃANZXB				*/
/*        FATAfBNgGgXVB								*/
/****************************************************************************/
unsigned short RfmFlush( T_RF_FCB * pFcb )
{
	unsigned short errCode = RF_ERR_NOT_OPENED;

	errCode = RF_OK;
	if( (pFcb->openMode & (RF_OPEN_WRITE_NEW|RF_OPEN_WRITE_CREATE|RF_OPEN_WRITE_OLD)) != 0 )
	{
		/* t@C write ̂ */
		errCode = updateEntry( pFcb );			/* fBNgGgXV */
	}

	if( errCode == RF_OK )
	{
		/* obt@ */
		errCode = RfbReflect(  );				/* ׂď */
	}

	return errCode;
}

/****************************************************************************/
/* T  v																	*/
/*        ROOT fBNg̏ FCB 								*/
/* p[^																*/
/*        pFcbFFCB															*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_NOT_OPENEDFI[vĂȂ							*/
/*        RF_ERR_...F̑̏݃G[								*/
/*   																	*/
/*          E															*/
/*          Et@CTCY												*/
/*          Ef[^̐擪NX^ԍ										*/
/****************************************************************************/
unsigned short RfmTakeRootInfo( T_RF_FCB * pFcb )
{
	pFcb->brk.sr.entryAddr = 0UL;
	pFcb->brk.sr.attribute = DIR_ATTR_DIRECTORY;
	pFcb->brk.sr.totalLen = 0UL;
	pFcb->brk.sr.pointInCluster = 0UL;
	pFcb->brk.sr.firstCluster = 0UL;
	pFcb->brk.sr.curCluster = 0UL;
	pFcb->brk.sr.curPoint = 0UL;

	return RF_OK;
}

/****************************************************************************/
/* T  v																	*/
/*        ݂t@C̏ FCB Ɏ荞							*/
/* p[^																*/
/*        pFcbFFCB															*/
/*        entryFt@C̃fBNgGgAhX						*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_NOT_OPENEDFI[vĂȂ							*/
/*        RF_ERR_...F̑̏݃G[								*/
/*   																	*/
/*        ݂t@CI[v鎞A݂t@C̏ FCB 	*/
/*        BfBNgGg擾́A				*/
/*          E															*/
/*          Et@CTCY												*/
/*          Ef[^̐擪NX^ԍ										*/
/****************************************************************************/
unsigned short RfmTakeExistInfo( T_RF_FCB * pFcb, unsigned long entry )
{
	unsigned short err = RF_OK;
	char buff[4];

	pFcb->brk.sr.entryAddr = entry;

	/* 擾 */
	err = RfbRead( pFcb->brk.sr.entryAddr+DIR_ATTRIBUTE, (char*)&pFcb->brk.sr.attribute, 1 );
	if( err != RF_OK )				goto ERR_EXIT;

	/* t@CTCY擾 */
	err = RfbRead( pFcb->brk.sr.entryAddr+DIR_FILE_SIZE, buff, 4 );
	if( err != RF_OK )				goto ERR_EXIT;
	pFcb->brk.sr.totalLen = makeULongData( buff );				/* t@CS̒擾 */


	/* 擪NX^ԍ擾 */
	err = RfbRead( pFcb->brk.sr.entryAddr+DIR_CLUSTOR_NUM, buff, 2 );
	if( err != RF_OK )				goto ERR_EXIT;
	pFcb->brk.sr.firstCluster = makeUShortData( buff );				/* 擪NX^ԍ擾 */
	pFcb->brk.sr.curCluster = pFcb->brk.sr.firstCluster;

	pFcb->brk.sr.curPoint = 0UL;						/* ݂̈ʒu		*/

ERR_EXIT:
	return err;
}

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* READ/WRITE ֘A															*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* T  v																	*/
/*       t@C̓eǂݍ											*/
/* p[^																*/
/*        pFcb FFCB														*/
/*        pBuffFǂݍ񂾃f[^i[̈								*/
/*        size FǂݍޒAI͓ǂݍ߂						*/
/* ߂l																	*/
/*        RF_OK FI													*/
/*        RF_ERR_EOFFǂݍݒt@C̏I[ɒB						*/
/*        RF_ERR_...F̑ǂݍ݃G[									*/
/*   																	*/
/*        NX^̃f[^͘AIɓǂݏo邪NX^܂鎞̓A	*/
/*       hXvZēǂݍށB										*/
/*        pointInCluster ̓NX^TCYƈv鎞B̏ꍇ͌	*/
/*       ̃NX^ɋ󂫂͂Ȃ̂ő̃NX^擾B				*/
/****************************************************************************/
unsigned short RfmRead( T_RF_FCB * pFcb, char * pBuff, unsigned long * size )
{
	unsigned short err = RF_OK;
	unsigned long addr = 0UL;
	unsigned long remain = *size;
	unsigned long getLen;								/* 񖈂ɓǂރTCY */
	unsigned short nextCluster;							/* ̃NX^ԍ	*/
	char *pSave = pBuff;								/* ۑʒu */
	char overSize = FALSE;								/* t@CTCY𒴂vtO */

	if( pFcb == NULL )
	{
		err = RF_ERR_NOT_OPENED;
		goto ERR_EXIT;									/* pFcb G[		*/
	}

	/* vt@C̏I[𒴂ꍇ */
	if( ( pFcb->brk.sr.curPoint + *size ) > pFcb->brk.sr.totalLen )
	{
		remain = pFcb->brk.sr.totalLen - pFcb->brk.sr.curPoint;		/* I[܂łǂݎTCYƂ */
		overSize = TRUE;
	}

	while( remain != 0UL )
	{
		if( rfDriveInfo.bytesPerCluster <= pFcb->brk.sr.pointInCluster )
		{
			/* NX^Ƀf[^cĂȂ */
			nextCluster = getNextCluster( pFcb->brk.sr.curCluster, &err );	/* ̃NX^擾 */
			if( err != RF_OK )			goto ERR_EXIT;	/* ǂݎ莸s			*/
			if( nextCluster == RF_F_CLUST_TERMINATE )
			{
				err = RF_ERR_BROKEN_FILE;				
				goto ERR_EXIT;							/* ǂݎ莸s			*/
			}
			pFcb->brk.sr.curCluster = nextCluster;		/* ̃NX^ʒuݒ		*/
			pFcb->brk.sr.pointInCluster = 0;			/* NX^̈ʒuXV			*/
		}

		/* NX^̓ǂݎ钷߂ */
		getLen = remain;								/* cTCYׂēǂݎ */
		if( remain > ( rfDriveInfo.bytesPerCluster - pFcb->brk.sr.pointInCluster ) )
		{
			/* NX^̏I[𒴂鎞 */
			getLen
				= rfDriveInfo.bytesPerCluster - pFcb->brk.sr.pointInCluster;	/* NX^̏I[܂œǂݎ */
		}

		/* NX^ԍAhX߂ */
		err = RF_ERR_BROKEN_FILE;				
		addr = clusterToAddr( pFcb->brk.sr.curCluster );
		if( addr == 0UL )				goto ERR_EXIT;	/* t@CĂ */

		addr += pFcb->brk.sr.pointInCluster;			/* NX^̐擪ǂݎʒu܂ňړ */
		err = RfbRead( addr, pSave, getLen );			/* f[^擾 */
		if( err != RF_OK )				goto ERR_EXIT;	/* ANZXG[ */

		/* |C^ލXV */
		remain -= getLen;								/* cTCYoTCY */
		pSave += getLen;								/* i[ʒuXV			*/
		pFcb->brk.sr.curPoint += getLen;				/* ݈ʒuXV			*/
		pFcb->brk.sr.pointInCluster += getLen;			/* NX^̈ʒuXV		*/
	}

	if( overSize != FALSE )
	{
		err = RF_ERR_EOF;					/* I[𒴂Ă̂ EOF */
		goto ERR_EXIT;
	}

	err = RfmReadKick( pFcb );							/* ǂł */

ERR_EXIT:
	*size = (unsigned long)(pSave - pBuff);				/* ǂݍ݃oCg */
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*       ̃f[^ǂ݂												*/
/* p[^																*/
/*        pFcb FFCB														*/
/* ߂l																	*/
/*        RF_OK FI													*/
/*        RF_ERR_DEFINE_DRIVERFhCoɐǂ݋@\͎ĂȂB	*/
/*        RF_ERR_...F̑ǂݍ݃G[									*/
/*   																	*/
/*        FCB ăt@CǂݎʒuZN^Eɂꍇ͎̃ZN^	*/
/*       f[^̓ǂݎNB										*/
/****************************************************************************/
unsigned short RfmReadKick( T_RF_FCB * pFcb )
{
	unsigned long addr;
	unsigned short err = RF_OK;
	unsigned short nextCluster;							/* ̃NX^ԍ	*/

	/* cf[^ */
	/* V[PV̍œKIvVtĂꍇ͐ǂł */
	if( ( pFcb->brk.sr.curPoint < pFcb->brk.sr.totalLen ) &&
		(( pFcb->openMode & RF_OPEN_OPT_SEQ) == RF_OPEN_OPT_SEQ ) &&
		(( pFcb->brk.sr.curPoint % rfDriveInfo.bytesPerSector ) == 0 ) ) 	/* ZN^E */
	{
		if( rfDriveInfo.bytesPerCluster <= pFcb->brk.sr.pointInCluster )
		{
			/* NX^Ȅꍇ̃NX^ʒu߂ */
			nextCluster = getNextCluster( pFcb->brk.sr.curCluster, &err );	/* ̃NX^擾 */
			if( err != RF_OK )			goto ERR_EXIT;	/* ǂݎ莸s			*/
			if( nextCluster == RF_F_CLUST_TERMINATE )
			{
				err = RF_ERR_BROKEN_FILE;
				goto ERR_EXIT;							/* ǂݎ莸s			*/
			}
			pFcb->brk.sr.curCluster = nextCluster;		/* ̃NX^ʒuݒ		*/
			pFcb->brk.sr.pointInCluster = 0;			/* NX^̈ʒuXV			*/
		}

		err = RF_ERR_BROKEN_FILE;
		addr = clusterToAddr( pFcb->brk.sr.curCluster );
		if( addr == 0UL)				goto ERR_EXIT;	/* t@CĂ */
		addr += pFcb->brk.sr.pointInCluster;			/* NX^̐擪ǂݎʒu܂ňړ */
		err = RfbPostSecureRead( addr );				/* ǂݎJn */
	}
ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*       XV̏If[^ɏ										*/
/* p[^																*/
/*        pFcb FFCB														*/
/* ߂l																	*/
/*        RF_OK FI													*/
/*        RF_ERR_DEFINE_DRIVERFhCoɐǂ݋@\͎ĂȂB	*/
/*        RF_ERR_...F̑ǂݍ݃G[									*/
/*   																	*/
/*        FCB ăt@CʒuZN^Eɂꍇ͎̃ZN^̊mۂ	*/
/*      ȂBobt@̊mۂ̂߂ɍXVς݂̃f[^foCX	*/
/*      ܂B														*/
/*       RfmWriteAppend()݂̂ŎgpB									*/
/****************************************************************************/
unsigned short RfmWriteKick( T_RF_FCB * pFcb )
{
	unsigned long addr;
	unsigned short err = RF_OK;
	unsigned short nextCluster;							/* ̃NX^ԍ	*/

	/* V[PV̍œKIvVtĂꍇ͐ǂł */
	if( (( pFcb->openMode & RF_OPEN_OPT_SEQ) == RF_OPEN_OPT_SEQ ) &&
		(( pFcb->brk.sr.curPoint % rfDriveInfo.bytesPerSector ) == 0 ) ) 	/* ZN^E */
	{
		if( pFcb->brk.sr.pointInCluster >= rfDriveInfo.bytesPerCluster )
		{
			/* NX^ȄꍇA炽ȃNX^mۂ */
			nextCluster = findFreeClust( &err );
			if( err != RF_OK )			goto ERR_EXIT;	/* NX^mێs			*/
			err = setFatVal( pFcb->brk.sr.curCluster,
										nextCluster );	/* ݂̃NX^Ɏ̃NX^ԍ */
			if( err != RF_OK )			goto ERR_EXIT;	/* FAT XVs */
			err = setFatVal( nextCluster,
							 RF_F_CLUST_TERMINATE );	/* ̃NX^I[ƂĂ */
			if( err != RF_OK )			goto ERR_EXIT;	/* FAT XVs */
			pFcb->brk.sr.curCluster = nextCluster;		/* ̃NX^ݒ */
			pFcb->brk.sr.pointInCluster = 0;
		}

		err = RF_ERR_BROKEN_FILE;
		addr = clusterToAddr( pFcb->brk.sr.curCluster );
		if( addr == 0UL )				goto ERR_EXIT;	/* t@CĂ */
		addr += pFcb->brk.sr.pointInCluster;			/* NX^̐擪ǂݎʒu܂ňړ */
		err = RfbPostSecureWrite( addr );				/* ǂݎJn */
	}
ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*       t@CɃf[^ǉ݂									*/
/* p[^																*/
/*        pFcb FFCB														*/
/*        pBuffFރf[^i[Ă̈							*/
/*        size FޒAI͏߂						*/
/* ߂l																	*/
/*        RF_OK FI													*/
/*        RF_ERR_...Fǂݍ݃G[										*/
/*   																	*/
/*        NX^̃f[^͘AIɏ߂邪NX^܂鎞̓A	*/
/*       hXvZďށB										*/
/****************************************************************************/
unsigned short RfmWriteAppend( T_RF_FCB * pFcb, char * pBuff, unsigned long * size )
{
	unsigned short err = RF_ERR_CANNOT_APPEND;			/* G[R[h		*/
	unsigned long remain = *size;						/* c̏ޒ	*/
	unsigned long writeLen = 0;
	unsigned long addr = 0;
	unsigned short nextClust = 0;
	short useOrg = FALSE;
	char *pTake = pBuff;						/* oʒu */

	if( pFcb->brk.sr.curPoint != pFcb->brk.sr.totalLen )	goto ERR_EXIT;

	if( ( pFcb->openMode & RF_OPEN_WRITE_OLD ) == RF_OPEN_WRITE_OLD )
	{
		useOrg = TRUE;						/* ǂł珑 */
	}

	while( remain != 0UL )
	{
		if( ( pFcb->brk.sr.pointInCluster >= rfDriveInfo.bytesPerCluster ) ||
			( ( pFcb->brk.sr.pointInCluster == 0UL ) && (pFcb->brk.sr.curCluster == 0 ) )    )
		{
			/* NX^ɋ󂫂ƂA܂܂ĂȂƂ	*/
			/* 󂫃NX^mۂ		*/
			err = RF_ERR_NO_SPACE;
			nextClust = findFreeClust( &err );
			if( err != RF_OK )			goto ERR_EXIT;	/* 󂫃NX^Ȃ	*/
			if( pFcb->brk.sr.curCluster == 0 )
			{
				pFcb->brk.sr.curCluster = nextClust;	/* 񏑂ݎ݂͌̃NX^ԍXV */
				pFcb->brk.sr.firstCluster = nextClust;	/* 񏑂ݎ͐擪̃NX^ԍݒ */
			}
			else
			{
				err = setFatVal( pFcb->brk.sr.curCluster,
								 nextClust );			/* ݂̃NX^Ɏ̃NX^ԍ */
				if( err != RF_OK )			goto ERR_EXIT;	/* FAT XVs */
			}
			err = setFatVal( nextClust,
							 RF_F_CLUST_TERMINATE );	/* ̃NX^I[ƂĂ */
			if( err != RF_OK )			goto ERR_EXIT;	/* FAT XVs */
			pFcb->brk.sr.curCluster = nextClust;			/* ̃NX^ݒ */
			pFcb->brk.sr.pointInCluster = 0;
		}
		writeLen = remain;
		if( remain > ( rfDriveInfo.bytesPerCluster - pFcb->brk.sr.pointInCluster ) )
		{
			/* ݗvNX^̍Ō𒴂ĂƂ */
			/* NX^̍Ō܂ŏ						*/
			writeLen = rfDriveInfo.bytesPerCluster - pFcb->brk.sr.pointInCluster;
		}

		/* NX^ԍAhX߂ */
		err = RF_ERR_BROKEN_FILE;
		addr = clusterToAddr( pFcb->brk.sr.curCluster );
		if( addr == 0UL )				goto ERR_EXIT;	/* t@CĂ */

		addr += pFcb->brk.sr.pointInCluster;				/* NX^̐擪ǂݎʒu܂ňړ */
		err = RfbWrite( addr, pTake, writeLen, useOrg );	/* f[^ */
		if( err != RF_OK )				goto ERR_EXIT;

		/* ݐ|C^ނ */
		remain -= writeLen;								/* cf[^ */
		pTake += writeLen;								/* f[^̎oʒu */

		/* FCB XV */
		pFcb->brk.sr.curPoint += writeLen;				/* t@C擪̈ʒu */
		pFcb->brk.sr.totalLen += writeLen;				/* t@CŜ̃TCY */
		pFcb->brk.sr.pointInCluster += writeLen;		/* NX^̈ʒu */
	}

	err = RfmWriteKick( pFcb );							/* ZN^E͍XVς݂̃f[^ăobt@󂯂 */

ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*       t@CɃf[^㏑										*/
/* p[^																*/
/*        pFcb FFCB														*/
/*        pBuffFރf[^i[Ă̈							*/
/*        size FޒAI͏߂						*/
/* ߂l																	*/
/*        RF_OK FI													*/
/*        RF_ERR_...Fǂݍ݃G[										*/
/*   																	*/
/*        NX^̃f[^͘AIɏ߂邪NX^܂鎞	*/
/*       AhXvZďށB									*/
/*        f[^݂̑镔܂ł݂͂ȂȂB͈̔͂	*/
/*       wȂꍇA RF_ERR_EOF Ԃ邪t@C̏I[	*/
/*       ł͏݂ȂB											*/
/****************************************************************************/
unsigned short RfmWriteOver( T_RF_FCB * pFcb, char * pBuff, unsigned long * size )
{
	unsigned short err = RF_OK;
	unsigned long addr = 0;
	unsigned long remain = *size;
	unsigned long writeLen;								/* 񖈂ɏރTCY */
	unsigned short nextCluster;							/* ̃NX^ԍ	*/
	char *pTake = pBuff;								/* ݈ʒu */
	char overSize = FALSE;								/* t@CTCY𒴂vtO */

	/* vt@C̏I[𒴂ꍇ */
	if( ( pFcb->brk.sr.curPoint + *size ) > pFcb->brk.sr.totalLen )
	{
		remain = pFcb->brk.sr.totalLen - pFcb->brk.sr.curPoint;		/* I[܂ł݃TCYƂ */
		overSize = TRUE;
	}

	while( remain != 0UL )
	{
		if( rfDriveInfo.bytesPerCluster <= pFcb->brk.sr.pointInCluster )
		{
			/* NX^Ƀf[^cĂȂ */
			nextCluster = getNextCluster( pFcb->brk.sr.curCluster, &err );	/* ̃NX^擾 */
			if( err != RF_OK )			goto ERR_EXIT;	/* ǂݎ莸s			*/
			if( nextCluster == RF_F_CLUST_TERMINATE )
			{
				err = RF_ERR_BROKEN_FILE;				
				goto ERR_EXIT;							/* ǂݎ莸s			*/
			}
			pFcb->brk.sr.curCluster = nextCluster;		/* ̃NX^ʒuݒ		*/
			pFcb->brk.sr.pointInCluster = 0;			/* NX^̈ʒuXV			*/
		}

		/* NX^̓ǂݎ钷߂ */
		writeLen = remain;								/* cTCYׂēǂݎ */
		if( remain > ( rfDriveInfo.bytesPerCluster - pFcb->brk.sr.pointInCluster ) )
		{
			/* NX^̏I[𒴂鎞 */
			writeLen
				= rfDriveInfo.bytesPerCluster - pFcb->brk.sr.pointInCluster;	/* NX^̏I[܂ŏ */
		}

		/* NX^ԍAhX߂ */
		err = RF_ERR_BROKEN_FILE;				
		addr = clusterToAddr( pFcb->brk.sr.curCluster );
		if( addr == 0UL )				goto ERR_EXIT;	/* t@CĂ */

		addr += pFcb->brk.sr.pointInCluster;			/* NX^̐擪ǂݎʒu܂ňړ */
		err = RfbWrite( addr, pTake, writeLen, TRUE );	/* f[^ */
		if( err != RF_OK )				goto ERR_EXIT;

		/* |C^ލXV */
		remain -= writeLen;								/* cTCY珑񂾃TCY */
		pTake += writeLen;								/* oʒuXV			*/
		pFcb->brk.sr.curPoint += writeLen;				/* ݈ʒuXV			*/
		pFcb->brk.sr.pointInCluster += writeLen;		/* NX^̈ʒuXV		*/
	}

	if( overSize != FALSE )
	{
		err = RF_ERR_EOF;								/* I[𒴂Ă̂ EOF */
	}
	else
	{
		err = RfmReadKick( pFcb );						/* ǂł */
	}

ERR_EXIT:
	*size = (unsigned long)(pTake - pBuff);				/* ǂݍ݃oCg */
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*       NX^ԍAhXɕϊ									*/
/* p[^																*/
/*        clusterFNX^ԍ												*/
/* ߂l																	*/
/*        AhXA0 ͕ϊłȂ									*/
/*   																	*/
/*        NX^ԍ 2 n܂̂ňȉ̎ŋ߂邱ƂłB		*/
/*         (NX^ԍ - 2) ~ NX^TCY + f[^̈̐擪AhX	*/
/*        NX^TCÝA ZN^TCY~PNX^̃ZN^				*/
/****************************************************************************/
unsigned long clusterToAddr( unsigned short cluster )
{
	unsigned long addr = 0UL;

	if( ( cluster >= 2 ) &&
		( cluster < (rfDriveInfo.clusterNum + 2) )  )
	{
		addr = rfDriveInfo.bodyPoint +
				rfDriveInfo.bytesPerCluster *
				(unsigned long)(cluster - 2);
	}

	return addr;
}

/****************************************************************************/
/* T  v																	*/
/*       NX^wlŖ߂											*/
/* p[^																*/
/*        addr FNX^AhX											*/
/*        val  F߂l													*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... G[												*/
/*   																	*/
/*        PNX^̗̈w̒lŖ߂								*/
/*         FillCluster()̓obt@ڏ݂ȂBobt@	*/
/*         Ƃ̐ɖ̖ꍇgpłȂ̂Œӂ邱ƁB		*/
/****************************************************************************/
unsigned short fillCluster( unsigned long addr, char val  )
{
	unsigned short i;
	unsigned short err = RF_OK;

	if( rfDriverInterface.fill == NULL )
	{
		err = RF_ERR_DEFINE_DRIVER;
	}
	else
	{
		for(i = 0; i < (unsigned short)rfDriveInfo.sectorPerCluster; ++i )
		{
			err = drvFill( addr, val );						/* PZN^߂ */
			if( err != RF_OK )
			{
				break;
			}
			addr += (unsigned long)rfDriveInfo.bytesPerSector;	/* ̃ZN^AhX */
		}
	}

	return err;
}
/****************************************************************************/
/* T  v																	*/
/*        t@C̓ǂݏ̈ʒuύX								*/
/* p[^																*/
/*        pFcb  FI[vŎ擾FCB										*/
/*        offsetForigin̋											*/
/*        originFړ̊Jn_												*/
/*                RF_SEEK_SETFt@C̐擪								*/
/*                RF_SEEK_CURF݈ʒu										*/
/*                RF_SEEK_ENDFt@C̏I[								*/
/* ߂l																	*/
/*        RF_OK 														*/
/*        RF_ERR_... ̎̓G[											*/
/*   																	*/
/*        t@CTCYɐݒ肵ꍇAŏĨNX^̏ꍇ	*/
/*       t@CTCYgBŏINX^I[o[ʒuw肳	*/
/*       ꂽꍇ͐VK̃NX^mۂt@CTCYg傷BA	*/
/*       ̏ꍇe͏ȂB										*/
/*        TCYg傷ۂ seek ʒuNX^̋EƂȂꍇ write	*/
/*       ĂȂNX^͊mۂȂ悤ɂB							*/
/****************************************************************************/
unsigned short RfmSeek( T_RF_FCB * pFcb, long offset, unsigned short origin )
{
	long targetPoint = 0UL;								/* ړI̐Έʒu	*/
	unsigned long nowClustTopPoint;						/* ݈ʒuƂ̍	*/
	unsigned short cluster;								/* NX^ԍ			*/
	unsigned short nextCluster;							/* VɃNX^mۂƂ̐VNX^ */
	unsigned short clustNum;							/* ړNX^	*/
	unsigned short err = RF_ERR_SEEK_OPTION;			/* G[R[h			*/
	unsigned short i;									/* NX^		*/

	/* t@C擪̈ʒu߂ */
	if( origin == RF_SEEK_SET )
	{
		targetPoint = offset;
	}
	else if( origin == RF_SEEK_CUR )
	{
		targetPoint = (long)pFcb->brk.sr.curPoint + offset;
	}
	else if( origin == RF_SEEK_END )
	{
		targetPoint = (long)pFcb->brk.sr.totalLen + offset;
	}
	else						goto ERR_EXIT;			/* origin ̌		*/

	if( targetPoint < 0L )		goto ERR_EXIT;			/* t@C̐擪OɂȂG[ */

	if( pFcb->canWriteFlag == FALSE )
	{
		/* ݕs̏ꍇ̓t@C̍Ō𒴂Ȃ */
		if( targetPoint > (long)pFcb->brk.sr.totalLen )
		{
			err = RF_ERR_OUT_OF_LENGTH;
			goto ERR_EXIT;								/* Ō𒴂	*/
		}
	}

	err = RF_OK;										/* ftHg OK Ƃ	*/

	/* ړ悪݂̃NX^Ɠf */
	nowClustTopPoint = pFcb->brk.sr.curPoint - pFcb->brk.sr.pointInCluster;	/* ݂̃NX^̐擪ʒuvZ */
	if( nowClustTopPoint > (unsigned long)targetPoint )
	{
		/* ݂̃NX^OɖڕWꍇ */
		/* 擪T */
		cluster = pFcb->brk.sr.firstCluster;
		clustNum = (unsigned short)((unsigned long)targetPoint / rfDriveInfo.bytesPerCluster);
		pFcb->brk.sr.pointInCluster = (unsigned long)targetPoint % rfDriveInfo.bytesPerCluster;	/* NX^̈ʒuC */
	}
	else
	{
		/* ݂̃NX^납̃NX^̏ꍇ */
		/* ̈ʒuT */
		cluster = pFcb->brk.sr.curCluster;
		clustNum = (unsigned short)(((unsigned long)targetPoint - nowClustTopPoint) / rfDriveInfo.bytesPerCluster);
		if( ( clustNum != 0 ) && ((((unsigned long)targetPoint - nowClustTopPoint) % rfDriveInfo.bytesPerCluster) == 0L) )
		{
			/* NX^̋ڂwƂ͑ÕNX^̍ŌƂĂ */
			clustNum--;
			pFcb->brk.sr.pointInCluster = rfDriveInfo.bytesPerCluster;			/* NX^̈ʒuC */
		}
		else
		{
			pFcb->brk.sr.pointInCluster = (unsigned long)targetPoint % rfDriveInfo.bytesPerCluster;	/* NX^̈ʒuC */
		}
	}

	if( ( targetPoint != 0 ) && ( cluster == 0 ) )
	{
		if( pFcb->canWriteFlag == FALSE )
		{
			err = RF_ERR_BROKEN_FILE;
			goto ERR_EXIT;							/* FAT Ă */
		}

		/* VK쐬ł܂ write ĂȂƂ
		   ŐVȃNX^mۂ */
		cluster = findFreeClust( &err );		/* VȃNX^m	*/
		if( err != RF_OK )					goto ERR_EXIT;
		err = setFatVal( cluster, RF_F_CLUST_TERMINATE );	/* I[}[N */
		if( err != RF_OK )					goto ERR_EXIT;
		pFcb->brk.sr.firstCluster = cluster;		/* 񏑂ݎ͐擪̃NX^ԍݒ */
	}

	/* targetPoint ̃NX^ʒuT */
	for( i = 0; i < clustNum; ++i )
	{
		nextCluster = getFatVal( cluster, &err );		/* FAT ̓e擾 */
		if( err != RF_OK )					goto ERR_EXIT;
		if( nextCluster == RF_F_CLUST_TERMINATE )
		{
			if( pFcb->canWriteFlag == FALSE )
			{
				err = RF_ERR_BROKEN_FILE;
				goto ERR_EXIT;							/* FAT Ă */
			}
			/* FAT I[̏ꍇVȃNX^mۂĂȂ */
			nextCluster = findFreeClust( &err );		/* VȃNX^m	*/
			if( err != RF_OK )				goto ERR_EXIT;
			err = setFatVal( cluster, nextCluster );	/* ̃NX^ʒuݒ */
			if( err != RF_OK )				goto ERR_EXIT;
			err = setFatVal( nextCluster, RF_F_CLUST_TERMINATE );	/* I[}[N */
			if( err != RF_OK )				goto ERR_EXIT;
			cluster = nextCluster;
		}
		else if( nextCluster == 0 )
		{
			err = RF_ERR_BROKEN_FILE;
			goto ERR_EXIT;								/* FAT Ă */
		}
		else	cluster = nextCluster;					/* F̃NX^ݒ */
	}
	pFcb->brk.sr.curCluster = cluster;					/* NX^ʒuC */
	pFcb->brk.sr.curPoint = (unsigned long)targetPoint;	/* t@C擪̈ʒuC */
	if( pFcb->brk.sr.totalLen < (unsigned long)targetPoint )
	{
		pFcb->brk.sr.totalLen = (unsigned long)targetPoint;	/* Ŝ̃TCYςƂ */
	}

ERR_EXIT:
	return err;
}


/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* DIRECTORY ֘A															*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* T  v																	*/
/*        tpXfBNgNX^ʒuT						*/
/* p[^																*/
/*        dirPath FfBNg̃tpXA'\0'I[						*/
/*        err     FG[R[hi[̈								*/
/* ߂l																	*/
/*        fBNg̃NX^ԍ										*/
/*   																	*/
/*        ŉwfBNg̃NX^ԍ擾B						*/
/*        dirPath ̓fBNgŏIĂȂ΂ȂȂB			*/
/****************************************************************************/
unsigned short RfmGetDirClust( char * dirPath, unsigned short * err )
{
	unsigned short cluster = 0;				/* fBNg̃NX^ԍFŏ̓[g */
	unsigned short pathEnd;					/* pX̏I			*/

	/* path 擾	*/
	pathEnd = (unsigned short)rfStrLen( dirPath, RF_MAX_FILE_PATH);

	/* ŉw̃fBNg */
	cluster = findLastDir( dirPath, pathEnd, err );

	return cluster;
}

/****************************************************************************/
/* T  v																	*/
/*        t@Ci[ĂfBNg̃NX^ԍ擾		*/
/* p[^																*/
/*        filePathFt@C̃tpXA'\0'I[							*/
/*        err     FG[R[hi[̈								*/
/* ߂l																	*/
/*        0xffff ȊOFŉw̃fBNgNX^ԍ						*/
/*   																	*/
/*        filePath ̓t@C܂񂾃tpXB̃t@C	*/
/*       w̃fBNg̃NX^ԍ߂B							*/
/*        g[N̋؂肪擪̎ root fBNgȂ̂ŒTKv	*/
/*       B																*/
/*        TufBNg̐efBNĝɂgp̂ōŌ	*/
/*        '\' ŏIpXɂΉB									*/
/****************************************************************************/
unsigned short RfmGetParentDir( char * filePath, unsigned short * err )
{
	unsigned short cluster = 0;					/* fBNg̃NX^ԍFŏ̓[g */
	unsigned short pathEnd;						/* pX̏I			*/
	unsigned short bodyTop;						/* t@C̐擪		*/
	unsigned short pathLen;						/* t@CpXŜ̒	*/

	*err = RF_OK;
	pathEnd = 0;
	pathLen = (unsigned short)rfStrLen( filePath, LDIR_FLNAME_TOTAL);	/* Ŝ̒߂	*/
	if( pathLen == 0 )
	{
		*err = RF_ERR_ROOT_DIRECTORY;			/* root fBNgȂ̂Őe͂Ȃ */
		goto ERR_EXIT;
	}
	if( filePath[pathLen-1] == '\\' )
	{
		if( pathLen == 1 )
		{
			*err = RF_ERR_ROOT_DIRECTORY;		/* root fBNgȂ̂Őe͂Ȃ */
			goto ERR_EXIT;
		}
		--pathLen;								/* Ōオ'\'̂ƂȂO܂Ō */
	}
	bodyTop = takeLastToken( filePath,  pathLen );		/* t@C̈ʒu߂ */
	if( bodyTop == 0 )
	{
		/* 擪 '\' Ȃ */
		*err = RF_ERR_INVALID_NAME;
	}
	else if( bodyTop != 1 )
	{
		/* [gfBNgȊȌꍇ */
		pathEnd = bodyTop - 1;
		cluster = findLastDir( filePath, pathEnd, err );	/* ŉw̃fBNg */
	}
ERR_EXIT:
	return cluster;
}

/****************************************************************************/
/* T  v																	*/
/*        fBNgpXŉw̃fBNgT					*/
/* p[^																*/
/*        dirPathFfBNgpX											*/
/*        lim    F钷												*/
/*        err    FG[R[hi[̈								*/
/* ߂l																	*/
/*        0 ȊOFŉw̃TufBNg̃NX^ԍ					*/
/*        0F[gfBNg												*/
/*        0xffffFȂ												*/
/*   																	*/
/*        TufBNg܂ރt@CpXŏIIȃTufBNg	*/
/*       TB filePath ɂ͍ŏIIȃt@C͕tĂĂ͂ȂB	*/
/*       AdirPath ̒ lim ܂łȂ̂ł̌	*/
/*       t@CtĂ邱Ƃ͓ɖȂB						*/
/****************************************************************************/
unsigned short findLastDir( char * filePath, unsigned short lim, unsigned short * err )
{
	unsigned short startPos = 0;						/* filePath ̃g[N擪ʒu */
	unsigned short tokLen = 0;
	char takeBuff[2];
	unsigned short cluster = 0;							/* fBNg̃NX^ԍFŏ̓[g */
	unsigned long addr = 0UL;							/* Gg̃AhX	*/

	*err = RF_OK;

	if( filePath[0] == '\\')
	{
		++startPos;						/* 擪 \ 炷		*/
	}
	else
	{
		*err = RF_ERR_INVALID_NAME;		/* t@Cs */
	}

	while( ( startPos < lim ) && ( *err == RF_OK) )
	{
		/* g[N؂o */
		*err = RF_ERR_INVALID_NAME;						/* u\vĂ	*/
		tokLen = takeOneToken( &filePath[startPos], (unsigned short)(lim - startPos) );
		if( tokLen != 0 )
		{
			/* fBNg猟 */
			*err = RF_ERR_NOT_FOUND;
			addr = findFileByName( &filePath[startPos], cluster, err );
			if( ( addr != 0UL ) && ( *err == RF_OK ) )
			{
				/* Gg̃`FbN */
				*err = RfbRead( addr+DIR_ATTRIBUTE,
									takeBuff,
									1 );				/* o		*/
				if( *err == RF_OK ) 
				{
					*err = RF_ERR_INVALID_NAME;			/* fBNgłȂG[ */
					if( ( takeBuff[0] & DIR_ATTR_DIRECTORY ) == DIR_ATTR_DIRECTORY )
					{
						/* fBNg */
						*err = RfbRead( addr+DIR_CLUSTOR_NUM,
											takeBuff,
											DIR_CLUSTOR_NUM_LEN);	/* fBNg̃NX^ԍ擾	*/
						if( *err == RF_OK )
						{
							cluster = makeUShortData( takeBuff );	/* TufBNg̃NX^ԍ𐔒lɂ */
							startPos += tokLen + 1;			/* fBNg + \				*/
						}
					}
				}
			}
		}
	}

	if( *err != RF_OK )	cluster = 0xffff;				/* G[ NX^ԍNA		*/

	return cluster;
}

/****************************************************************************/
/* T  v																	*/
/*       fBNgt@C								*/
/* p[^																*/
/*        flName Fgq܂ރt@C									*/
/*        clusterFfBNg̃NX^ԍA0̓[gfBNg		*/
/*        err    FG[̃G[R[h								*/
/*                 RF_OKF												*/
/*                 RF_ERR...Fs											*/
/* ߂l																	*/
/*        fBNgGg̃AhX									*/
/*   																	*/
/*       PɂP̃fBNgw̃t@CTȂ̂ '\'ŘA	*/
/*       ꂽTufBNgt̃t@C͕Ă炱̊֐gp	*/
/*       邱ƁB															*/
/****************************************************************************/
unsigned long findFileByName( char * flName, unsigned short cluster, unsigned short * err )
{
	char findName[DIR_SHORT_FLNAME_TOTAL];				/* gqƃt@C{̂𕪊̈ */
	unsigned long addr = 0UL;

	*err = RF_ERR_NOT_FOUND;

	/* t@C̃`FbN */
	*err = checkShortName( flName, findName, NULL );
	if( *err == RF_OK )
	{
		/* V[gt@CŒT */
		addr = findShortName( findName, cluster, err );
		return addr;
	}

	return addr;
}

/****************************************************************************/
/* T  v																	*/
/*       fBNgV[gt@C						*/
/* p[^																*/
/*        entryNameFfBNgGg`̃t@C					*/
/*        clusterFfBNg̃NX^ԍA0 ̓[gfBNg		*/
/*        err    FANZXG[R[hi[̈						*/
/*                 RF_OKF										*/
/*                 RF_ERR_NOT_FOUNDFGgȂ					*/
/*                 RF_ERR_...F̑̃ANZXG[						*/
/* ߂l																	*/
/*        fBNgGg̃AhX									*/
/*        ȂƂ̓AhX 0 Ԃ								*/
/*   																	*/
/*        getNextValidEntry() ŗLȃGgTĂB				*/
/****************************************************************************/
unsigned long findShortName( char * entryName, unsigned short cluster, unsigned short * err )
{
	char inDirName[DIR_SHORT_FLNAME_TOTAL];				/* fBNgɂt@C		*/
	unsigned long addr = 0UL;							/* rfBNgGg̃AhX */
	T_RF_SEARCH_DIR		searchDirInfo;					/* fBNg	*/



	searchDirInfo.curCluster = cluster;			/* 擪̃NX^ԍ */
	searchDirInfo.pointInCluster = 0UL;			/* NX^̈ʒu			*/
	searchDirInfo.cond = RF_ENTRY_VALID;

	while( searchDirInfo.cond == RF_ENTRY_VALID )
	{
		*err = getNextValidEntry( &searchDirInfo );
		if( *err != RF_OK )						goto ERR_EXIT;
		if( ( searchDirInfo.attribute != DIR_ATTR_LONG_NAME ) &&			/* Ot@CGgł͂Ȃ */
			( searchDirInfo.cond == RF_ENTRY_VALID ) )
		{
			*err = RfbRead( searchDirInfo.entryAddr+DIR_NAME,
							inDirName,
							DIR_SHORT_FLNAME_TOTAL );				/* t@Cǂݍ		*/

			if( *err != RF_OK )					goto ERR_EXIT;		/* ANZXG[	*/

			/* V[gt@CŗLȃGg */
			if( rfMemCmp( inDirName, entryName, (unsigned long)DIR_SHORT_FLNAME_TOTAL ) == 0 )
			{
				/* TĂGg */
				addr = searchDirInfo.entryAddr;
				*err = RF_OK;
				break;
			}
		}
	}

	if( (searchDirInfo.cond == RF_ENTRY_NOT_FOUND) || (searchDirInfo.cond == RF_ENTRY_TERMINATE) )
	{
		/* gp̈܂ŒBꍇƍŌ܂ŒTȂꍇ́uȂvƂ */
		/* ̑́uvꍇƂȂ炩̃ANZXG[ƂB					*/
		/* ͍Ă err ̂܂ܕԂB										*/
		*err = RF_ERR_NOT_FOUND;
	}

	if( searchDirInfo.cond != RF_ENTRY_VALID )
	{
		addr = 0UL;							/* ȂƂ̓AhX 0 Ƃ	*/
	}

ERR_EXIT:
	return addr;
}

/****************************************************************************/
/* T  v																	*/
/*       V[gt@C̐`FbNgqƃt@C{̂	*/
/*       																*/
/* p[^																*/
/*        flNameFgq܂ރt@CBI[ '\0' ̂ƁB				*/
/*        findNameFgqƃt@C{̂𕪉(11oCgKv)		*/
/*        charTypeF^iʒuj									*/
/* ߂l																	*/
/*        RF_OKFt@C												*/
/*        RF_ERR_INVALID_NAMEFt@Cs								*/
/*   																	*/
/*        Xy[X̃t@C͖B									*/
/*        gqꍇ 8 oCgȓBgqꍇ̃t@C{ 	*/
/*       ̂ 8 oCgȓBgq 3 oCgȓB							*/
/*        ̊֐͂P̃t@C`FbN̂Ȃ̂'\'ŋ؂	*/
/*       TufBNg܂ނ͕̂ĂƁB					*/
/*        t@C{̂ 8 oCgȓ̎͌Xy[XŖߊgq	*/
/*       ɕt 11 oCg̔zɂB܂Ap͑啶ɕϊ	*/
/*       B																*/
/*        )																*/
/*         abc.txt  "ABC     TXT"											*/
/*                     12345678901											*/
/****************************************************************************/
unsigned short checkShortName( char * flName, char * findName, char * charType )
{
	unsigned short i;
	unsigned short ret = RF_ERR_INVALID_NAME;
	unsigned short dotPoint;
	unsigned short tailLen = 0;
	enum e_char_mix charMix;

	/* ʂȖ̂`FbN */
	if( checkException( flName, findName ) != FALSE )
	{
		ret = RF_OK;
		goto ERR_EXIT;									/* G[ł͂ȂI */
	}

	/* t@C{ */
	/* sK؂Ȃ̂̓G[Ƃ		*/
	/* sK؂Ȉʒu܂ŒT̂ + 2 	*/
	dotPoint = findChar( flName, '.', DIR_SHORT_FLNAME_BODY+2 );	/* t@C{ */
	if( dotPoint == 0 )					goto ERR_EXIT;	/* 擪 '.' ̂̓G[ */
	if( dotPoint > DIR_SHORT_FLNAME_BODY )
	{
		/* '.' ȂƂ */
		dotPoint = DIR_SHORT_FLNAME_BODY+2;				/* ͈		*/
		takeToken( 0, flName, &dotPoint );				/* ؂܂łׂ̂Ăo */
		if( dotPoint > DIR_SHORT_FLNAME_BODY )	goto ERR_EXIT;
	}
	if( isValidShortChar( flName, dotPoint) == FALSE )
	{
		goto ERR_EXIT;									/* V[g֑̋`FbN */
	}
	rfMemCpy( findName, flName, (unsigned long)dotPoint );			/* t@C{copy */
	if( ( DIR_SHORT_FLNAME_BODY - dotPoint ) != 0 )
	{
		rfMemSet( &findName[dotPoint],
				  (int)' ',
				  (unsigned long)(DIR_SHORT_FLNAME_BODY - dotPoint) );	/* c space Ŗ߂ */
	}

	/* gq */
	tailLen = 0;
	if( flName[dotPoint] == '.' )
	{
		/* '.' ꍇ */
		tailLen = DIR_SHORT_FLNAME_EXT;
		takeToken( 0, &flName[dotPoint+1], &tailLen );	/* ؂܂łׂ̂Ăo */
		if( tailLen > DIR_SHORT_FLNAME_EXT )	goto ERR_EXIT;
		if( isValidShortChar( &flName[dotPoint+1], tailLen) == FALSE )
		{
			goto ERR_EXIT;								/* V[g֑̋`FbN */
		}
		rfMemCpy( &findName[DIR_SHORT_FLNAME_BODY],
				  &flName[dotPoint+1],
				  (unsigned long)tailLen );				/* gqcopy */
		
	}
	if( ( DIR_SHORT_FLNAME_EXT - tailLen ) != 0 )
	{
		rfMemSet( &findName[DIR_SHORT_FLNAME_BODY+tailLen],
				(int)' ',
				(unsigned long)(DIR_SHORT_FLNAME_EXT - tailLen) );		/* c space Ŗ߂ */
	}


	if( charType != NULL )
	{
		*charType = 0;
		charMix = checkCharMix( &findName[0], DIR_SHORT_FLNAME_BODY );
		if( charMix == E_CHAR_MIX )			goto ERR_EXIT;		/* 啶A݂̓G[ */
		if( charMix == E_CHAR_SMALL )
		{
			*charType |= DIR_NAME_TITLE_SMALL;
		}
		charMix = checkCharMix( &findName[DIR_SHORT_FLNAME_BODY], DIR_SHORT_FLNAME_EXT );
		if( charMix == E_CHAR_MIX )			goto ERR_EXIT;		/* 啶A݂̓G[ */
		if( charMix == E_CHAR_SMALL )
		{
			*charType |= DIR_NAME_EXTENT_SMALL;
		}
	}

	/* 啶ɕϊ */
	for( i = 0; i < DIR_SHORT_FLNAME_TOTAL; ++i )
	{
		findName[i] = (char)rfToUpper( (int)findName[i] );
	}
	
	/* ׂăXy[X̃`FbN */
	for( i = 0; i < DIR_SHORT_FLNAME_TOTAL; ++i )
	{
		if( findName[i] != ' ')
		{
			break;
		}
	}
	/* ׂăXy[XG[ */
	if( i >= DIR_SHORT_FLNAME_TOTAL )		goto ERR_EXIT;
	
	ret = RF_OK;

ERR_EXIT:

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*       "."A".."fBNg`FbN							*/
/* p[^																*/
/*        flNameFgq܂ރt@CBI[ '\0' ̂ƁB				*/
/*        findNameFgqƃt@C{̂𕪉(11oCgKv)		*/
/* ߂l																	*/
/*        TRUE Fʂȃt@C											*/
/*        FALSEFʂȃt@Cł͂Ȃ									*/
/*   																	*/
/*        "."A".."`FbNBȊOׂ͂ FALSE ԂB		*/
/****************************************************************************/
unsigned short checkException( char * flName, char * findName )
{
	unsigned short result = FALSE;

	rfMemSet(findName, 0x20, DIR_SHORT_FLNAME_TOTAL);	/* ̈NA */
	if( ((flName[0] == '.') && (flName[1] == '\\' )) ||
	    ((flName[0] == '.') && (flName[1] == '\0' )) )
	{
		findName[0] = '.';								/* wfBNg */
		result = TRUE;
	}

	if( ((flName[0] == '.') && (flName[1] == '.' ) && (flName[2] == '\\')) ||
	    ((flName[0] == '.') && (flName[1] == '.' ) && (flName[2] == '\0')) )
	{
		findName[0] = '.';								/* 1̃fBNg */
		findName[1] = '.';
		result = TRUE;
	}

	return result;
}

/****************************************************************************/
/* T  v																	*/
/*        w肳ꂽfBNgɐVK̃t@CGg쐬			*/
/* p[^																*/
/*        clusterFfBNg̃NX^ԍ								*/
/*        flName Ft@C̃pX								*/
/*        pFcb   FFCB 														*/
/* ߂l																	*/
/*        RF_OKF														*/
/*   																	*/
/*        VK̃Gg쐬B										*/
/*        Gg쐬ꍇ FCB ɃGgAhXi[B	*/
/****************************************************************************/
unsigned short RfmCreateFileEntry( unsigned short cluster, char * flPath, T_RF_FCB * pFcb )
{
	unsigned short err;									/* G[R[h		*/
	unsigned long entryAddr = 0UL;						/* AhX		*/
	unsigned short bodyTop;

	/* fBNg̋󂫃GgT */
	entryAddr = findFreeEntry( cluster, &err );
	if( entryAddr != 0UL )
	{
		bodyTop = takeLastToken( flPath,  LDIR_FLNAME_TOTAL );	/* t@C̈ʒu߂ */
		err = makeEntry( entryAddr, &flPath[bodyTop], 0, 0 );	/* t@CGg쐬 */
		if( err == RF_OK )
		{
			pFcb->brk.sr.entryAddr = entryAddr;					/* GgAhXi[		*/
		}
	}
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        w肳ꂽfBNgɐVK̃fBNgGg쐬		*/
/* p[^																*/
/*        clusterFfBNg̃NX^ԍ								*/
/*        flName Ft@C̃pX								*/
/*        pFcb   FFCB 														*/
/* ߂l																	*/
/*        RF_OKF														*/
/*   																	*/
/*        VK̃Gg쐬B										*/
/****************************************************************************/
unsigned short RfmCreateDirEntry( unsigned short cluster, char * flPath )
{
	unsigned short err;								/* G[R[h		*/
	unsigned long entryAddr = 0UL;					/* VȃfBNgGg̃AhX		*/
	unsigned long subAddr = 0UL;					/* VɍfBNg̃AhX		*/
	unsigned short bodyTop;
	unsigned short subCluster = 0;					/* VfBNg̃NX^ԍ	*/

	/* fBNg̈mۂ */
	subCluster = findFreeClust( &err );				/* VȃNX^m	*/
	if( subCluster == 0 )				goto ERR_EXIT;
	err = setFatVal( subCluster, RF_F_CLUST_TERMINATE );	/* I[}[N */
	if( err != RF_OK )					goto ERR_EXIT;
	subAddr = clusterToAddr( subCluster );				/* NX^ԍAhXɕϊ */
	err = fillCluster( subAddr, 0x00  );				/* 1 NX^ 0 ŃNA */
	if( err != RF_OK )					goto ERR_EXIT;

	/* w肳ꂽGg쐬 */
	entryAddr = findFreeEntry( cluster, &err );
	if( entryAddr == 0 )				goto ERR_EXIT;
	bodyTop = takeLastToken( flPath,  LDIR_FLNAME_TOTAL );	/* t@C̈ʒu߂ */
	err = makeEntry( entryAddr, &flPath[bodyTop], DIR_ATTR_DIRECTORY, subCluster );/* fBNgGg쐬 */
	if( err != RF_OK )					goto ERR_EXIT;

	/* "."A".."fBNgGg쐬 */
	err = makeEntry( subAddr, ".", DIR_ATTR_DIRECTORY, subCluster );/* gwfBNgGg쐬 */
	if( err != RF_OK )					goto ERR_EXIT;
	subAddr = findFreeEntry( subCluster, &err );	/* 󂫃GgT */
	if( err != RF_OK )					goto ERR_EXIT;
	err = makeEntry( subAddr, "..", DIR_ATTR_DIRECTORY, cluster );/* ewfBNgGg쐬 */
	if( err != RF_OK )					goto ERR_EXIT;
ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        w肳ꂽfBNg̃GgT							*/
/* p[^																*/
/*        cluster FfBNg̃NX^ԍ								*/
/*        filePathFt@C̃tpX									*/
/*        pErr    FG[R[hi[̈								*/
/*                 RF_OK F										*/
/* ߂l																	*/
/*        Gg̃AhX												*/
/*   																	*/
/*         w肳ꂽfBNg̒Ɏw肳ꂽGg邩T		*/
/****************************************************************************/
unsigned long RfmFindFileEntry( unsigned short cluster, char * filePath, unsigned short * pErr )
{
	unsigned long addr = 0UL;							/* Gg̃AhX	*/
	unsigned short bodyTop;								/* t@C̐擪		*/

	bodyTop = takeLastToken( filePath,  LDIR_FLNAME_TOTAL );	/* t@C̈ʒu߂ */

	/* w̃fBNg猟 */
	addr = findFileByName( &filePath[bodyTop], cluster, pErr );
	return addr;
}

/****************************************************************************/
/* T  v																	*/
/*        w肳ꂽfBNg̗LȃGgԂɒT				*/
/* p[^																*/
/*        pSearchDirFfBNg									*/
/* ߂l																	*/
/*          RF_OK F												*/
/*          RF_ERR... FG[												*/
/*   																	*/
/*         ʂ pSearchDir->cond Ɋi[B						*/
/****************************************************************************/
unsigned short getNextValidEntry( T_RF_SEARCH_DIR * pSearchDir )
{
	unsigned short err = RF_OK;

	pSearchDir->cond = RF_ENTRY_FREE;
	while( pSearchDir->cond == RF_ENTRY_FREE )
	{
		/* gpGgȊO܂ŌJԂ */
		err = getNextEntry( pSearchDir );
	}

	if( pSearchDir->cond != RF_ENTRY_VALID )
	{
		pSearchDir->entryAddr = 0UL;	/* ȂƂ̓AhX 0 Ƃ	*/
	}

	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        w肳ꂽfBNg̃GgԂɒT					*/
/* p[^																*/
/*        pSearchDirFfBNg									*/
/* ߂l																	*/
/*        RF_ENTRY_VALID     FLȃGg					*/
/*        RF_ENTRY_FREE      FgpGg					*/
/*        RF_ENTRY_NOT_FOUND FŌ܂ŒTȂ					*/
/*        RF_ENTRY_TERMINATE FGg̏I[ɒB						*/
/*        RF_ENTRY_ERR_ACCESSFǂݍ݃G[						*/
/*   																	*/
/*         w肳ꂽfBNg̃GgԂɎ擾B				*/
/*         pointInCluster TĂB									*/
/*        G[R[h pSearchDir->err Ɋi[B						*/
/*          RF_OK F												*/
/*          RF_ERR... FG[												*/
/****************************************************************************/
unsigned short getNextEntry( T_RF_SEARCH_DIR * pSearchDir )
{
	unsigned short err = RF_OK;

	if( pSearchDir->curCluster == 0 )
	{
		/* [gfBNg̎ */
		err = getNextEntryNarrow( pSearchDir );	/* LȃGgT */
	}
	else
	{
		/* TufBNg̎ */
		/* NX^ƂɌ */
		while( pSearchDir->curCluster != RF_F_CLUST_TERMINATE )
		{
			/* NX^ƂɌ */
			err = getNextEntryNarrow( pSearchDir );	/* LȃGgT */
			if( err != RF_OK )							break;
			if( pSearchDir->cond != RF_ENTRY_NOT_FOUND )	break;	/* pKvȂ */
			pSearchDir->curCluster =
						getNextCluster( pSearchDir->curCluster,
										&err );			/* ̃NX^ԍ擾 */
			pSearchDir->pointInCluster = 0UL;				/* NX^̈ʒu			*/
			if( err != RF_OK )							break;	/* ANZXG[		*/
		}
	}

	return err;
}

/****************************************************************************/
/* T  v																	*/
/*       NX^̃fBNgGgԂɓǂ						*/
/* p[^																*/
/*        pSearchDirFfBNg									*/
/* ߂l																	*/
/*        RF_ENTRY_VALID     FLȃGg					*/
/*        RF_ENTRY_FREE      FgpGg					*/
/*        RF_ENTRY_NOT_FOUND FŌ܂ŒTȂ					*/
/*        RF_ENTRY_TERMINATE FGg̏I[ɒB						*/
/*        RF_ENTRY_ERR_ACCESSFǂݍ݃G[						*/
/*   																	*/
/*        fBNgGg curClust  pointInCluster ʒu	*/
/*       ߃Gg̃AhX߂BOt@CGgȊÔ	*/
/*       Ă𔭌Ƃ̈ʒuĊ֐𔲂B						*/
/****************************************************************************/
unsigned short getNextEntryNarrow( T_RF_SEARCH_DIR * pSearchDir )
{
	unsigned short err = RF_OK;						/* G[R[h			*/
	unsigned long entryAddr = 0UL;
	unsigned long dirAddr;						/* NX^̐擪AhX	*/
	unsigned long searchLimit;					/* ͈ */
	char buffNameTop;						/* fBNgGg̃t@C擪oCg */

	if( pSearchDir->curCluster == 0 )
	{
		/* [gfBNg̏ꍇ */
		dirAddr = rfDriveInfo.rootPoint;
		searchLimit = (unsigned long)rfDriveInfo.rootEntryNum * (unsigned long)DIR_RECORD_SIZE;
	}
	else
	{
		/* TufBNg̏ꍇ */
		dirAddr = clusterToAddr( pSearchDir->curCluster );	/* NX^̐擪AhX߂ */
		searchLimit = rfDriveInfo.bytesPerCluster;
	}

	pSearchDir->cond = RF_ENTRY_NOT_FOUND;
	for( ; pSearchDir->pointInCluster < searchLimit; pSearchDir->pointInCluster += (unsigned long)DIR_RECORD_SIZE )
	{
		/* Ot@C̃GgԂ͌JԂ */
		entryAddr = pSearchDir->pointInCluster + dirAddr;
		err = RfbRead( entryAddr+DIR_NAME,
								&buffNameTop,
								1 );					/* t@C̐擪ǂݍ		*/
		if( err != RF_OK )
		{
			pSearchDir->cond = RF_ENTRY_ERR_ACCESS;		/* ANZXG[	*/
			break;
		}
		if(	buffNameTop == DIR_NAME_UNUSED_ENTRY )		/* gp̃Gg			*/
		{
			/* gpGg܂ŒB̂łTKvȂ */
			pSearchDir->cond = RF_ENTRY_TERMINATE;
			break;
		}
		if( buffNameTop == DIR_NAME_FREE_ENTRY1 )		/* 폜ꂽGg		*/
		{
			/* 폜ꂽGg */
			pSearchDir->cond = RF_ENTRY_FREE;			/* gpGg */
			pSearchDir->flNameTop = buffNameTop;		/* t@C̐擪i[		*/
			break;
		}
		err = RfbRead( entryAddr+DIR_ATTRIBUTE,
							(char*)&pSearchDir->attribute,
							1 );						/* Agr[gǂݍ		*/
		if( err != RF_OK )
		{
			pSearchDir->cond = RF_ENTRY_ERR_ACCESS;	/* ANZXG[	*/
			break;
		}
		if( pSearchDir->attribute != DIR_ATTR_LONG_NAME )	/* Ot@CGg͔ */
		{
			/* LȃGg */
			pSearchDir->cond = RF_ENTRY_VALID;			/* LȃGg */
			pSearchDir->flNameTop = buffNameTop;		/* t@C̐擪i[		*/
			break;
		}
	}

	pSearchDir->entryAddr = entryAddr;					/* ʒuA܂͎̈ʒuݒ */
	pSearchDir->pointInCluster += (unsigned long)DIR_RECORD_SIZE; /* ̈ʒuݒ */
	return err;
}


/****************************************************************************/
/* T  v																	*/
/*       fBNg̋󂫃GgT									*/
/* p[^																*/
/*        cluster FfBNg̃NX^ԍ								*/
/*                  [g̏ꍇ 0										*/
/*        err     FANZXG[̃G[R[hi[̈				*/
/*                  RF_OK 												*/
/*                  RF_ERR_... G[									*/
/* ߂l																	*/
/*        fBNgGg̃AhX									*/
/*        G[ 0B												*/
/*   																	*/
/*        󂫃fBNgGgTB									*/
/*        TufBNgŋ󂫂Ȃꍇ͐VȃNX^mۂ	*/
/*       ̈𑝂₷B̍ۂ͐VɊmۂ̈̃AhXVG	*/
/*       gƂȂB														*/
/****************************************************************************/
unsigned long findFreeEntry( unsigned short cluster, unsigned short * err )
{
	unsigned long addr = 0UL;					/* rfBNgGg̃AhX */
	T_RF_SEARCH_DIR	searchDirInfo;				/* fBNg	*/
	unsigned short lastCluster = 0;				/* NX^ԍ					*/
	unsigned short newCluster = 0;				/* VNX^ԍ				*/
	unsigned short rootFlag = FALSE;

	searchDirInfo.curCluster = cluster;			/* 擪̃NX^ԍ */
	searchDirInfo.pointInCluster = 0UL;			/* NX^̈ʒu	*/
	searchDirInfo.cond = RF_ENTRY_VALID;			/* 			*/

	if( cluster == 0 )
	{
		rootFlag = TRUE;
	}

	while( searchDirInfo.cond == RF_ENTRY_VALID )
	{
		/* LȃGgȊOT */
		lastCluster = searchDirInfo.curCluster;
		*err = getNextEntry( &searchDirInfo );
		if( *err != RF_OK )					goto ERR_EXIT;
	}

	if( searchDirInfo.cond == RF_ENTRY_NOT_FOUND )
	{
		if( rootFlag != FALSE )
		{
			/* [gfBNg̏ꍇ̓G[ */
			*err = RF_ERR_NO_ROOT_SPACE;			/* [gɋ󂫂	*/
			addr = 0UL;
		}
		else
		{
			/* TufBNg̏ꍇ */
			/* 󂫂̂ŐVɃNX^ǉ */
			newCluster = findFreeClust( err );				/* VȃNX^m	*/
			if( *err != RF_OK )				goto ERR_EXIT;	/* mۂłȂ */
			*err = setFatVal( lastCluster, newCluster );	/* ̃NX^Ɏ̃NX^ԍ */
			if( *err != RF_OK )				goto ERR_EXIT;
			*err = setFatVal( newCluster, RF_F_CLUST_TERMINATE );	/* I[}[N */
			if( *err != RF_OK )				goto ERR_EXIT;
			addr = clusterToAddr( newCluster );				/* NX^ԍAhXɕϊ */
			*err = fillCluster( addr, 0x00  );				/* 1 NX^ 0 ŃNA */
		}
	}
	else if( ( searchDirInfo.cond == RF_ENTRY_FREE ) ||
			 ( searchDirInfo.cond == RF_ENTRY_TERMINATE ) )
	{
		/* 󂫂ƏI[ɒBꍇ */
		addr = searchDirInfo.entryAddr;
	}

ERR_EXIT:
	return addr;
}

/****************************************************************************/
/* T  v																	*/
/*       t@C폜													*/
/* p[^																*/
/*        pDelFileInfoFt@C폜\								*/
/*                      eɂ͈ȉ܂܂								*/
/*                       EentryAddr			̃GgAhX	*/
/*                       EfileClust			t@CNX^ԍ		*/
/*                       EpFcb;				gpĂ FCB			*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*         ݂fBNgGg폜Bt@C̐擪ɍ폜	*/
/*        }[NB													*/
/*         FAT`FC폜B											*/
/****************************************************************************/
unsigned short RfmDelFile( T_RF_DEL_FILE * pDelFileInfo )
{
	unsigned short err = RF_OK;

	err = RfmDelFatChain( pDelFileInfo->firstCluster );			/* FAT `FC */
	if( err == RF_OK )
	{
		err = RfmDelEntry(	pDelFileInfo->entryAddr );	/* Ggɍ폜}[N */
	}
	
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*       fBNg폜												*/
/* p[^																*/
/*        pDelDirInfoFfBNg폜\							*/
/*                      eɂ͈ȉ܂܂								*/
/*                       EentryAddr			̃GgAhX	*/
/*                       EfileClust			t@CNX^ԍ		*/
/*                       EpFcb;				gpĂ FCB			*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*         fBNgGg폜BfBNgɗLȃt@C	*/
/*        ݂ꍇ͂폜BTufBNg蓯lɃt@	*/
/*        Cꍇ폜B										*/
/****************************************************************************/
unsigned short RfmDelDir( T_RF_FCB * pFcb )
{
	T_RF_DEL_DIR		orgInfo;
	T_RF_SEARCH_DIR		searchDirInfo;
	unsigned short 		result = RF_OK;

	/* ̏ۑĂ */
	orgInfo.entryAddr = pFcb->brk.dd.entryAddr;
	orgInfo.firstCluster = pFcb->brk.dd.firstCluster;
	orgInfo.nest = pFcb->brk.dd.nest;

	/* fBNg */
	searchDirInfo.curCluster = pFcb->brk.dd.firstCluster;/* 擪̃NX^ԍ */
	searchDirInfo.pointInCluster = 0UL;						/* NX^̈ʒu	*/
	searchDirInfo.cond = RF_ENTRY_VALID;					/* 			*/
	
	/* Lȃt@CcĂꍇ͏ */
	result = getNextValidEntry( &searchDirInfo );
	while( searchDirInfo.cond == RF_ENTRY_VALID )
	{
		if( result != RF_OK )					goto ERR_EXIT;
		if( ( searchDirInfo.flNameTop != DIR_NAME_EXCEPTION ) &&	/* ȖOi폜ȂĂǂj */
			( searchDirInfo.attribute != DIR_ATTR_LONG_NAME ) )			/* Ot@CGgj */
		{
			/* Lȃt@C݂ */
			/* fBNgGg FCB  */
			result = RfmTakeExistInfo( pFcb, searchDirInfo.entryAddr );
			if( result != RF_OK )					goto ERR_EXIT;

			if( ( searchDirInfo.attribute & DIR_ATTR_DIRECTORY) == DIR_ATTR_DIRECTORY )
			{
				/* fBNĝƂ */
				pFcb->brk.dd.nest = orgInfo.nest + 1;
				if( pFcb->brk.dd.nest > rfNestDelDir )
				{
					result = RF_ERR_DEL_DIR_NEST;	/* lXgI[o[Ă */
					goto ERR_EXIT;
				}
				pFcb->brk.dd.entryAddr = searchDirInfo.entryAddr;
				result = RfmDelDir( pFcb );			/* fBNg폜AċAIɌĂяo */
				if( result != RF_OK )				goto ERR_EXIT;
			}
			else
			{
				/* t@ĈƂ */
				pFcb->brk.df.entryAddr = searchDirInfo.entryAddr;
				result = RfmDelFile( &pFcb->brk.df );		/* t@C폜 */
				if( result != RF_OK )				goto ERR_EXIT;
			}
		}
		result = getNextValidEntry( &searchDirInfo );
	}

	/* g */
	pFcb->brk.df.entryAddr = orgInfo.entryAddr;
	pFcb->brk.df.firstCluster = orgInfo.firstCluster;
	result = RfmDelFile( &pFcb->brk.df );					/* t@C폜 */

ERR_EXIT:
	return result;
}

/****************************************************************************/
/* T  v																	*/
/*       fBNgGg̈ړɈړ悪ړ̔zɂȂƂ		*/
/*       `FbN														*/
/* p[^																*/
/*        pMoveInfoFړ\											*/
/*                      eɂ͈ȉ܂܂								*/
/*                       EorgEntryAddr		̃t@CGgAhX	*/
/*                       EorgCluster		f[^̃NX^ԍ			*/
/*                       EorgAttr			(dir?)						*/
/*                       EtoCluster		ړfBNg̃NX^ԍ*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*         ړ".."ǂĂrňړ̃fBNgȂƂ	*/
/*        mFB														*/
/****************************************************************************/
unsigned short RfmCheckRoots( T_RF_MOVE_INFO * pMoveInfo )
{
	unsigned short err = RF_OK;
	unsigned short cluster = 0;
	unsigned long entryAddr = 0L;
	char strCluster[2];

	cluster = pMoveInfo->toCluster;

	while( cluster != 0 )
	{
		if( cluster == pMoveInfo->orgCluster )
		{
			err = RF_ERR_MOVE_POSTERITY;
			break;
		}

		entryAddr = findFileByName( "..",
									cluster,
									&err );				/* ".." T */
		err = RfbRead( entryAddr+DIR_CLUSTOR_NUM,
									strCluster,
									2 );				/* ".."̃NX^ԍ擾	*/
		if( err != RF_OK )
		{
			break;
		}
		cluster = makeUShortData( strCluster );			/* 2 oCg				*/
	}

	return err;
}

/****************************************************************************/
/* T  v																	*/
/*       fBNgGgړ										*/
/* p[^																*/
/*        pMoveInfoFړ\											*/
/*                      eɂ͈ȉ܂܂								*/
/*                       EorgEntryAddr		̃t@CGgAhX	*/
/*                       EorgCluster		f[^̃NX^ԍ			*/
/*                       EorgAttr			(dir?)						*/
/*                       EtoCluster		ړfBNg̃NX^ԍ*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*         t@CړBt@CfBNĝƂ ".." Gg	*/
/*        ̐efBNgNX^ʒuύXB						*/
/*         obt@悭gp邽ߌ̃Ggɑ΂ANZX		*/
/*        擪ɏW߁AɐVGgɑ΂ĂȂBfBNgG		*/
/*        g̏ꍇ͐efBNg̈ʒuXVB						*/
/****************************************************************************/
unsigned short RfmMoveEntry( T_RF_MOVE_INFO * pMoveInfo )
{
	unsigned short err = RF_OK;					/* G[R[h			*/
	unsigned long entryAddr;					/* VȃGgAhX	*/
	char saveCluster[2];				/* NX^ԍi[` */
	char dirWork[DIR_RECORD_SIZE];		/* fBNgGgꎞIɕۑ */

	/* ̃Ggɑ΂ANZX */
	err = RfbRead( pMoveInfo->orgEntryAddr,
								dirWork,
								DIR_RECORD_SIZE );		/* ̃Ggo	*/
	if( err != RF_OK )					goto ERR_EXIT;

	err = RfmDelEntry( pMoveInfo->orgEntryAddr );		/* ̃Ggɍ폜}[N */
	if( err != RF_OK )					goto ERR_EXIT;

	/* VGgɑ΂ANZX */
	entryAddr = findFreeEntry(	pMoveInfo->toCluster, 
								&err );					/* ړ̋󂫂T	*/
	if( err != RF_OK )					goto ERR_EXIT;

	err = RfbWrite( entryAddr,
								dirWork,
								DIR_RECORD_SIZE,
								TRUE );					/* Rs[ɐVGg쐬	*/
	if( err != RF_OK )					goto ERR_EXIT;

	if( ( pMoveInfo->orgAttr & DIR_ATTR_DIRECTORY) == DIR_ATTR_DIRECTORY )
	{
		/* fBNĝƂ */
		entryAddr = findFileByName( "..",
								pMoveInfo->orgCluster,
								&err );					/* ".." T */
		if( err != RF_OK )				goto ERR_EXIT;
		brokenUShortData( pMoveInfo->toCluster, saveCluster);
		err = RfbWrite( entryAddr+DIR_CLUSTOR_NUM,
									saveCluster,
									2,
									TRUE );				/* VȐeNX^ԍݒ	*/
		if( err != RF_OK )				goto ERR_EXIT;
	}

ERR_EXIT:
	return err;
}
/****************************************************************************/
/* T  v																	*/
/*       ݂fBNgGg폜								*/
/* p[^																*/
/*        addr  F폜Gg̃AhX								*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*         ݂fBNgGg폜Bt@C̐擪ɍ폜	*/
/*        }[NB													*/
/****************************************************************************/
unsigned short RfmDelEntry( unsigned long addr )
{
	unsigned short err;
	char delMark = DIR_NAME_FREE_ENTRY1;

	/* t@C擪ɍ폜}[N */
	err = RfbWrite( addr+DIR_NAME,
						&delMark,
						1,
						TRUE );						/* 폜}[Ni[	*/
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*       Vȃt@CGg										*/
/* p[^																*/
/*        addr  FGgAhX									*/
/*        fileNmFpXt@C									*/
/*        attr  F														*/
/*        cluster:f[^JnNX^ԍ									*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*        VK̃fBNgGg쐬B							*/
/*        AhX̏Ԃɏނ悤ɋCtBAhXɏ		*/
/*       ܂Ȃƍēǂݍ݂̂Œӂ邱ƁI						*/
/****************************************************************************/
unsigned short makeEntry( unsigned long addr, char * fileNm, unsigned char attr, unsigned short cluster )
{
	unsigned short err;

	char sepName[DIR_SHORT_FLNAME_TOTAL];		/* t@C */
	char nameChar = 0;							/* t@C̕ */

	T_RF_TIME nowTime;							/* ݎ */
	char dirTime[5];							/* i[` */

	char saveCluster[2];						/* NX^ԍi[` */

	/* t@CAȂ */
	err = checkShortName( fileNm, sepName, &nameChar );	/* t@C`FbN */
	if( err != RF_OK )					goto ERR_EXIT;
	err = RfbWrite( addr+DIR_NAME,
						sepName,
						DIR_SHORT_FLNAME_TOTAL,
						TRUE );							/* t@Ci[	*/
	if( err != RF_OK )					goto ERR_EXIT;
	err = RfbWrite( addr+DIR_ATTRIBUTE,
						(char*)&attr,
						1,
						TRUE );							/* t@C	*/
	if( err != RF_OK )					goto ERR_EXIT;
	err = RfbWrite( addr+DIR_NAME_CHAR,
						&nameChar,
						1,
						TRUE );							/* t@Cݒ	*/
	if( err != RF_OK )					goto ERR_EXIT;


	/* ֘A */
	if( rfSystemFunction.pGetNowTime != NULL )
	{
		if( (*rfSystemFunction.pGetNowTime)( &nowTime ) != RF_OK )	/* ݎ擾	*/
		{
			err = RF_ERR_GET_TIME;
			goto ERR_EXIT;
		}
	}
	else
	{
		nowTime.year = 1981;
		nowTime.month = 1;
		nowTime.day = 1;
		nowTime.hour = 0;
		nowTime.min = 0;
		nowTime.sec = 0;
		nowTime.mSec = 0;
	}
	toDirTime( dirTime, &nowTime );						/* fBNgi[`ɕϊ */
	err = RfbWrite( addr+DIR_CRT_TIME_TENTH,
						dirTime,
						5,
						TRUE );							/* 쐬	*/
	if( err != RF_OK )					goto ERR_EXIT;
	err = RfbWrite( addr+DIR_ACCESS_DATE,
						&dirTime[3],
						4,
						TRUE );							/* ŏIANZXt	*/
	if( err != RF_OK )					goto ERR_EXIT;
	err = RfbWrite( addr+DIR_CLUSTOR_HI_NUM,
						"\0\0\0\0",
						2,
						TRUE );							/* ʐ擪NX^ԍigpj	*/
	if( err != RF_OK )					goto ERR_EXIT;
	err = RfbWrite( addr+DIR_UPDATE_TIME,
						&dirTime[1],
						4,
						TRUE );							/* ŏIXV	*/
	if( err != RF_OK )					goto ERR_EXIT;

	/* NX^ԍAt@CTCY */
	brokenUShortData( cluster, saveCluster);
	err = RfbWrite( addr+DIR_CLUSTOR_NUM,
						saveCluster,
						2,
						TRUE );							/* NX^ԍ ݒ */
	if( err != RF_OK )					goto ERR_EXIT;
	err = RfbWrite( addr+DIR_FILE_SIZE,
						"\0\0\0\0",
						4,
						TRUE );							/* t@CTCY NA	*/
	if( err != RF_OK )					goto ERR_EXIT;

ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*       łɂt@CGg FCB ɓčXV				*/
/* p[^																*/
/*        pFcb  FFCB ̃AhX											*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*        łɑ݂Gg̍XVATCYA擪NX^XVB*/
/*        entryAddr  0 ̎̓GĝōXVȂB̏ꍇ 	*/
/*       RF_OK ŏIB													*/
/****************************************************************************/
unsigned short updateEntry( T_RF_FCB * pFcb )
{
	unsigned short err = RF_OK;
	T_RF_TIME nowTime;
	char buff[5];
	unsigned long addr = pFcb->brk.sr.entryAddr;

	if( addr == 0UL )				goto ERR_EXIT;

	/* XVAANZXXV */
	if( rfSystemFunction.pGetNowTime )
	{
		if( (*rfSystemFunction.pGetNowTime)( &nowTime ) == RF_OK )	/* ݎ擾	*/
		{
			toDirTime( buff, &nowTime );					/* fBNgi[`ɕϊ */

			err = RfbWrite( addr+DIR_ACCESS_DATE,
								&buff[3],
								2,
								TRUE );						/* ŏIANZXt	*/
			if( err != RF_OK )				goto ERR_EXIT;
			err = RfbWrite( addr+DIR_UPDATE_TIME,
								&buff[1],
								4,
								TRUE );						/* ŏIXV	*/
			if( err != RF_OK )				goto ERR_EXIT;
		}
		else
		{
			err = RF_ERR_GET_TIME;
			goto ERR_EXIT;
		}
	}
	brokenUShortData( pFcb->brk.sr.firstCluster, buff );
	err = RfbWrite( addr+DIR_CLUSTOR_NUM,
						buff,
						2,
						TRUE );							/* NX^ԍ ݒ	*/
	if( err != RF_OK )					goto ERR_EXIT;
	brokenULongData( pFcb->brk.sr.totalLen, buff );
	err = RfbWrite( addr+DIR_FILE_SIZE,
						buff,
						4,
						TRUE );							/* t@CTCY ݒ	*/
	if( err != RF_OK )					goto ERR_EXIT;
ERR_EXIT:
	return err;
}
/****************************************************************************/
/* T  v																	*/
/*       t@CύX												*/
/* p[^																*/
/*        pFcb  FFCB ̃AhX											*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*        pFcb  entryAddr Ɋi[ĂfBNgGg attribute*/
/*       B														*/
/****************************************************************************/
unsigned short RfmUpdateAttr( T_RF_FCB * pFcb )
{
	unsigned short err = RF_OK;

	unsigned long addr = pFcb->brk.sr.entryAddr;

	if( addr == 0UL )				goto ERR_EXIT;

	err = RfbWrite( addr+DIR_ATTRIBUTE,
						(char*)&pFcb->brk.sr.attribute,
						1,
						TRUE );							/* t@CύX	*/
ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*       fBNgɊi[鎞`ɕϊ							*/
/* p[^																*/
/*        dirTimeFfBNgɊi[鎞`i5oCg̗̈悪Kvj	*/
/*        nowTimeF擾ݎ											*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*        ϊi[f[^͈̔̓`FbNȂBG[ 			*/
/*       1980/01/01 0:0:0 i[BA邤NAƓt̊֌W	*/
/*       ǂ܂ł̓`FbNȂB											*/
/*        tAtB[h̃tH[}bg								*/
/*             +------------------------------------------------- ms 0`199 10msPʂ Qb\ */
/*             |        +----------------------------------------  0`23	*/
/*             |        |      +---------------------------------  0`59	*/
/*             |        |      |       +------------------------- b 0`29 2 bPʂŊi[ */
/*             |        |      |       |        +---------------- N 0`127 1980N0AȂ̂2107N܂ŕ\ */
/*             |        |      |       |        |       +--------  1`12	*/
/*             |        |      |       |        |       |    +---  1`31	*/
/*             |        |      |       |        |       |    |   			*/
/*        +---------+ +---------+---------+ +---------+---------+			*/
/*        |tttt tttt| |hhhh hmmm|mmms ssss| |yyyy yyym|mmmd dddd|			*/
/*        +---------+ +---------+---------+ +---------+---------+			*/
/*                       time tB[h       date tB[h				*/
/*         dateAtimetB[h word f[^Ƃĕ\Ă̂Ŋi[	*/
/*         ͏㉺]B												*/
/****************************************************************************/
void toDirTime( char * dirTime, T_RF_TIME * nowTime )
{
	unsigned short wordWk;
	static const T_RF_TIME defaultTime = { 1980,1,1,0,0,0,0 };
	T_RF_TIME * pOrgTime = (T_RF_TIME*)&defaultTime;

	if(	(nowTime->year >= 1980) && (nowTime->year <= (1980+127)) &&
		(nowTime->month >= 1)	&& (nowTime->month <= 12)	&&
		(nowTime->day >= 1)		&& (nowTime->day <= 31)	&&
		(nowTime->hour <= 23)	&&
		(nowTime->min <= 59)	&&
		(nowTime->sec <= 59)	&&
		(nowTime->mSec <= 999)	)
	{
		 pOrgTime = nowTime;
	}

	wordWk  = (unsigned short)(((pOrgTime->year - 1980) << 9) & 0xfe00);	/* N	*/
	wordWk |= (unsigned short)( (pOrgTime->month << 5) & 0x01e0);		/* 	*/
	wordWk |= (unsigned short)(  pOrgTime->day & 0x001f);				/* 	*/
	brokenUShortData( wordWk, &dirTime[3]);			/* date tB[hi[ */

	wordWk  = (unsigned short)((pOrgTime->hour << 11) & 0xf800);		/* 	*/
	wordWk |= (unsigned short)((pOrgTime->min << 5) & 0x07e0);		/* 	*/
	wordWk |= (unsigned short)((pOrgTime->sec / 2) & 0x001f);		/* b	*/
	brokenUShortData( wordWk, &dirTime[1]);			/* time tB[hi[ */

	dirTime[0] = (char)((pOrgTime->mSec + (pOrgTime->sec % 2) * 1000) / 10);	/* ~b */
}

/****************************************************************************/
/* T  v																	*/
/*       fBNg̍쐬tAAms  T_RF_TIME `ɕϊ		*/
/* p[^																*/
/*        pRfTimeF擾												*/
/*        dirTimeFfBNgɊi[Ă鎞`(5oCg)			*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*        fBNgɊi[ĂtAAms  T_RF_TIME `ɕ	*/
/*       																*/
/****************************************************************************/
void fromDirCreateTime( T_RF_TIME * pRfTime, char * dirTime )
{
	fromDirUpdateTime( pRfTime, dirTime+1 );

	pRfTime->sec += (unsigned short)(*dirTime) / 100;			/* b̒P	*/
	pRfTime->mSec = ((unsigned short)(*dirTime) % 100) * 10;	/* 10ms P */
}

/****************************************************************************/
/* T  v																	*/
/*       fBNg̍XVtA T_RF_TIME `ɕϊ			*/
/* p[^																*/
/*        pRfTimeF擾												*/
/*        dirTimeFfBNgɊi[Ă鎞`(4oCg)			*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*        fBNgɊi[ĂtA T_RF_TIME `ɕϊ	*/
/****************************************************************************/
void fromDirUpdateTime( T_RF_TIME * pRfTime, char * dirTime )
{
	unsigned short wordWk = 0;

	fromDirAccessDate( pRfTime, dirTime+2 );		/* tϊ	*/

	wordWk = makeUShortData(dirTime);				/* 	*/
	
	pRfTime->hour = (wordWk >> 11 ) & 0x1f;			/*  */
	pRfTime->min = (wordWk >> 5 ) & 0x3f;			/*  */
	pRfTime->sec = (wordWk  & 0x1f) * 2;			/* b */

}

/****************************************************************************/
/* T  v																	*/
/*       fBNg̃ANZXt T_RF_TIME `ɕϊ				*/
/* p[^																*/
/*        pRfTimeF擾												*/
/*        dirTimeFfBNgɊi[Ă鎞`(2oCg)			*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*        fBNgɊi[Ăt T_RF_TIME `ɕϊ		*/
/****************************************************************************/
void fromDirAccessDate( T_RF_TIME * pRfTime, char * dirTime )
{
	unsigned short wordWk = 0;

	wordWk = makeUShortData(dirTime);

	pRfTime->year = (wordWk >> 9 ) + 1980;
	pRfTime->month = (wordWk >> 5 ) & 0x0f;
	pRfTime->day = wordWk & 0x1f;

	pRfTime->hour = 0;
    pRfTime->min = 0;
    pRfTime->sec = 0;

    pRfTime->mSec = 0;

}

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* FAT ֘A																	*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/

/****************************************************************************/
/* T  v																	*/
/*        FAT`FCNA											*/
/* p[^																*/
/*        firstF擪̃NX^ԍ											*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*         w肳ꂽNX^ԍAIɂȂĂNX^ԍ	*/
/*        ׂăNABt@C폜ۂɎgpBfBNgG	*/
/*        gɏĂt@CTCY͎QƂȂB					*/
/****************************************************************************/
unsigned short RfmDelFatChain( unsigned short first )
{
	unsigned short curClust = 0;						/* ݂̃NX^ԍ	*/
	unsigned short nextClust = 0;						/* ̃NX^ԍ		*/
	unsigned short err = RF_OK;							/* G[R[h			*/

	curClust = first;
	while( curClust != RF_F_CLUST_TERMINATE )
	{
		nextClust = getNextCluster( curClust, &err );	/* ̃NX^ԍ߂ */
		if( err != RF_OK )				goto ERR_EXIT;
		err = setFatVal( curClust, RF_F_CLUST_FREE );	/* gp̈Ƃ	*/
		if( err != RF_OK )				goto ERR_EXIT;
		curClust = nextClust;
	}
ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        gpNX^T												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        0 ȊOF󂫂̃NX^ԍ										*/
/*        0FgpNX^												*/
/*   																	*/
/*         FATgp̃NX^T								*/
/****************************************************************************/
unsigned short findFreeClust( unsigned short * err )
{
	unsigned short freeClust = nowFreeClust;
	unsigned short i = 0;
	unsigned short fatVal = 0;

	for( i = 0; i < rfDriveInfo.clusterNum; ++i )
	{
		fatVal = getFatVal( freeClust, err );
		if( *err != RF_OK )
		{
			freeClust = 0;
			goto EXIT_FUNC;								/* ANZXG[ */
		}
		if( fatVal == RF_F_CLUST_FREE )
		{


			nowFreeClust = freeClust;					/* ݂̋󂫃NX^ʒuXV */
			goto EXIT_FUNC;								/* gpNX^ */
		}
		freeClust
			= (freeClust + 1) % (rfDriveInfo.clusterNum+2);	/* ̃NX^ԍw */
		if( freeClust < 2 )	freeClust = 2;
	}
	*err = RF_ERR_NO_SPACE;
	freeClust = 0;										/* 󂫃NX^Ȃ */

EXIT_FUNC:
	return freeClust;
}

/****************************************************************************/
/* T  v																	*/
/*       w肳ꂽNX^ԍɑNX^ԍ擾					*/
/* p[^																*/
/*        clustorFNX^ԍ												*/
/*        errCodeFG[R[hi[̈								*/
/* ߂l																	*/
/*        0Fw肳ꂽNX^ԍɑNX^݂͑Ȃ				*/
/*        0ȊOFw肳ꂽNX^ԍɑNX^ԍ					*/
/*   																	*/
/*         FAT ̎w肳ꂽNX^ԍɑΉeǂݎNX^ԍ	*/
/*        ̏ꍇ͂ԂBI[NX^A܂͎w肳ꂽNX^ԍ	*/
/*        ̂Ȏ 0 ԂB											*/
/****************************************************************************/
unsigned short getNextCluster( unsigned short cluster, unsigned short * errCode )
{
	unsigned short nextCluster = 0;

	nextCluster = getFatVal( cluster, errCode );
	if( ( nextCluster == RF_F_CLUST_TERMINATE ) ||
		( nextCluster == RF_F_CLUST_BROKEN ) ||
		( nextCluster == RF_F_CLUST_FREE )    )

	if( ( nextCluster == RF_F_CLUST_BROKEN ) ||
		( nextCluster == RF_F_CLUST_FREE )    )
	{
		*errCode = RF_ERR_BROKEN_FILE;
	}

	return nextCluster;
}

/****************************************************************************/
/* T  v																	*/
/*       FAT ̎wNX^ԍɏĂe擾					*/
/* p[^																*/
/*        clustorFNX^ԍ												*/
/*        errCodeFG[R[hi[̈								*/
/* ߂l																	*/
/*        RF_F_CLUST_FREE       󂫃NX^								*/
/*        RF_F_CLUST_TERMINATE  I[NX^								*/
/*        RF_F_CLUST_BROKEN     ꂽNX^								*/
/*   																	*/
/*         FAT ̎w肳ꂽNX^ԍɑΉeǂݎNX^ԍ	*/
/*        ̏ꍇ͂ԂBI[NX^A܂͎w肳ꂽNX^ԍ	*/
/*        ̂Ȏ RF_F_CLUST_... ԂB							*/
/****************************************************************************/
unsigned short getFatVal( unsigned short cluster, unsigned short * errCode )
{
	unsigned short clusterNum = 0;

	if( ( cluster < ( rfDriveInfo.clusterNum + 2 ) ) &&
		( cluster >= 2 )		)
	{
		if( rfDriveInfo.fSystem == RF_F_SYSTEM_FAT12 )
		{
			clusterNum = getFat12Value( cluster, errCode );	/* FAT12 ̏ꍇ */
		}
		else if( rfDriveInfo.fSystem == RF_F_SYSTEM_FAT16 )
		{
			clusterNum = getFat16Value( cluster, errCode );	/* FAT16 ̏ꍇ */
		}
		else
		{
			*errCode = RF_ERR_UNKNOWN_FILE_SYSTEM;
			clusterNum = 0;							/* t@CVXes */
		}
	}

	return clusterNum;
}

/****************************************************************************/
/* T  v																	*/
/*       FAT12 ̎wNX^e擾									*/
/* p[^																*/
/*        clustorFNX^ԍ												*/
/*        errCodeFǂݍ݃G[̃G[R[hi[̈				*/
/* ߂l																	*/
/*        RF_F_CLUST_FREE       󂫃NX^								*/
/*        RF_F_CLUST_TERMINATE  I[NX^								*/
/*        RF_F_CLUST_BROKEN     ꂽNX^								*/
/*        ȊOEEEEEEẼNX^ԍ							*/
/*   																	*/
/*        FAT12 12bit(1.5byte)PʂŊǗ̂ŃNX^ԍ 1.5 {	*/
/*       ʒuɃNX^񂪊i[B								*/
/****************************************************************************/
unsigned short getFat12Value( unsigned short cluster, unsigned short * errCode )
{
	unsigned long targetAddr;
	unsigned short fatVal = 0;
	char buff[2];

	targetAddr = (unsigned long)cluster +
				 (unsigned long)cluster / 2UL;			/* FAT ̃NX^ԍɑΉAhX */
	targetAddr += rfDriveInfo.fatPoint;					/* FAT ̐擪AhX𑫂	*/
	*errCode = RfbRead( targetAddr, buff, 2 );
	if( *errCode == RF_OK )
	{
		fatVal = makeUShortData( buff );				/* 2 oCg				*/
		if( ( cluster % 2 ) != 0 )	fatVal >>= 4;		/* ԃNX^ 4 rbgVtg	*/
		fatVal &= 0x0fff;								/* svȃf[^}XN			*/

		if( fatVal == RF_F_CLUST_FAT12_FREE )			fatVal = RF_F_CLUST_FREE;
		else if( fatVal == RF_F_CLUST_FAT12_TERMINATE )	fatVal = RF_F_CLUST_TERMINATE;
		else if( fatVal > RF_F_CLUST_FAT12_MAX )		fatVal = RF_F_CLUST_BROKEN;
	}

	return fatVal;
}

/****************************************************************************/
/* T  v																	*/
/*       FAT16 ̎wNX^e擾									*/
/* p[^																*/
/*        clustorFNX^ԍ												*/
/*        errCodeFǂݍ݃G[̃G[R[hi[̈				*/
/* ߂l																	*/
/*        RF_F_CLUST_FREE       󂫃NX^								*/
/*        RF_F_CLUST_TERMINATE  I[NX^								*/
/*        RF_F_CLUST_BROKEN     ꂽNX^								*/
/*        ȊOEEEEEEẼNX^ԍ							*/
/*   																	*/
/*        FAT16 16bit(2byte)PʂŊǗ̂ŃNX^ԍ 2 {	*/
/*       ʒuɃNX^񂪊i[B									*/
/****************************************************************************/
unsigned short getFat16Value( unsigned short cluster, unsigned short * errCode )
{
	unsigned long targetAddr;
	unsigned short fatVal = 0;
	char buff[2];

	targetAddr = (unsigned long)cluster * 2UL;			/* FAT ̃NX^ԍɑΉAhX */
	targetAddr += rfDriveInfo.fatPoint;					/* FAT ̐擪AhX𑫂	*/
	*errCode = RfbRead( targetAddr, buff, 2 );
	if( *errCode == RF_OK )
	{
		fatVal = makeUShortData( buff );				/* 2 oCg				*/

		if( fatVal == RF_F_CLUST_FAT16_FREE )			fatVal = RF_F_CLUST_FREE;
		else if( fatVal == RF_F_CLUST_FAT16_TERMINATE )	fatVal = RF_F_CLUST_TERMINATE;
		else if( fatVal > RF_F_CLUST_FAT16_MAX )		fatVal = RF_F_CLUST_BROKEN;
	}

	return fatVal;
}

/****************************************************************************/
/* T  v																	*/
/*       FAT ̎wNX^ԍɎw肳ꂽl						*/
/* p[^																*/
/*        clusterFNX^ԍ												*/
/*        val    Fޓe												*/
/* ߂l																	*/
/*        RF_OK       													*/
/*        RF_ERR_...  s													*/
/*   																	*/
/*         FAT ̎w肳ꂽNX^ԍɓeށB					*/
/*         FAT ̕ύX͈͂XVB										*/
/****************************************************************************/
unsigned short setFatVal( unsigned short cluster, unsigned short val )
{
	unsigned short err = RF_ERR_UNKNOWN_FILE_SYSTEM;

	if( rfDriveInfo.fSystem == RF_F_SYSTEM_FAT12 )
	{
		err = setFat12Value( cluster, val );	/* FAT12 ̏ꍇ */
	}
	else if( rfDriveInfo.fSystem == RF_F_SYSTEM_FAT16 )
	{
		err = setFat16Value( cluster, val );	/* FAT16 ̏ꍇ */
	}

	/* ꍇFAT̕ύX͈͂XV */
	if( err == RF_OK )
	{
		if( noseUpdateClust == 0 )
		{
			noseUpdateClust = cluster;
			tailUpdateClust = cluster;
		}
		else if( noseUpdateClust > cluster )
		{
			noseUpdateClust = cluster;					/* 擪ʒuXV */
		}
		else if( tailUpdateClust < cluster )
		{
			tailUpdateClust = cluster;					/* I[ʒuXV */
		}
	}

	return err;
}

/****************************************************************************/
/* T  v																	*/
/*       FAT12 ̎wNX^e擾									*/
/* p[^																*/
/*        clustorFNX^ԍ												*/
/*                 RF_F_CLUST_FREE       󂫃NX^						*/
/*                 RF_F_CLUST_TERMINATE  I[NX^						*/
/*                 RF_F_CLUST_BROKEN     ꂽNX^						*/
/*                 ȊOEEEEEEẼNX^ԍ					*/
/*        errCodeFǂݍ݃G[̃G[R[hi[̈				*/
/* ߂l																	*/
/*        RF_OK       													*/
/*        RF_ERR_...  G[											*/
/*   																	*/
/*        FAT12 12bit(1.5byte)PʂŊǗ̂ŃNX^ԍ 1.5 {	*/
/*       ʒuɃNX^񂪊i[B								*/
/****************************************************************************/
unsigned short setFat12Value( unsigned short cluster, unsigned short val )
{
	unsigned long targetAddr;						/* ǂݏ̃AhX	*/
	unsigned short err = RF_ERR_FAT_NUM;			/* G[R[h			*/
	char buff[2];									/* ǂݏ̃obt@	*/
	unsigned short orgVal = 0;						/* ̒l				*/

	/* FAT12 p̋LɕύX */
	if( val == RF_F_CLUST_FREE )			val = RF_F_CLUST_FAT12_FREE;
	else if( val == RF_F_CLUST_TERMINATE )	val = RF_F_CLUST_FAT12_TERMINATE;
	else if( val == RF_F_CLUST_BROKEN )		val = RF_F_CLUST_FAT12_BROKEN;
	else if( ( val > RF_F_CLUST_FAT12_MAX ) || (val == 1) )
	{
		goto ERR_EXIT;
	}

	/* AhX߂ */
	targetAddr = (unsigned long)cluster +
				 (unsigned long)cluster / 2UL;	/* FAT ̃NX^ԍɑΉAhX */
	targetAddr += rfDriveInfo.fatPoint;			/* FAT ̐擪AhX𑫂	*/

	/* ̓eo */
	err = RfbRead( targetAddr, buff, 2 );
	if( err != RF_OK )	goto ERR_EXIT;			/* ǂݎG[			*/
	orgVal = makeUShortData( buff );			/* 2 oCg				*/
	if( ( cluster % 2 ) != 0 )
	{
		/* Ԃ̃NX^͉4bit ʂ̃NX^ƋLĂ */
		val <<= 4;
		val |= (orgVal & 0x000f);				/*  4 rbgɌ̒lc */
	}
	else
	{
		/* Ԃ̃NX^͏4bit ʂ̃NX^ƋLĂ */
		val &= 0x0fff;
		val |= (orgVal & 0xf000);				/*  4 rbgɌ̒lc */
	}
	brokenUShortData( val, buff );				/* oCgɕ				*/
	err = RfbWrite( targetAddr,
							buff,
							2,
							TRUE );				/* 					*/

ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*       FAT16 ̎wNX^ɒl									*/
/* p[^																*/
/*        clusterFNX^ԍ												*/
/*                 RF_F_CLUST_FREE       󂫃NX^						*/
/*                 RF_F_CLUST_TERMINATE  I[NX^						*/
/*                 RF_F_CLUST_BROKEN     ꂽNX^						*/
/*                 ȊOEEEEEEẼNX^ԍ					*/
/*        val    Fޓe												*/
/* ߂l																	*/
/*        RF_OKFݐ												*/
/*        RF_ERR_...  ̑G[											*/
/*   																	*/
/*        FAT16 16bit(2byte)PʂŊǗ̂ŃNX^ԍ 2 {	*/
/*       ʒuɃNX^񂪊i[B									*/
/*        FAT16 ̓NX^PʂƃoCgEĂ̂Œڏނ	*/
/*       ŗǂB															*/
/****************************************************************************/
unsigned short setFat16Value( unsigned short cluster, unsigned short val )
{
	unsigned long targetAddr;					/* FAT̃AhX		*/
	unsigned short err = RF_ERR_FAT_NUM;		/* G[R[h			*/
	char buff[2];								/* ǂݏobt@		*/

	/* FAT16 p̋LɕύX */
	if( val == RF_F_CLUST_FREE )			val = RF_F_CLUST_FAT16_FREE;
	else if( val == RF_F_CLUST_TERMINATE )	val = RF_F_CLUST_FAT16_TERMINATE;
	else if( val == RF_F_CLUST_BROKEN )		val = RF_F_CLUST_FAT16_BROKEN;
	else if( ( val > RF_F_CLUST_FAT16_MAX ) || (val == 1) )
	{
		goto ERR_EXIT;
	}

	targetAddr = (unsigned long)cluster * 2UL;	/* FAT ̃NX^ԍɑΉAhX */
	targetAddr += rfDriveInfo.fatPoint;			/* FAT ̐擪AhX𑫂	*/
	brokenUShortData( val, buff );				/* oCgɕ				*/
	err = RfbWrite( targetAddr,
							buff,
							2,
							TRUE );				/* 					*/
ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        t@CVXe̊										*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        RF_OKFݐ												*/
/*        RF_ERR_...  ̑G[											*/
/*   																	*/
/*        J[hoOɂȂB									*/
/*        ݂ȂꍇAݎ FAT1 ̂ݍXVĂB	*/
/*       ̊֐s FAT1 ̓e FAT2 ɏށB				*/
/****************************************************************************/
unsigned short RfmConclude( void )
{
	unsigned long startAddr;					/* FAT ̕ύXJnAhX */
	unsigned long tailAddr;						/* FAT ̕ύXIAhX */
	unsigned short copyLen;						/* Rs[钷 */
	unsigned long distAddr;						/* J[h̃Rs[AhX */
	unsigned short err;

	err = RF_OK;
	if( noseUpdateClust == 0 ) 				goto ERR_EXIT;	/* ύXĂȂ̂łȂɂȂ */

	/* XVʒũZN^AhX߂ */
	if( rfDriveInfo.fSystem == RF_F_SYSTEM_FAT12 )
	{
		startAddr = noseUpdateClust + noseUpdateClust / 2UL;
		tailAddr = tailUpdateClust + tailUpdateClust / 2UL;
	}
	else if( rfDriveInfo.fSystem == RF_F_SYSTEM_FAT16 )
	{
		startAddr = noseUpdateClust * 2UL;
		tailAddr = tailUpdateClust * 2UL;
	}
	else
	{
		err = RF_ERR_UNKNOWN_FILE_SYSTEM;
		goto ERR_EXIT;									/* t@CVXes	*/
	}
	tailAddr += 2UL;									/* 1ubNXVĂ̂ő */
	copyLen = (unsigned short)(tailAddr - startAddr);	/* Rs[ */
	startAddr = startAddr + rfDriveInfo.fatPoint;		/* Rs[AhX */
	distAddr = startAddr + rfDriveInfo.fatSize;			/* Rs[AhX */

	err = RfbCopy( distAddr, startAddr, copyLen );


ERR_EXIT:
	clearSystemVariable();								/* VXeϐ	*/

	return err;
}

/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* ͊֘A															*/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
/* T  v																	*/
/*        SoCg̐f[^gݗĂ									*/
/* p[^																*/
/*        pBuffFSoCgf[^i[Ă̈						*/
/* ߂l																	*/
/*        ɕϊl													*/
/*   																	*/
/*        ʃoCgʌɂB										*/
/****************************************************************************/
unsigned long makeULongData( char * pBuff)
{
	return
			(((unsigned long)pBuff[3] <<  (8UL*3UL)) & 0xff000000 ) |
			(((unsigned long)pBuff[2] <<  (8UL*2UL)) & 0x00ff0000 ) |
			(((unsigned long)pBuff[1] <<  (8UL*1UL)) & 0x0000ff00 ) |
			(((unsigned long)pBuff[0] <<  (8UL*0UL)) & 0x000000ff );
}

/****************************************************************************/
/* T  v																	*/
/*        QoCg̐f[^gݗĂ									*/
/* p[^																*/
/*        pBuffFQoCgf[^i[Ă̈						*/
/* ߂l																	*/
/*        ɕϊl													*/
/*   																	*/
/*        ʃoCgʌɂB										*/
/****************************************************************************/
unsigned short makeUShortData( char * pBuff)
{
	return  (unsigned short)(
			(((unsigned short)pBuff[1] <<  (8*1)) & 0xff00 ) |
			(((unsigned short)pBuff[0] <<  (8*0)) & 0x00ff ) );
}
/****************************************************************************/
/* T  v																	*/
/*        QoCg̐l𕪉										*/
/* p[^																*/
/*        org  F unsigned short ̐l									*/
/*        pBuffForg ̉ʁAʃf[^i[̈						*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ʌz̐Ɋi[B										*/
/****************************************************************************/
void brokenUShortData( unsigned short org, char * pBuff)
{
	pBuff[0] = (char)org;
	pBuff[1] = (char)(org >> 8);
}

/****************************************************************************/
/* T  v																	*/
/*        SoCg̐l𕪉										*/
/* p[^																*/
/*        org  F unsigned long ̐l									*/
/*        pBuffFʂۑSoCg̗̈						*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        ʌz̐Ɋi[B										*/
/****************************************************************************/
void brokenULongData( unsigned long org, char * pBuff)
{
	pBuff[0] = (char)org;
	pBuff[1] = (char)(org >> (8UL*1UL));
	pBuff[2] = (char)(org >> (8UL*2UL));
	pBuff[3] = (char)(org >> (8UL*3UL));
}

/****************************************************************************/
/* T  v																	*/
/*        													*/
/* p[^																*/
/*        strF镶obt@										*/
/*        targetF镶												*/
/*        lenF̒													*/
/* ߂l																	*/
/*        ̈ʒu												*/
/*   																	*/
/*          target BŏɌʒuԂB	*/
/*        Ȃꍇ 0xffff ԂB									*/
/*        ʒu len ܂ł '\0',܂'\\' ܂ŁB'\0' łB	*/
/*         j																*/
/*           findChar("abcdefg", 'e', 5);									*/
/*           "abcdefg" ̐擪ToCgڂ܂ł̊Ԃ 'e'TB			*/
/*            12345															*/
/*           ͈͂ a ` e ܂łŁA߂l 4 ƂȂB					*/
/*        t@C̃tpX𕪊̂܂܏ł悤'\\'ftH	*/
/*        gŏI[ƂB												*/
/****************************************************************************/
unsigned short findChar( char * str, char target, unsigned short len )
{
	unsigned short i = 0;
	unsigned short targetPoint = 0xffff;

	for( i = 0; i < len; ++i )
	{
		if( str[i] == target )
		{
			targetPoint = i;
			break;
		}
		if( str[i] == '\0' ) break;
		if( str[i] == '\\' ) break;
	}

	return targetPoint;
}

/****************************************************************************/
/* T  v																	*/
/*        g[No												*/
/* p[^																*/
/*        tokenNumFog[N̔ԍiO`j							*/
/*        filePathF̕												*/
/*        len     FsO͌钷̃~bgA						*/
/*                  s̓g[N̒ݒ肳						*/
/* ߂l																	*/
/*        g[N̐擪ʒu												*/
/*        0xffffFȂ												*/
/*   																	*/
/*        '\\'ŋ؂ꂽg[NTB									*/
/*        filePath z̃g[N̐擪ʒuƃg[N̒߂B		*/
/*         )																*/
/*          @"\aaaaa\bbbb\ccc.txt"											*/
/*          A"aaaaa\bbbb\ccc.txt"											*/
/*          tokenNum=0Faaaaa												*/
/*          tokenNum=1Fbbbb												*/
/*          tokenNum=2Fccc.txt												*/
/*          @ƇÂ͓g[NƂĔ肷B						*/
/*          u\v AĂꍇ̓G[ƂB						*/
/****************************************************************************/
unsigned short takeToken( unsigned short tokenNum, char * filePath, unsigned short * len )
{
	unsigned short startPos = 0xffff;
	unsigned short i = 0;
	unsigned short curTok = 0;

	/*  '\\' 菜 */
	if( filePath[i] == '\\' )	++i;					/* u\v Ԃ񂸂炷 */

	/* g[NT */
	for( curTok = 0; curTok < tokenNum; ++i )
	{
		for( ; i < *len; ++i )
		{
			if( filePath[i] == '\0' )	goto ERR_EXIT;
			if( filePath[i] == '\\' )	break;
		}
		if( i >= *len )					goto ERR_EXIT;
		++curTok;
	}

	if( i >= *len )						goto ERR_EXIT;	/* I[܂ŒB		*/
	if( filePath[i] == '\\' )	++i;					/* u\vԂ񂸂炷		*/
	if( filePath[i] == '\\' )			goto ERR_EXIT;	/* u\vAĂ	*/

	/* g[N̒߂ */
	startPos = i;										/* g[N̊Jnʒuۑ */
	for( ; i < *len; ++i )
	{
		if( filePath[i] == '\\' )	break;
		if( filePath[i] == '\0' )	break;
	}
	*len = i - startPos;								/* g[N̒߂	*/

ERR_EXIT:
	return startPos;
}

/****************************************************************************/
/* T  v																	*/
/*        Pg[No										*/
/* p[^																*/
/*        filePathF̕												*/
/*        len     F钷̃~bg									*/
/* ߂l																	*/
/*        g[N̒													*/
/*   																	*/
/*        '\'ŋ؂ꂽg[NTB									*/
/*        擪'\'̂Ƃ̓G[B											*/
/*        filePath z̃g[N̒߂B							*/
/*        g[NȂꍇ 0 ԂB							*/
/*        len ܂ŒTƂ len ԂB									*/
/****************************************************************************/
unsigned short takeOneToken( char * filePath, unsigned short len )
{
	unsigned short i = 0;


	/* g[NT */
	for( i = 0; i < len; ++i )
	{
		if( filePath[i] == '\0' )	break;
		if( filePath[i] == '\\' )	break;
	}

	return i;
}

/****************************************************************************/
/* T  v																	*/
/*        Ō̃g[Nʒu߂										*/
/* p[^																*/
/*        filePathF̕AI['\0'									*/
/*        lim     F钷̃~bg									*/
/* ߂l																	*/
/*        g[N̐擪ʒu												*/
/*        g[NȂA؂蕶ꍇ͐擪ʒuԂB	*/
/*   																	*/
/*        '\'ŋ؂ꂽg[NTB									*/
/*        filePath z̃g[N̐擪ʒuƃg[N̒߂B		*/
/*         )																*/
/*                         V												*/
/*          @"\aaaaa\bbbb\ccc.txt"											*/
/*                        V													*/
/*          A"aaaaa\bbbb\ccc.txt"											*/
/*              V															*/
/*          B"\"															*/
/*             V															*/
/*          C""															*/
/*               V															*/
/*          D"\\\"															*/
/*                  V														*/
/*          E"\aaa\bbb\"													*/
/*               															*/
/*        '\'ŕŜIĂƂ͂̑O'\'g[NƂB	*/
/****************************************************************************/
unsigned short takeLastToken( char * filePath, unsigned short lim )
{
	unsigned short bfStartPos = 0;
	unsigned short startPos = 0;
	unsigned short i = 0;

	/*  '\\' 菜 */
	if( filePath[i] == '\\' )	++i;					/* u\v Ԃ񂸂炷 */

	startPos = i;
	/* ؂蕶T */
	for( ; i < lim; ++i )
	{
		if( filePath[i] == '\0' )	break;
		if( filePath[i] == '\\' )
		{
			bfStartPos = startPos;						/* 1Õg[N */
			startPos = i+1;								/* Vg[N */
		}
	}
	if( startPos >= i )
	{
		startPos = bfStartPos;							/* 1O '\' ɖ߂ */
	}

	return startPos;
}

/****************************************************************************/
/* T  v																	*/
/*        \ȏ܂ޕ񂩒ׂ								*/
/* p[^																*/
/*        strF镶			'									*/
/*        lenF钷													*/
/* ߂l																	*/
/*        enum e_char_small ^												*/
/*         E_CHAR_SMALLF\ȏ܂ޕ						*/
/*         E_CHAR_MIX  F啶ƏĂ						*/
/*         E_CHAR_LARGEF啶ō\A܂͑啶		*/
/*   																	*/
/*        啶Ə݂p̏ꍇ͕\ƂB	*/
/*        )																*/
/*         "aaaBB"      E_CHAR_MIX										*/
/*         "AAABB"      E_CHAR_LARGE										*/
/*         "aaabb"      E_CHAR_SMALL										*/
/*         "AAA#1"      E_CHAR_LARGE										*/
/*         "aaa#1"      E_CHAR_SMALL										*/
/*         "222#1"      E_CHAR_LARGE										*/
/*        DOS ̃t@Cl[~O[ł͏̃t@C͋Ă	*/
/*       B																*/
/*        ̃t@C쐬Ƃ long file ̃Gg͍쐬	*/
/*       ȂB啶ŃGg쐬łƂtO𗧂	*/
/*       ĂB̃tO𗧂Ă邩ǂ̔̊֐łȂB		*/
/****************************************************************************/
enum e_char_mix checkCharMix( char * str, unsigned short len )
{
	enum e_char_mix ret = E_CHAR_LARGE;
	unsigned short i = 0;
	unsigned short smallCharNum = 0;
	unsigned short largeCharNum = 0;

	for( i = 0; i < len; ++i )
	{
		if( ( str[i] >= 'a' ) &&
			( str[i] <= 'z' )   )
		{
			++smallCharNum;								/* ̐݌v */
		}
		if( ( str[i] >= 'A' ) &&
			( str[i] <= 'Z' )   )
		{
			++largeCharNum;								/* 啶̐݌v */
		}
	}
	if( ( smallCharNum != 0 ) && (largeCharNum == 0) )
	{
		ret = E_CHAR_SMALL;								/* p̂Ƃ */
	}
	else if( ( smallCharNum != 0 ) && (largeCharNum != 0) )
	{
		ret = E_CHAR_MIX;								/* 啶AĂ */
	}

	/* else */
	/* ȊO E_CHAR_LARGE Ƃ */

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*        V[gt@C̎gp֎~܂܂Ă邩`FbN		*/
/* p[^																*/
/*        strF镶			'									*/
/*        lenF钷													*/
/* ߂l																	*/
/*        TRUEFgp֎~͊܂܂ĂȂ								*/
/*        FALSEFgp֎~܂܂Ă									*/
/*   																	*/
/*        V[gt@C̎gp֎~`FbN DOS x܂Ŏ	*/
/*        ŝ͍̉ۑƂB󐳂삵Ȃ̂`FbNB*/
/*        EV[gt@CŋւĂL̓G[ƂB			*/
/*        EVtgJIS ̊R[h̓G[									*/
/*          R[ĥQoCgڂ 0x5c(\)gꍇB̏ꍇA*/
/*          \ ̓fBNg̋؂ƌĂ͂ȂB؂蔻菈ł	*/
/*          Ȃ悤ɂȂ܂ŊR[ht@C͎gpłȂ	*/
/*          ƂƂB														*/
/*          ̂PoCg0x80`0x8fA0xe0`0xff							*/
/*        EpJi͂nj													*/
/*        Ep͂nj													*/
/****************************************************************************/
unsigned short isValidShortChar( char * name, unsigned short len )
{
	static const char validMark[] = VALID_SHORT_CHAR;			/* V[gt@CŋL */
	unsigned short i,j;
	unsigned short ret = TRUE;

	for( i = 0; i < len; ++i )
	{
		/* p`FbN */
		if( (name[i] >= 'a' ) && ( name[i] <= 'z' ) )	continue;	/* p	*/
		if( (name[i] >= 'A' ) && ( name[i] <= 'Z' ) )	continue;	/* p啶	*/
		if( (name[i] >= '0' ) && ( name[i] <= '9' ) )	continue;	/* 	*/

		/* R[h`FbN */
		if( ((name[i] & 0xff) >= 0x80 ) && ( (name[i] & 0xff)<= 0x8f ) )	/* ̂PoCgڇ@	*/
		{
			ret = FALSE;
			break;
		}
		if( ((name[i] & 0xff) >= 0xe0 ) && ( (name[i] & 0xff) <= 0xff ) )	/* ̂PoCgڇA	*/
		{
			ret = FALSE;
			break;
		}

		/* ĂL */
		ret = FALSE;
		for(j = 0; j < (sizeof(validMark)-1); ++j )
		{
			if( name[i] == validMark[j] )
			{
				ret = TRUE;
				break;
			}
		}
		if( ret == FALSE )		break;								/* ǂɂĂ͂܂Ȃ */
	}

	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*        fBNgǂ												*/
/* p[^																*/
/*        pFcb    FRfOpenDir() ̖߂l									*/
/*        pDirInfoFǂݍ񂾃fBNg								*/
/* ߂l																	*/
/*        RF_OK ͐														*/
/*        RF_ERR_...̓G[												*/
/*   																	*/
/****************************************************************************/
unsigned short RfmReadDir( T_RF_FCB * pFcb, T_RF_DIR_INFO * pDirInfo )
{
	unsigned short err = RF_OK;
	char entry[DIR_RECORD_SIZE];
	unsigned short i;

	err = getNextValidEntry( &pFcb->brk.sd );
	if( err == RF_OK )
	{
		if( pFcb->brk.sd.cond == RF_ENTRY_VALID )
		{
			err = RfbRead( pFcb->brk.sd.entryAddr,
							 entry, DIR_RECORD_SIZE );		/* f[^擾	*/

			/* 啶/𔽉f */
			if( (entry[DIR_NAME_CHAR] & DIR_NAME_TITLE_SMALL) != 0 )
			{
				for( i = 0; i < DIR_SHORT_FLNAME_BODY; i++ )
				{
					entry[DIR_NAME+i] = (char)rfToLower((int)entry[DIR_NAME+i]);
				}
			}
			if( (entry[DIR_NAME_CHAR] & DIR_NAME_EXTENT_SMALL) != 0 )
			{
				for( i = 0; i < DIR_SHORT_FLNAME_EXT; i++ )
				{
					entry[DIR_NAME+DIR_SHORT_FLNAME_BODY+i] = (char)rfToLower((int)entry[DIR_NAME+DIR_SHORT_FLNAME_BODY+i]);
				}
			}
			connectionFlName(pDirInfo->name, &entry[DIR_NAME]);	/* body ƊgqA */
			pDirInfo->attribute = (unsigned char)entry[DIR_ATTRIBUTE];	/* 			*/
			fromDirCreateTime(&pDirInfo->timeCreate, 
								&entry[DIR_CRT_TIME_TENTH]);	/* 쐬tA */
			fromDirAccessDate(&pDirInfo->timeAccess, 
								&entry[DIR_ACCESS_DATE]);	/* ŏIANZXt */
			fromDirUpdateTime(&pDirInfo->timeUpdate, 
								&entry[DIR_UPDATE_TIME]);	/* XVtA	*/
			pDirInfo->size
				 = makeUShortData(&entry[DIR_FILE_SIZE]);	/* t@CTCY	*/
	
		}
		else if( ( pFcb->brk.sd.cond == RF_ENTRY_TERMINATE ) || ( pFcb->brk.sd.cond == RF_ENTRY_NOT_FOUND) )
		{
			/* gp̈܂ŒBꍇƍŌ܂ŒTȂꍇ́uȂvƂ	*/
			/* ̑́uvꍇƂȂ炩̃ANZXG[ƂB					*/
			/* ͍Ă err ̂܂ܕԂB											*/
			err = RF_ERR_EOF;								/* I[ɒB */
		}
	}

	return err;
}


/****************************************************************************/
/* T  v																	*/
/*        t@C body  gqA								*/
/* p[^																*/
/*        connect FAt@Ci[̈						*/
/*        separateFAÕt@C										*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        fBNgɊi[Ă`̃t@CAB			*/
/*        )																*/
/*          "ABC     TXT"  "ABC.TXT"										*/
/****************************************************************************/
void connectionFlName( char * pConnect,  char * pSeparate)
{
	char * curSeparate = pSeparate;
	unsigned short i;

	/* body ̃Rs[ */
	for( i = 0; i < DIR_SHORT_FLNAME_BODY; i++ )
	{
		if( *curSeparate == ' ' )
		{
			break;
		}
		*pConnect = *curSeparate;
		pConnect++;
		curSeparate++;
	}

	curSeparate = pSeparate+DIR_NAME_EXT;
	if( *curSeparate != ' ' )
	{
		/* gqꍇ */
		*pConnect = '.';
		pConnect++;

		/* gq̃Rs[ */
		for( i = 0; i < DIR_SHORT_FLNAME_EXT; i++ )
		{
			if( *curSeparate == ' ' )
			{
				break;
			}
			*pConnect = *curSeparate;
			pConnect++;
			curSeparate++;
		}
		
	}
	*pConnect = '\0';				/* I[ */
}
