/****************************************************************************/
/* T  vF format ̃eXg													*/
/*   F formatȂ												*/
/* 쐬F 2005.08.20														*/
/* XVF 2014.02.02														*/
/* Copyright    resove														*/
/****************************************************************************/

#include "RfInterface.h"
#include "RfFormat.h"
#include "TstDefine.h"
#include "TraceOut.h"



#define FORMAT_TEST( n ) \
	TRACE_OUT(( "%d.=======================================\n",++ix )); \
	TRACE_OUT(( "   ==== RfFormat( " #n " )\n" ));			\
	err = RfFormat( n );			/* tH[}bgs	*/ 			\
	CHK_ERR_CODE(err, RF_OK, "RfFormat()");						\
	err = RfInitFileSystem( );									\
	CHK_ERR_CODE(err, RF_OK, "RfInitFileSystem()");				\
	dispCardInfo(  );											\
	TRACE_OUT(("\n"))

/****************************************************************************/
/* T  v																	*/
/*        format s													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestFormat( void )
{
	unsigned short ix = 0;
	unsigned short err = RF_OK;
	T_RF_FCB * pFcb;

	TEST_TITLE(("Test format."));


	err = RfInitFileSystem( );
	CHK_ERR_CODE(err, RF_OK, "RfInitFileSystem()");
	TRACE_OUT(("\n"));

	FORMAT_TEST( RF_FORMAT_MODE_DOS | 0x39 );
	FORMAT_TEST( RF_FORMAT_MODE_DOS|RF_FORMAT_OPT_SAME_PARTITION );
	FORMAT_TEST( RF_FORMAT_MODE_DOS | 0 );
	FORMAT_TEST( RF_FORMAT_MODE_DOS|RF_FORMAT_OPT_SAME_PARTITION );
	FORMAT_TEST( RF_FORMAT_MODE_SD );
	FORMAT_TEST( RF_FORMAT_MODE_MAINT );
	FORMAT_TEST( RF_FORMAT_MODE_DOS|RF_FORMAT_OPT_SAME_PARTITION );
	FORMAT_TEST( RF_FORMAT_MODE_MAINT );
	
	/* t@CI[ṽ`FbN */
	pFcb = RfOpen("\\format.txt", RF_OPEN_WRITE_NEW, &err);
	CHK_ERR_CODE(err, RF_OK, "RfOpen()");
	if( pFcb != (T_RF_FCB*)0 )
	{
		err = RfFormat( RF_FORMAT_MODE_MAINT );			/* tH[}bgs	*/ 
		CHK_ERR_CODE(err, RF_ERR_FMT_THERE_IS_OPENED, "RfFormat() [RF_ERR_FMT_THERE_IS_OPENED]");
		err = RfClose(pFcb);
		CHK_ERR_CODE(err, RF_OK, "RfClose()");
	}
	

}
