/****************************************************************************/
/* T  vF ㏑ write ̃eXg											*/
/*   F n߂Ƀt@CVKɍ쐬Ãt@Cēx㏑[h	*/
/*         I[v㏑̃eXgȂB								*/
/* 쐬F 2005.07.17														*/
/* XVF 2014.02.15														*/
/* Copyright    resove														*/
/****************************************************************************/

#include "RfInterface.h"
#include "TraceOut.h"
#include "TstDefine.h"
#include "TstWriteVal.h"
#include "TstWriteFunc.h"

/* ֐^錾 */
static void readyEnv( void );										/* eXg쐬 */
static void TestWriteNew( void );
static void TestWriteOld( void );
static void TestNg( void );

static void overWriteSm( char * pFileNm );
static void overWriteLarge( char * pFileNm, unsigned long len );

#define MANY_NUM	(5)


/****************************************************************************/
/* T  v																	*/
/*        ㏑̃eXg													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestOverWrite( void )
{
	TEST_TITLE(("Test over write."));
	TestReady();

	readyEnv();
	TestWriteNew();
	TestWriteOld();
	TestNg();

	TestConclude();
}

/****************************************************************************/
/* T  v																	*/
/*        eXg													*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void readyEnv( void )
{
	unsigned short err;

	err = RfMkDir("\\SUBDIR");
	CHK_ERR_CODE(err, RF_OK,  "mkdir()");
}

/****************************************************************************/
/* T  v																	*/
/*        VKɃt@C쐬												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestWriteNew( void )
{
	TestWriteLarge( "\\root512.TXT", 512UL );
	TestWriteLarge( "\\root4k.txt", 4096UL+10UL );
	TestWriteLarge( "\\SUBDIR\\SUB512.txt", 512UL );
	TestWriteLarge( "\\SUBDIR\\SUB4K.TXT", 4096UL+10UL );
	TestWriteSmallFile( "\\rootsm.TXT" );
	TestWriteSmallFile( "\\SUBDIR\\small.TXT" );
	
}

/****************************************************************************/
/* T  v																	*/
/*        ㏑															*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestWriteOld( void )
{
	overWriteSm( "\\root512.TXT");
	overWriteSm( "\\root4k.txt");
	overWriteSm( "\\SUBDIR\\SUB512.txt");
	overWriteSm( "\\SUBDIR\\SUB4K.TXT");
	overWriteLarge( "\\rootSm.TXT", 512UL);
	overWriteLarge( "\\SUBDIR\\small.TXT", 4096UL+10UL);
}

/****************************************************************************/
/* T  v																	*/
/*        G[R[h̃`FbN											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestNg( void )
{
	unsigned short err;

	RfOpen("\\noname.txt", RF_OPEN_WRITE_OLD, &err );
	CHK_ERR_CODE(err, RF_ERR_NOT_FOUND, "open noName.txt[RF_ERR_NOT_FOUND]");

	RfOpen("\\root512.TXT", RF_OPEN_WRITE_NEW, &err );
	CHK_ERR_CODE(err, RF_ERR_ALREADY_EXIST, "open root512.TXT[RF_ERR_ALREADY_EXIST]");

}

/****************************************************************************/
/* T  v																	*/
/*        ̃TCY𒴂㏑											*/
/* p[^																*/
/*        pFileNmFt@C												*/
/*        len    Ft@C̒											*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void overWriteLarge( char * pFileNm, unsigned long len )
{
	T_RF_FCB * pFcb;
	unsigned short err;

	pFcb = RfOpen( pFileNm, RF_OPEN_WRITE_OLD, &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpen() overWriteLarge");
	if( pFcb )
	{
		err = RfWrite( pFcb, (char*)constWriteVal, &len);
		CHK_ERR_CODE(err, RF_OK, "RfWrite()");
		err = RfClose( pFcb );
		CHK_ERR_CODE(err, RF_OK, "RfClose()");
	}

}

/****************************************************************************/
/* T  v																	*/
/*        ̃TCY㏑											*/
/* p[^																*/
/*        pFileNmFt@C												*/
/*        len    Ft@C̒											*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void overWriteSm( char * pFileNm )
{
	const static char overChar[] = "ABCDEFGHIJKLM";
	T_RF_FCB * pFcb;
	unsigned short err;
	unsigned long len;

	pFcb = RfOpen( pFileNm, RF_OPEN_WRITE_OLD, &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpen() overWriteSm");
	if( pFcb )
	{
		len = 10;
		RfWrite(pFcb, (char*)overChar, &len);
		CHK_ERR_CODE(err, RF_OK, "over write()");
		err = RfClose( pFcb );
		CHK_ERR_CODE(err, RF_OK, "RfClose()");
	}

}

