/****************************************************************************/
/* T  vF eXgP[XIėp@\										*/
/*   F eXgŎgpėp@\܂Ƃ߂								*/
/* 쐬F 2011.09.23														*/
/* XVF 2014.02.02														*/
/* Copyright    resove														*/
/****************************************************************************/
#include "RfInterface.h"
#include "TstWriteVal.h"
#include "TraceOut.h"


/****************************************************************************/
/* T  v																	*/
/*        t@C쐬											*/
/* p[^																*/
/*        pPathFt@Ci[ʒũpX										*/
/*        num  Ft@C鐔											*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestWriteMany( char * pPath, unsigned short num )
{
	T_RF_FCB * pFcb;
	unsigned short err;
	unsigned long len;
	unsigned short i;
	char flName[32];
	unsigned short nameIx;
	char editBuff[32];

	for( i = 0; pPath[i] != '\0'; ++i )
	{
		flName[i] = pPath[i];
	}

	nameIx = i;
	for( i = 0; i < num; ++i )
	{
		numToChar( &flName[nameIx], (unsigned long)i, 1000L);
		pFcb = RfOpen( flName, RF_OPEN_WRITE_NEW, &err );
		rfStrCpy( editBuff, "RfOpen() ", 32);
		rfStrCat( editBuff, flName, 32,32);
		CHK_ERR_CODE(err, RF_OK, editBuff);
		if( pFcb )
		{
			len = nameIx + 3;
			err = RfWrite( pFcb, flName, &len);
			CHK_ERR_CODE(err, RF_OK, "RfWrite()");
			err = RfClose( pFcb );
			CHK_ERR_CODE(err, RF_OK, "RfClose()");
		}
	}
	
}

/****************************************************************************/
/* T  v																	*/
/*        傫f[^												*/
/* p[^																*/
/*        pFileNmFt@C												*/
/*        len    Ft@C̒											*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestWriteLarge( char * pFileNm, unsigned long len )
{
	T_RF_FCB * pFcb;
	unsigned short err;

	pFcb = RfOpen( pFileNm, RF_OPEN_WRITE_NEW, &err );
	CHK_ERR_CODE(err, RF_OK, "RfOpen(RF_OPEN_WRITE_NEW)");
	if( pFcb )
	{
		err = RfWrite( pFcb, (char*)constWriteVal, &len);
		CHK_ERR_CODE(err, RF_OK, "RfWrite()");
		err = RfClose( pFcb );
		CHK_ERR_CODE(err, RF_OK, "RfClose()");
	}

}

/****************************************************************************/
/* T  v																	*/
/*        P̃t@C쐬											*/
/* p[^																*/
/*        flNameFt@C												*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/****************************************************************************/
void TestWriteSmallFile( char * flName )
{
	T_RF_FCB * pFcb;
	unsigned short err = RF_OK;
	unsigned long len;									/* eXgΏۂ̃t@CTCY */
	char editBuff[60];

	pFcb = RfOpen( flName, RF_OPEN_WRITE_NEW, &err );
	if( pFcb )
	{
		len = 10UL;
		err = RfWrite( pFcb, (char*)constWriteVal, &len );
		CHK_ERR_CODE(err, RF_OK, "RfWrite()");
		err = RfClose( pFcb );
		CHK_ERR_CODE(err, RF_OK, "RfClose()");
	}
	rfStrCpy( editBuff, "write ", 60);
	rfStrCat( editBuff, flName, 60, 50);
	CHK_ERR_CODE(err, RF_OK, editBuff);
}
