#include "stdafx.h"
#include "Winioctl.h"
#include "traceout.h"
#include "deviceSearch.h"

#define VOLUME_NAME_SIZE (256)

//////////////////////////////////////////////////////////
// ȉQ
// http://msdn.microsoft.com/ja-jp/library/cc429126.aspx
// http://msdn.microsoft.com/ja-jp/library/cc429128.aspx

void driveInfo( TCHAR * faceName );
void pathToVolume( TCHAR * faceName );
void faceToPhysicalNo( TCHAR * faceName );

//////////////////////////////////////////////////////////
// 
deviceSearch::deviceSearch( void )
{
	currentDriveNo = 0;
	currentDriveLetter = 0;
}

////////////////////////////////////////////
// ŏ̕hCu擾
// ߂lF-1 ͕hCuȂ
//          ȊȌꍇ͕hCu̔ԍ
DWORD deviceSearch::getFirstPhysicalDrive( void )
{
	currentDriveNo = 0;
	currentDriveLetter = 0;
	searchPhysicalDrive();
	searchDriveLetter();

	DWORD firstPhysicalDrive = -1;
	currentDriveNo = 0;
	for( DWORD i = 0; i < PHYSICAL_DRIVE_NUM; i++ )
	{
		if( physicalDrive[i].exist == true )
		{
			firstPhysicalDrive = i;
			currentDriveNo = i;
			break;
		}
	}
	return firstPhysicalDrive;
}

////////////////////////////////////////////
// hCu擾
// ŏ getFirstPhysicalDrive() sǍ getNextPhysicalDrive()
// sԂɗLȕhCu̔ԍ擾B
// ߂lF-1 ͕hCuȂ
//          ȊȌꍇ͕hCu̔ԍ
DWORD deviceSearch::getNextPhysicalDrive( void )
{
	DWORD physicalDriveNo = -1;
	for( DWORD i = currentDriveNo + 1; i < PHYSICAL_DRIVE_NUM; i++ )
	{
		if( physicalDrive[i].exist == true )
		{
			physicalDriveNo = i;
			currentDriveNo = i;
			break;
		}
	}
	return physicalDriveNo;
}

//////////////////////////////////////////////////////////////////////
// w肵hCu media type 擾
MEDIA_TYPE deviceSearch::getMediaType( DWORD physicalDriveNo )
{
	MEDIA_TYPE mediaType = Unknown;
	if( physicalDriveNo < PHYSICAL_DRIVE_NUM )
	{
		if( physicalDrive[physicalDriveNo].exist == true )
		{
			mediaType = physicalDrive[physicalDriveNo].mediaType;
		}
	}

	return mediaType;
}

//////////////////////////////////////////////////////////////////////
// w肵hCu̍ŏ drive letter 擾
// ꍇ c:́uCvȂǂ̕
// Ȃꍇ 0
TCHAR deviceSearch::getFirstDriveLetter( DWORD physicalDriveNo )
{
	TCHAR driveLetterChar = 0;

	if( physicalDriveNo < PHYSICAL_DRIVE_NUM )
	{
		if( physicalDrive[physicalDriveNo].exist == true )
		{
			currentDriveLetter = 0;
			driveLetterChar = physicalDrive[physicalDriveNo].driveLetter[currentDriveLetter];
		}
	}

	return driveLetterChar;
}

//////////////////////////////////////////////////////////////////////
// w肵hCu̎ drive letter 擾
// ꍇ c:́uCvȂǂ̕
// Ȃꍇ 0
// !
// getFirstDriveLetter() Ŏw肵hCuԍƈႤhCuԍ
// w肵ꍇ͕̓ۏ؂ȂB
// drive letter ̈ʒu͂P̕ϐŕێĂ蕨hCuԍ̊Ǘ͂ȂĂȂB
TCHAR deviceSearch::getNextDriveLetter( DWORD physicalDriveNo )
{
	TCHAR driveLetterChar = 0;

	if( physicalDriveNo < PHYSICAL_DRIVE_NUM )
	{
		if( physicalDrive[physicalDriveNo].exist == true )
		{
			if( (currentDriveLetter+1) < DRIVE_LETTER_NUM )
			{
				currentDriveLetter++;
				driveLetterChar = physicalDrive[physicalDriveNo].driveLetter[currentDriveLetter];
			}
		}
	}

	return driveLetterChar;
}

//////////////////////////////////////////////////////////////////////
// w̕hCuLׂ
bool  deviceSearch::isExist( DWORD physicalDriveNo )
{
	bool exist = false;
	if( physicalDriveNo < PHYSICAL_DRIVE_NUM )
	{
		exist = physicalDrive[physicalDriveNo].exist;
	}
	
	return exist;
}
//////////////////////////////////////////////////////////////////////
// w̕hCũfBATCY擾
LONGLONG deviceSearch::getSize( DWORD physicalDriveNo )
{
	LONGLONG size = 0;
	if( physicalDriveNo < PHYSICAL_DRIVE_NUM )
	{
		size = physicalDrive[physicalDriveNo].size;
	}
	
	return size;
}

//////////////////////////////////////////////////////////////////////
// physicaldrive B
// foCX̗LƃfBA^Cvi[
void deviceSearch::searchPhysicalDrive( void )
{
	DWORD retNum = 0;
	TCHAR driveName[] = _T("\\\\.\\PhysicalDrive0");

	for( DWORD i = 0; i < PHYSICAL_DRIVE_NUM; i++ )
	{
		driveName[17] = _T('0') + (TCHAR)i;
		HANDLE handle = CreateFile(driveName,						// t@C
										0,							// ANZX[h
										0,							// L[h
										NULL,						// ZLeBLqq
										OPEN_EXISTING,				// 쐬@
										FILE_ATTRIBUTE_NORMAL,		// t@C
										NULL						// ev[gt@C̃nh
										);
		if( handle != INVALID_HANDLE_VALUE )
		{
			physicalDrive[i].clean();
			physicalDrive[i].exist = true;							// foCX݂̑}[N

			DWORD retNum;
			DISK_GEOMETRY	diskGeometry;
			// fBXN^Cv擾
			if( DeviceIoControl(handle,								// handle to device
								IOCTL_DISK_GET_DRIVE_GEOMETRY,		// dwIoControlCode
								NULL,								// lpInBuffer
								0,									// nInBufferSize
								&diskGeometry,						// output buffer
								sizeof(DISK_GEOMETRY),				// size of output buffer
								&retNum,							// number of bytes returned
								NULL								// OVERLAPPED structure
								)  )
			{
				physicalDrive[i].mediaType =diskGeometry.MediaType;	// fBA^Cvۑ
			}

			// DISK_GEOMETRY_EX gƎ̃TCY擾ł
			// fBXNTCY擾
			// Awindows2000 ȍ~Ή
			DISK_GEOMETRY_EX diskGeometryEx;
			if( DeviceIoControl(handle,							// handle to device
							IOCTL_DISK_GET_DRIVE_GEOMETRY_EX,	// dwIoControlCode
							NULL,								// lpInBuffer
							0,									// nInBufferSize
							&diskGeometryEx,					// output buffer
							sizeof(DISK_GEOMETRY_EX),			// size of output buffer
							&retNum,							// number of bytes returned
							NULL								// OVERLAPPED structure
							)  )
			{
				physicalDrive[i].size =
							((LONGLONG)diskGeometryEx.DiskSize.LowPart) & 0x00000000ffffffff |
							((LONGLONG)diskGeometryEx.DiskSize.HighPart << 32);
			}
			CloseHandle( handle );
		}
	}
}

//////////////////////////////////////////////////////////////////////
// drive letter B
// hCu^[ƕfoCX֘At
void deviceSearch::searchDriveLetter( void )
{

	DWORD retNum = 0;
	TCHAR driveLetter[] = _T("\\\\.\\A:");

	for( TCHAR drive = _T('A'); drive <= _T('Z'); drive++ )
	{
		driveLetter[4] = drive;
		HANDLE handle = CreateFile(driveLetter,						// t@C
										0,							// ANZX[h
										0,							// L[h
										NULL,						// ZLeBLqq
										OPEN_EXISTING,				// 쐬@
										FILE_ATTRIBUTE_NORMAL,		// t@C
										NULL						// ev[gt@C̃nh
										);
		if( handle != INVALID_HANDLE_VALUE )
		{
			// foCX̕ԍ擾
			STORAGE_DEVICE_NUMBER storageDeviceNumber;
			if( DeviceIoControl(handle,							// handle to device
							IOCTL_STORAGE_GET_DEVICE_NUMBER,	// dwIoControlCode
							NULL,								// lpInBuffer
							0,									// nInBufferSize
							&storageDeviceNumber,				// output buffer
							sizeof(STORAGE_DEVICE_NUMBER),		// size of output buffer
							&retNum,							// number of bytes returned
							NULL								// OVERLAPPED structure
							)  )
			{
				if( storageDeviceNumber.PartitionNumber != -1 )
				{
					// Ή镨foCXɃhCu^[i[
					for( DWORD i = 0; i < DRIVE_LETTER_NUM; i++ )
					{
						if( physicalDrive[storageDeviceNumber.DeviceNumber].driveLetter[i] == NULL )
						{
							physicalDrive[storageDeviceNumber.DeviceNumber].driveLetter[i] = drive;
							break;
						}
					}
				}
			}
			CloseHandle( handle );
		}
	}
}

