/****************************************************************************/
/* T  vF t@CVXe FAT obt@Ǘ֘A							*/
/*   F foCXtbgȃƂăANZXł悤ɂB		*/
/* 쐬F 2004.12.19														*/
/* XVF 2011.08.20														*/
/* Copyright	resove														*/
/****************************************************************************/
#include "RfDiskLayout.h"
#include "RfInterface.h"
#include "RfControlBuff.h"
#include "RfGeneral.h"

/****************************************************************************/
/* Oϐ																	*/
/****************************************************************************/
extern const unsigned short	RfGenBuffSize;
extern const unsigned short	RfGenBuffNum;

/* obt@̊m */
extern char RfGenBuff[];

/* obt@Ǘ̈ */
extern T_RF_FILE_BUFF RfGenBuffCtrl[];
static T_RF_FILE_BUFF * useDrvResource = NULL;	/* read/writeobt@ */

/****************************************************************************/
/* ϐ																	*/
/****************************************************************************/


/****************************************************************************/
/* obt@Ǘ̈̎܂Ƃ												*/
/****************************************************************************/
typedef struct t_buff_ctrl_unify
{
	T_RF_FILE_BUFF *buffCtrl;				/* obt@Ǘ̈zւ̃|C^	*/
	unsigned short buffNum;					/* obt@			*/
	unsigned char canWriteFlag:1;			/* write \tO	*/
	unsigned char fill;						/* 				*/
} T_BUFF_CTRL_UNIFY;

/* { static ɂeXgł̓eύXĂ */
T_BUFF_CTRL_UNIFY buffCtrlUnify = {			/* FATobt@܂Ƃ	*/
	&RfGenBuffCtrl[0],						/* buffCtrl			*/
	0,										/* buffNum			*/
	FALSE,									/* canWriteFlag		*/
	0										/* fill				*/
};



/****************************************************************************/
/* ֐																	*/
/****************************************************************************/
unsigned short checkDriverFunction( void );						/* hCo@\̃`FbN */
static T_RF_FILE_BUFF * FindInBuff( unsigned long addr );
static T_RF_FILE_BUFF * FindFreeBuff( void );
static unsigned short UpdateBuff( unsigned long addr,
								  char * data,
								  unsigned long len,
								  short useOrg );			/* obt@f[^XV */
static unsigned short FillBuff( unsigned long addr,
									char data,
									unsigned long len );	/* obt@f[^w̒lŖ߂ */
static unsigned short OneBuffUpdate( unsigned long addr,
									 char * data,
									 unsigned long *len,
									 short useOrg );		/* P̃obt@̃f[^XV	*/
static unsigned short OneBuffFill(  unsigned long addr,
									 char data,
									 unsigned long *len );	/* P̃obt@̃f[^FILL	*/
static unsigned short TakeBuffData( unsigned long addr,
									char * data,
									unsigned long len );	/* obt@f[^擾 */
static unsigned short OneBuffTake( unsigned long addr,
								   char * data,
								   unsigned long *len );	/* P̃obt@̃f[^擾	*/
static unsigned short CheckInAddr( unsigned long addr,
								   T_RF_FILE_BUFF ** buffCtrl,
								   short useOrg);		/* YAhXobt@擾 */
static unsigned short physicalCopy( unsigned long distAddr,
								 unsigned long srcAddr,
								 unsigned short len );			/* Rs[ */
static unsigned short FlushNear( unsigned long addr,
								T_RF_FILE_BUFF ** freeBuff );	/* ߂obt@𕨗Iɏ */

static unsigned short waitReadTarget( T_RF_FILE_BUFF * buffCtrl,
								unsigned short target );		/* 񓯊 read ̕Kvf[^擾҂ */
static unsigned short waitWriteTarget( T_RF_FILE_BUFF * buffCtrl,
								unsigned short target );		/* 񓯊 write ̃obt@҂ */
static unsigned short waitResource( void );							/* 񓯊read/write @\҂	*/

/* reflectAll  mode */
static unsigned short reflectAll( void );			/* obt@܂Ƃ߂ɏobt@foCXɏ */
static unsigned short reflectABuffer( T_RF_FILE_BUFF * buffCtrl );	/* obt@tbV	*/
static void ClearBuff( T_RF_FILE_BUFF * buffCtrl );				/* obt@NA	*/
static unsigned short checkMaxPow( unsigned short org );/* org ȉ̍ő̂Qׂ̂̐T */

/****************************************************************************/
/* T  v																	*/
/*        obt@												*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*       																	*/
/* 																		*/
/*        obt@̓ubNTCYŕBobt@TCYubNTC	*/
/*       Y̏ꍇ̓obt@1ƂB								*/
/****************************************************************************/
unsigned short RfbInitBuff( void )
{
	unsigned short retCode = RF_OK;
	unsigned short blockSize;							/* ubNTCY */
	unsigned short buffUnitSize;						/* 1̃obt@TCY */
	T_RF_FILE_BUFF * pBuffCtrl;
	unsigned short i;

	if( RfGenBuffSize < 2 )
	{
		/* obt@TCYs */
		retCode = RF_ERR_BUFF_LEN;
		goto ERR_EXIT;
	}

	/* hCo@\̃`FbN */
	retCode = checkDriverFunction( );
	if( retCode != RF_OK )				goto ERR_EXIT;

	retCode = drvInitialize();			/* hCo */
	if( retCode != RF_OK )				goto ERR_EXIT;

	/* ubNTCYɉăobt@ύX */
	blockSize = drvGetBlockSize();
	if( RfGenBuffSize >= blockSize )
	{
		buffCtrlUnify.buffNum = RfGenBuffSize / blockSize;
		buffUnitSize = blockSize;
		buffCtrlUnify.canWriteFlag = TRUE;
	}
	else
	{
		buffCtrlUnify.buffNum = 1;
		buffUnitSize = checkMaxPow( RfGenBuffSize );
		buffCtrlUnify.canWriteFlag = FALSE;
	}
	if( rfDriverInterface.write == NULL )
	{
		buffCtrlUnify.canWriteFlag = FALSE;			/* write @\ */
	}
	if( buffCtrlUnify.buffNum > RfGenBuffNum )
	{
		/* G[ */
		retCode = RF_ERR_SECTOR_SIZE;				/* ubNTCYG[ */
		goto ERR_EXIT;
	}

	/* FAT obt@ */
	pBuffCtrl = buffCtrlUnify.buffCtrl;				/* obt@ǗAhX	*/
	for( i = 0; i < buffCtrlUnify.buffNum; ++i )
	{
		pBuffCtrl->cardAddr = 0UL;
		pBuffCtrl->buffAddr = &RfGenBuff[i*buffUnitSize];
		pBuffCtrl->buffSize = buffUnitSize;
		pBuffCtrl->useFlag = FALSE;
		pBuffCtrl->updateFlag = FALSE;
		pBuffCtrl->justReadFlag = FALSE;
		pBuffCtrl->justWriteFlag = FALSE;

		pBuffCtrl++;
	}
	
	useDrvResource = NULL;

ERR_EXIT:
	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        hCo֐̗L`FbN									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        RF_OK																*/
/* 																		*/
/*        t@CANZX邽߂̍Œ̃hCo֐L𒲂ׂB		*/
/****************************************************************************/
unsigned short checkDriverFunction( void )
{
	unsigned short success = RF_OK;

	/* KvȃhCo֐L`FbN */
	if( ( rfDriverInterface.initialize   == NULL ) ||
		( rfDriverInterface.read         == NULL ) ||
		( rfDriverInterface.getBlockSize == NULL ) ||
		( rfDriverInterface.getCapacity  == NULL ) )
	{
		success = RF_ERR_DEFINE_DRIVER;
	}

	return success;
}

/****************************************************************************/
/* T  v																	*/
/*        obt@ǗăXg[Wǂݎ						*/
/* p[^																*/
/*        addrFAhX													*/
/*        dataFXVf[^												*/
/*        len F														*/
/* ߂l																	*/
/*        RF_OK F														*/
/*        RF_ERR_... s													*/
/* 																		*/
/****************************************************************************/
unsigned short RfbRead( unsigned long addr, char * data, unsigned long len )
{
	unsigned short retCode = RF_OK;				/* ߂l */

	retCode = TakeBuffData( addr,
							data,
							len );			/* obt@f[^o */
	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        wAhX̃obt@mۂȂ								*/
/* p[^																*/
/*        addrFAhX													*/
/* ߂l																	*/
/*        RF_OK F														*/
/*        RF_ERR_... s													*/
/* 																		*/
/*        addr ̓ZN^̐擪AhXłȂ΂ȂȂB					*/
/*        addr ̂PZN^obt@ɓǂݎ铮JnB			*/
/****************************************************************************/
unsigned short RfbPostSecureRead( unsigned long addr )
{
	unsigned short retCode = RF_ERR_DEFINE_DRIVER;				/* ߂l */
	T_RF_FILE_BUFF * insideBuffCtrl;

	if( rfDriverInterface.readPoll  != NULL )
	{
		retCode = CheckInAddr( addr, &insideBuffCtrl, TRUE );
	}
	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        wAhX̃obt@mۂȂ								*/
/* p[^																*/
/*        addrFAhX													*/
/*        useOrgFAhX													*/
/* ߂l																	*/
/*        RF_OK F														*/
/*        RF_ERR_... s													*/
/* 																		*/
/*        addr ̓ZN^̐擪AhXłȂ΂ȂȂB					*/
/*        addr ̂PZN^Ԃ̃obt@mۂB						*/
/*        ֐͏ݎɎgp邱Ƃz肵ĂBXVobt@	*/
/*       e𕨗foCXɏ݃obt@󂯂Bǂݎ͂Ȃ	*/
/*       ȂB																*/
/****************************************************************************/
unsigned short RfbPostSecureWrite( unsigned long addr )
{
	unsigned short retCode = RF_ERR_DEFINE_DRIVER;				/* ߂l */
	T_RF_FILE_BUFF * insideBuffCtrl;

	if( ( rfDriverInterface.write  != NULL ) &&
		( rfDriverInterface.writePoll  != NULL ) )
	{
		retCode = CheckInAddr( addr, &insideBuffCtrl, FALSE );
	}
	return retCode;
}


/****************************************************************************/
/* T  v																	*/
/*        wAhX̃f[^擾									*/
/* p[^																*/
/*        addrFAhX													*/
/*        dataFXVf[^												*/
/*        len F														*/
/* ߂l																	*/
/*        RF_OK F														*/
/*        RF_ERR_... s													*/
/*   																	*/
/*        w肳ꂽobt@f[^擾B							*/
/****************************************************************************/
unsigned short TakeBuffData( unsigned long addr, char * data, unsigned long len )
{
	unsigned short retCode = RF_ERR_BUFF_TAKE;	/* ߂l	 */
	unsigned long takeLen;						/* o */
	unsigned long remainLen;					/* c蒷 */

	remainLen = len;
	for( ; ; )
	{
		if( remainLen == 0 )	break;
		takeLen = remainLen;
		retCode = OneBuffTake( addr, data, &takeLen );	/* obt@o */
		if( retCode != RF_OK )	break;			/* 擾G[ */
		if( takeLen == 0 )
		{
			retCode = RF_ERR_BUFF_TAKE;			/* f[^oȂ */
			break;
		}
		if( takeLen >= remainLen )	break;		/* Ō܂ŎôŏI */
		remainLen -= takeLen;					/* c̒XV */
		data += takeLen;						/* f[^ʒuXV	*/
		addr += takeLen;						/* foCXAhXXV	*/
	}

	return retCode;
}
/****************************************************************************/
/* T  v																	*/
/*        wAhX̃f[^擾									*/
/* p[^																*/
/*        addrFAhX													*/
/*        dataFXVf[^												*/
/*        len F														*/
/*              ow肷邪s͎ۂɎoi[	*/
/*             B														*/
/* ߂l																	*/
/*        RF_OK F														*/
/*        RF_ERR_... s													*/
/*   																	*/
/*         P̃obt@o邾̃f[^oBobt@	*/
/*         ɂ܂ꍇ͌ĂяoōēxAAAhX𒲐		*/
/*         OneBuffTake()s邱ƁB									*/
/****************************************************************************/
unsigned short OneBuffTake( unsigned long addr, char * data, unsigned long * len )
{

	unsigned short retCode;
	T_RF_FILE_BUFF * buffCtrl;
	char * buffCurr;
	unsigned long i;
	unsigned long cardEnd;
	unsigned long canTakeLen;
	unsigned short inBuffNeed;


	retCode = CheckInAddr( addr, &buffCtrl, TRUE);			/* YAhX܂ރobt@擾 */


	if( retCode == RF_OK )
	{
		/* obt@̃f[^o */
		cardEnd = buffCtrl->cardAddr + (unsigned long)buffCtrl->buffSize;	/* obt@̂K̃AhX + 1*/
		canTakeLen = *len;
		if( (addr + *len) > cardEnd )
		{
			canTakeLen = cardEnd - addr;	/* o\ȒvZ */
		}
		buffCurr = buffCtrl->buffAddr + (addr - buffCtrl->cardAddr);

		/* obt@XV͕Kvȃf[^ǂ߂܂ő҂ */
		if( buffCtrl == useDrvResource )
		{
			inBuffNeed = (unsigned short)((addr - buffCtrl->cardAddr) + canTakeLen);
			retCode = waitReadTarget( buffCtrl, inBuffNeed );
		}

		if( retCode == RF_OK ) {
			/* Kvȃf[^擾 */
			for( i = 0; i < canTakeLen; ++i )
			{
				 (*data) = (*buffCurr);
				 buffCurr++;
				 data++;
			}
			*len = canTakeLen;					/* o */
			retCode = RF_OK;
		}
	}

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        œ삵Ăǂݎ肪wʒu܂Ŋ̂҂			*/
/* p[^																*/
/*        buffCtrlFobt@Ǘf[^ubN								*/
/*        target  FړĨf[^ʒu										*/
/* ߂l																	*/
/*        RF_OK F														*/
/*        RF_ERR_... s													*/
/*   																	*/
/*        																	*/
/****************************************************************************/
unsigned short waitReadTarget( T_RF_FILE_BUFF * buffCtrl, unsigned short target )
{
	unsigned short ret = RF_OK;

	if( buffCtrl->justReadFlag != 0 )
	{
		ret = RF_ERR_DEFINE_DRIVER;
		
		if( ( rfDriverInterface.read      != NULL ) &&
			( rfDriverInterface.readPoll  != NULL ) )
		{
			ret = RF_OK;

			/* ړIʒu܂ł̃f[^̂҂ */
			while( target > buffCtrl->completeSize )
			{
				ret = drvReadPoll( &buffCtrl->completeSize );
				if( ret != RF_OK )
				{
					break;
				}
			}
			
			/* obt@ׂ̏Ċ̂ōXVtO𗎂Ƃ */
			if( buffCtrl->completeSize >= buffCtrl->buffSize )
			{
				buffCtrl->justReadFlag = FALSE;
				useDrvResource = NULL;
			}
		}
	}
	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*        œ삵Ă鏑݂wʒu܂Ŋ̂҂			*/
/* p[^																*/
/*        buffCtrlFobt@Ǘf[^ubN								*/
/*        target  FړĨf[^ʒu										*/
/* ߂l																	*/
/*        RF_OK F														*/
/*        RF_ERR_... s													*/
/*   																	*/
/*        																	*/
/****************************************************************************/
unsigned short waitWriteTarget( T_RF_FILE_BUFF * buffCtrl, unsigned short target )
{
	unsigned short ret = RF_OK;

	if( buffCtrl->justWriteFlag != FALSE )
	{
		ret = RF_ERR_DEFINE_DRIVER;
		if( ( rfDriverInterface.write  != NULL ) &&
			( rfDriverInterface.writePoll  != NULL ) )
		{
			ret = RF_OK;

			/* ړIʒu܂ł̃f[^̂҂ */
			while( target > buffCtrl->completeSize )
			{
				ret = drvWritePoll( &buffCtrl->completeSize );
				if( ret != RF_OK )
				{
					break;
				}
			}

			/* obt@ׂ̏Ċ̂ōXVtO𗎂Ƃ */
			if( buffCtrl->completeSize >= buffCtrl->buffSize )
			{
				buffCtrl->justWriteFlag = FALSE;
				useDrvResource = NULL;
			}
		}
	}
	return ret;
}

/****************************************************************************/
/* T  v																	*/
/*        œ삵Ăǂݎ⏑݂obt@܂ő҂	*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        RF_OK F														*/
/*        RF_ERR_... s													*/
/*   																	*/
/*        																	*/
/****************************************************************************/
unsigned short waitResource( void )
{
	unsigned short err = RF_OK;

	if( useDrvResource != NULL )
	{
		err = waitReadTarget(useDrvResource, useDrvResource->buffSize);
		if( ( err == RF_OK ) &&
			( useDrvResource != NULL ) )
		{
			err = waitWriteTarget(useDrvResource, useDrvResource->buffSize);
		}
	}
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        obt@ǗăXg[WXV							*/
/* p[^																*/
/*        addrFAhX													*/
/*        dataFXVf[^												*/
/*        len F														*/
/*        useOrg FTRUE̒lgpAFALSE:VKɃf[^			*/
/* ߂l																	*/
/*        RF_OK F														*/
/*        RF_ERR_... s													*/
/*   																	*/
/*        useOrg  TRUE ̍ۂɂ͎wAhXɏẴf[^		*/
/*       obt@ɓǂ݂łeB							*/
/*        FALSE ̍ۂ͓ǂݎ͂Ȃ킸݂ȂB̂߃Z	*/
/*       N^̈ꕔہAȂ̃f[^e͕ۏ؂	*/
/*       ȂB															*/
/****************************************************************************/
unsigned short RfbWrite( unsigned long addr, char * data, unsigned long len, short useOrg )
{
	unsigned short retCode = RF_ERR_CANT_WRITE_FOR_BUFF;	/* ߂l	iobt@sɂ菑sj */

	if( buffCtrlUnify.canWriteFlag != FALSE )
	{
		retCode = UpdateBuff( addr,
							  data,
							  len,
							  useOrg );				/* obt@ւ̏ */
	}
	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        obt@ǗăXg[W𖄂߂							*/
/* p[^																*/
/*        addrFAhX													*/
/*        dataFXVf[^												*/
/*        len F														*/
/* ߂l																	*/
/*        RF_OK F														*/
/*        RF_ERR_... s													*/
/*   																	*/
/*        																	*/
/****************************************************************************/
unsigned short RfbFill( unsigned long addr, char data, unsigned long len )
{
	unsigned short retCode = RF_ERR_CANT_WRITE_FOR_BUFF;	/* ߂l	iobt@sɂ菑sj */

	if( buffCtrlUnify.canWriteFlag != FALSE )
	{
		retCode = FillBuff(   addr,
							  data,
							  len );				/* obt@ւ̏ */
	}
	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        obt@f[^XV											*/
/* p[^																*/
/*        addrFAhX													*/
/*        dataFXVf[^												*/
/*        len F														*/
/* ߂l																	*/
/*       																	*/
/*   																	*/
/*        obt@f[^XVB										*/
/*         OneBuffUpdate()͂P̃obt@XVAXV	*/
/*        ĂBf[^Ȃ܂ OneBuffUpdate()JԂB		*/
/****************************************************************************/
unsigned short UpdateBuff( unsigned long addr, char * data, unsigned long len, short useOrg )
{
	unsigned short retCode = RF_ERR_BUFF_UPDATE;/* ߂l	*/
	unsigned long updateLen;					/* XV */
	unsigned long remainLen;					/* c蒷 */

	remainLen = len;
	for( ; ; )
	{
		if( remainLen == 0 )	break;
		updateLen = remainLen;
		retCode = OneBuffUpdate( addr, data, &updateLen, useOrg );	/* obt@ւ̏ */
		if( retCode != RF_OK )	break;			/* ݃G[ */
		if( updateLen == 0 )
		{
			retCode = RF_ERR_BUFF_UPDATE;		/* f[^XVȂ */
			break;
		}
		if( updateLen >= remainLen )	break;	/* Ō܂ŏ񂾂̂ŏI */
		remainLen -= updateLen;					/* c̒XV */
		data += updateLen;						/* f[^ʒuXV	*/
		addr += updateLen;						/* foCXAhXXV	*/
	}

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        obt@f[^w肳ꂽlŖ߂								*/
/* p[^																*/
/*        addrFAhX													*/
/*        dataF߂l													*/
/*        len F														*/
/* ߂l																	*/
/*       																	*/
/*   																	*/
/*        obt@f[^XVB										*/
/*         OneBuffFill()͂P̃obt@XVAXVԂ	*/
/*        Bf[^Ȃ܂ OneBuffFill()JԂB			*/
/****************************************************************************/
unsigned short FillBuff( unsigned long addr, char data, unsigned long len )
{
	unsigned short retCode = RF_ERR_BUFF_UPDATE;/* ߂l	*/
	unsigned long updateLen;					/* XV */
	unsigned long remainLen;					/* c蒷 */

	remainLen = len;
	for( ; ; )
	{
		if( remainLen == 0 )	break;
		updateLen = remainLen;
		retCode = OneBuffFill( addr, data, &updateLen );	/* obt@ւ̏ */
		if( retCode != RF_OK )	break;			/* ݃G[ */
		if( updateLen == 0 )
		{
			retCode = RF_ERR_BUFF_UPDATE;		/* f[^XVȂ */
			break;
		}
		if( updateLen >= remainLen )	break;	/* Ō܂ŏ񂾂̂ŏI */
		remainLen -= updateLen;					/* c̒XV */
		addr += updateLen;						/* foCXAhXXV	*/
	}

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        obt@f[^XV											*/
/* p[^																*/
/*        addrFAhX													*/
/*        dataFXVf[^												*/
/*        len Fi[Ă̈ւ̃|C^						*/
/*              obt@̋؂Ȃǂ̂߂ɓr܂łXVłȂ	*/
/*             ͎c̒ݒ肷B										*/
/*        useOrg FTRUE:UǂݍށAFALSEFǂݍ݂͂ȂȂ			*/
/* ߂l																	*/
/*       RF_OK 															*/
/*       RF_ERR_... ̃G[AG[R[hɂĂ̓wb_QƂ	*/
/*                  ƁB													*/
/*   																	*/
/*         obt@ɂłɊYAhXǂݍ܂Ă΂̃obt@	*/
/*        XVBobt@ɓǂݍ܂ĂȂꍇłׂẴobt@g	*/
/*        pĂ鎞͍łÂobt@foCXɏ݃obt@̋	*/
/*        B														*/
/*         obt@̋󂫂ɊYAhX܂ރf[^ǂݍ݂XV	*/
/*        B																*/
/*         ̊֐ł͂P̃obt@XVȂ̂ŕobt@ɂ܂	*/
/*        悤ȏꍇ͎ۂɏ܂ꂽQƂs邱ƁB*/
/****************************************************************************/
unsigned short OneBuffUpdate( unsigned long addr, char * data, unsigned long *len, short useOrg )
{
	
	unsigned short retCode;
	T_RF_FILE_BUFF * buffCtrl;
	char * buffCurr;
	unsigned short targetPos;
	unsigned long i;
	unsigned long cardEnd;
	unsigned long canUpdateLen;

	retCode = CheckInAddr( addr, &buffCtrl, useOrg );			/* YAhX܂ރobt@mۂ */

	if( retCode == RF_OK )
	{
		/* obt@̃f[^XV */
		cardEnd = buffCtrl->cardAddr + (unsigned long)buffCtrl->buffSize;	/* obt@̂K̃AhX + 1*/
		canUpdateLen = *len;
		if( (addr + *len) > cardEnd ) canUpdateLen = cardEnd - addr;	/* \ȒvZ */
		buffCurr = buffCtrl->buffAddr + (addr - buffCtrl->cardAddr);
		targetPos = (unsigned short)((addr - buffCtrl->cardAddr) + canUpdateLen);

		/* obt@̎gp\ʒup\ɂȂ̂҂ */
		retCode = waitReadTarget( buffCtrl, targetPos );
		if( retCode == RF_OK )
		{


			retCode = waitWriteTarget( buffCtrl, targetPos );
			if( retCode == RF_OK )
			{
				for( i = 0; i < canUpdateLen; ++i )
				{
					(*buffCurr) = (*data);
					buffCurr++;
					data++;
				}

				buffCtrl->updateFlag = TRUE;			/* XVԂɂ */
				*len = canUpdateLen;					/* XV */
				retCode = RF_OK;
			}
		}
	}

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        obt@f[^w̒lŖ߂									*/
/* p[^																*/
/*        addrFAhX													*/
/*        dataF߂l													*/
/*        len Fi[Ă̈ւ̃|C^						*/
/*              obt@̋؂Ȃǂ̂߂ɓr܂łXVłȂ	*/
/*             ͎c̒ݒ肷B										*/
/* ߂l																	*/
/*       RF_OK 															*/
/*       RF_ERR_... ̃G[AG[R[hɂĂ̓wb_QƂ	*/
/*                 ƁB													*/
/*   																	*/
/*         obt@ɂłɊYAhXǂݍ܂Ă΂̃obt@	*/
/*        XVBobt@ɓǂݍ܂ĂȂꍇłׂẴobt@g	*/
/*        pĂ鎞͍łÂobt@foCXɏ݃obt@̋	*/
/*        B														*/
/*         obt@̋󂫂ɊYAhX܂ރf[^ǂݍ݂XV	*/
/*        B																*/
/*         ̊֐ł͂P̃obt@XVȂ̂ŕobt@ɂ܂	*/
/*        悤ȏꍇ͎ۂɏ܂ꂽQƂs邱ƁB*/
/****************************************************************************/
unsigned short OneBuffFill( unsigned long addr, char data, unsigned long *len )
{
	
	unsigned short retCode;
	T_RF_FILE_BUFF * buffCtrl;
	char * buffCurr;
	unsigned short targetPos;
	unsigned long i;
	unsigned long cardEnd;
	unsigned long canUpdateLen;

	retCode = CheckInAddr( addr, &buffCtrl, FALSE);			/* YAhX܂ރobt@mۂ */

	if( retCode == RF_OK )
	{
		/* obt@̃f[^XV */
		cardEnd = buffCtrl->cardAddr + (unsigned long)buffCtrl->buffSize;	/* obt@̂K̃AhX + 1*/
		canUpdateLen = *len;
		if( (addr + *len) > cardEnd ) canUpdateLen = cardEnd - addr;	/* \ȒvZ */
		buffCurr = buffCtrl->buffAddr + (addr - buffCtrl->cardAddr);
		targetPos = (unsigned short)((addr - buffCtrl->cardAddr) + canUpdateLen);

		/* obt@̎gp\ʒup\ɂȂ̂҂ */
		retCode = waitReadTarget( buffCtrl, targetPos );
		if( retCode == RF_OK )
		{
			retCode = waitWriteTarget( buffCtrl, targetPos );

			if( retCode == RF_OK )
			{
				for( i = 0; i < canUpdateLen; ++i )
				{
					(*buffCurr) = data;
					buffCurr++;
				}
				buffCtrl->updateFlag = TRUE;			/* XVԂɂ */
				*len = canUpdateLen;					/* XV */
				retCode = RF_OK;
			}
		}
	}

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        ǂݍݍς݂̃obt@ɎwAhX邩T					*/
/* p[^																*/
/*        addr    FTAhX											*/
/* ߂l																	*/
/*        obt@Rg[ւ̃AhX							*/
/*        Ȃ 0 ԂB										*/
/*   																	*/
/*        ǂݍݍς݂̃obt@ɎwAhX邩T					*/
/****************************************************************************/
T_RF_FILE_BUFF * FindInBuff( unsigned long addr )
{
	unsigned long i;
	T_RF_FILE_BUFF * retCode = (T_RF_FILE_BUFF *)NULL;
	T_RF_FILE_BUFF * pBuffCtrl;

	pBuffCtrl = buffCtrlUnify.buffCtrl;

	for( i = 0UL; i < buffCtrlUnify.buffNum; ++i )
	{
		if( pBuffCtrl->useFlag != FALSE )
		{
			if( ( pBuffCtrl->cardAddr <= addr ) &&
			    ( (pBuffCtrl->cardAddr+pBuffCtrl->buffSize) > addr ) )
			{
				retCode = pBuffCtrl;
				break;
			}
		}
		pBuffCtrl++;
	}
	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        gp̃obt@T											*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*       gp̃obt@Ǘ̈											*/
/*       gp̃obt@Ǘ̈悪Ȃꍇ NULLԂ			*/
/*   																	*/
/*        buffUnify 疢gp̃obt@TĕԂB						*/
/****************************************************************************/
T_RF_FILE_BUFF * FindFreeBuff( void )
{
	T_RF_FILE_BUFF * retCode = NULL;
	unsigned short i;
	T_RF_FILE_BUFF * pBuffCtrl;

	pBuffCtrl = buffCtrlUnify.buffCtrl;

	for( i = 0UL; i < buffCtrlUnify.buffNum; ++i )
	{
		if( pBuffCtrl->useFlag == FALSE )
		{
			retCode = pBuffCtrl;
			break;
		}
		pBuffCtrl++;
	}

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        ł߂AhX̃obt@foCXɏ					*/
/* p[^																*/
/*        addrFrAhX											*/
/*        freeBuffFɂȂobt@ǗubÑ|C^i[̈	*/
/* ߂l																	*/
/*       RF_ERR_BUFF_FLUSH ̏ꍇ֐Ăяos						*/
/*       RF_ERR_... ̑Iȏ݃G[							*/
/*       RF_OK       													*/
/*   																	*/
/*         addr ɍł߂obt@TfoCXɏށB				*/
/*          ݁AɂȂobt@𖢎gpԂɂB				*/
/*         gpĂobt@̂ FlushNear()s			*/
/*         RF_ERR_BUFF_FLUSH ̂ԂB										*/
/*          wAhX̑Oƌɓ߂̃obt@͑O	*/
/*          flushB̂ߌɌAɑǑʂŏ㏑B	*/
/*          ł߂obt@OɏI\B				*/
/****************************************************************************/
unsigned short FlushNear( unsigned long addr, T_RF_FILE_BUFF ** freeBuff )
{
	unsigned short retCode = RF_OK;						/* ߂l					*/
	T_RF_FILE_BUFF * pBuffCtrl;							/* obt@Ǘ̈			*/
	T_RF_FILE_BUFF * targetCtrl = NULL;					/* ̏Ȃobt@Ǘ̈	*/
	unsigned long diff = 0xffffffffUL;					/* Ƃ			*/
	unsigned long endAddr;								/* obt@̏I[ + 1			*/
	unsigned short i;									/* CfbNX					*/

	pBuffCtrl = buffCtrlUnify.buffCtrl;
	endAddr = addr + pBuffCtrl->buffSize;				/* wAhX̃obt@I[߂ */

	/* ł߂AhXT */
	/* ܂͌ */
	for( i = 0; i < buffCtrlUnify.buffNum; ++i )
	{
		if( ( pBuffCtrl->cardAddr >= addr ) && ( pBuffCtrl->useFlag != FALSE ) )
		{
			if( diff >= ( pBuffCtrl->cardAddr - addr ) )
			{
				/* obt@wAhX̌̎ */
				diff = pBuffCtrl->cardAddr - addr;
				targetCtrl = pBuffCtrl;
			}
		}
		pBuffCtrl++;
	}

	pBuffCtrl = buffCtrlUnify.buffCtrl;
	/* ɑO */
	/* 둤Ɠꍇ͑OōXV */
	for( i = 0; i < buffCtrlUnify.buffNum; ++i )
	{
		endAddr = pBuffCtrl->cardAddr + pBuffCtrl->buffSize;	/* obt@̏I[AhX߂ */
		if( ( endAddr <= addr ) && ( pBuffCtrl->useFlag != FALSE ) )
		{
			/* obt@wAhX̑O̎ */
			if( diff >= ( addr - endAddr ) )
			{
				diff = addr - endAddr;
				targetCtrl = pBuffCtrl;
			}
		}
		else if( ( pBuffCtrl->cardAddr <= addr ) && ( pBuffCtrl->useFlag != FALSE ) )
		{
			/* ݂̃obt@ɎwAhX܂܂Ă鎞 */
			retCode = RF_ERR_BUFF_FLUSH;
		}
		pBuffCtrl++;
	}
	
	/* obt@ */
	if( targetCtrl == NULL )
	{
		retCode = RF_ERR_BUFF_FLUSH;				/* gpobt@Ȃ̂ŃG[ */
	}
	else
	{
		if( targetCtrl->updateFlag != FALSE )
		{
			/* XVĂꍇ͏ */
			retCode = reflectABuffer( targetCtrl );	/* obt@Ǘ̈ */
		}
		*freeBuff = targetCtrl;
	}
	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        obt@ɎcĂf[^𕨗Iɏ					*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        RF_ERR_BUFF_FLUSH ̏ꍇ֐Ăяos						*/
/*        RF_ERR_... ̑Iȏ݃G[							*/
/*        RF_OK       													*/
/*   																	*/
/*        FAT obt@̓efoCXɏށBAނŃob*/
/*       t@̓e̓NAȂB											*/
/****************************************************************************/
unsigned short RfbReflect( void )
{
	return reflectAll(  );
}

/****************************************************************************/
/* T  v																	*/
/*        ׂẴobt@foCXɏ								*/
/* p[^																*/
/*        mode     FRF_BUFF_CLEAR  obt@NA					*/
/*                   RF_BUFF_KEEP   ނobt@̓NAȂ		*/
/* ߂l																	*/
/*       RF_ERR_BUFF_FLUSH ̏ꍇ֐Ăяos						*/
/*       RF_ERR_... ̑Iȏ݃G[							*/
/*       RF_OK       													*/
/*   																	*/
/*         ׂẴobt@foCXɏ								*/
/*         ݌Amode  RF_BUFF_CLEAR ̎͋ɂȂobt@𖢎g	*/
/*        pԂɂB													*/
/*          ̃obt@񂾏ꍇŕ̃G[AŌ	*/
/*        ɔG[߂lƂĕԂB								*/
/****************************************************************************/
unsigned short reflectAll( void )
{
	unsigned short retCode;
	T_RF_FILE_BUFF * pBuffCtrl;
	unsigned short i;

	retCode = RF_OK;
	pBuffCtrl = buffCtrlUnify.buffCtrl;
	for( i = 0; i < buffCtrlUnify.buffNum; ++i )
	{
		if( ( pBuffCtrl->useFlag != FALSE )  && ( pBuffCtrl->updateFlag != FALSE ) )
		{
			/* gpōXVĂobt@ */
			retCode = reflectABuffer( pBuffCtrl );		/*  */
			if( retCode != RF_OK )
			{
				break;
			}

			retCode = waitResource();
		}
		ClearBuff( pBuffCtrl );
		if( retCode != RF_OK )
		{
			break;
		}
		pBuffCtrl++;
	}

	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        P̃obt@foCXɏ								*/
/* p[^																*/
/*        buffCtrlFobt@Ǘ̈̃|C^								*/
/* ߂l																	*/
/*        RF_ERR_BUFF_FLUSH ̏ꍇ֐Ăяos						*/
/*        RF_ERR_... ̑Iȏ݃G[							*/
/*        RF_OK       													*/
/*   																	*/
/*         w肳ꂽobt@foCXɏ							*/
/*          ݂ȂŃobt@𖢎gpԂɂ͂ȂBA	*/
/*         foCXƂ̖͖Ȃiǂ񂾂̏ԂƈꏏɂȂĵ	*/
/*         XVtO̓NAB											*/
/****************************************************************************/
unsigned short reflectABuffer( T_RF_FILE_BUFF * buffCtrl )
{
	unsigned short retCode = RF_OK;
	
	if( buffCtrl->updateFlag != FALSE )
	{
		retCode = waitResource( );						/* \[X҂ */
		if( retCode == RF_OK )
		{
			retCode = drvWrite( buffCtrl->cardAddr,
								   buffCtrl->buffAddr,
								   buffCtrl->buffSize );	/* Iɏ */
			if( retCode == RF_OK )
			{
				buffCtrl->updateFlag = FALSE;				/* ݂ĂȂԂƂ */
				if( rfDriverInterface.writePoll != NULL )
				{
					buffCtrl->justWriteFlag = TRUE;			/* ݒ		*/
					buffCtrl->completeSize = 0;				/* ς݂̃TCY	*/
					useDrvResource = buffCtrl;				/* kick obt@		*/
				}
			}
		}
	}
	else
	{
		retCode = RF_ERR_BUFF_FLUSH;
	}
	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        obt@NA												*/
/* p[^																*/
/*        buffCtrlFobt@Ǘ̈̃|C^								*/
/* ߂l																	*/
/*        Ȃ																*/
/*   																	*/
/*        obt@̊Ǘ̈NA									*/
/****************************************************************************/
void ClearBuff( T_RF_FILE_BUFF * buffCtrl )
{
	buffCtrl->useFlag = FALSE;					/* gpƂ */
	buffCtrl->updateFlag = FALSE;				/* ݂ĂȂԂƂ */
	buffCtrl->cardAddr = 0UL;					/* foCXAhXNA */
	buffCtrl->completeSize = 0L;				/* XV̊TCY	*/

}

/****************************************************************************/
/* T  v																	*/
/*        wAhX̃obt@擾									*/
/* p[^																*/
/*        addrFfoCX̃AhX											*/
/*        buffCtrlF擾obt@Ǘ̈̃|C^Ԃʒu			*/
/*        useOrg  FTRUE:擾AhX̃f[^ǂށAFALSE:ǂ܂ȂB	*/
/* ߂l																	*/
/*       F RF_OK														*/
/*       RF_ERR_... ̃G[Aڍׂ̓wb_QƂ̂				*/
/* 																		*/
/*         obt@ɊYAhXǂݍ܂Ăꍇ͂̃obt@Ǘ	*/
/*        ԂBǂݍ܂ĂȂꍇ͐VɊYAhX܂ރfoCX	*/
/*        ̈ǂݍ݂̃obt@Ǘ̈ԂB						*/
/*          obt@Ǘ̈ɋ󂫂ꍇ͍ŌẪobt@Ǘ̈J[	*/
/*        hɔfĂɊYAhX܂ރfoCXf[^ǂݍށB	*/
/*          VK write ۂɂ͂ƂƏ܂Ăf[^ǂޕK	*/
/*         vB̂悤ȏꍇ useOrg  TRUE Ƃǂݍ܂Ƀob	*/
/*         t@gpB													*/
/****************************************************************************/
unsigned short CheckInAddr( unsigned long addr, T_RF_FILE_BUFF ** buffCtrl, short useOrg )
{
	unsigned short retCode = RF_OK;
	T_RF_FILE_BUFF * insideBuffCtrl;

	/* YAhXobt@ɓǂݍ܂Ă邩T */
	insideBuffCtrl = FindInBuff( addr );
	if( insideBuffCtrl != NULL )
	{
		*buffCtrl = insideBuffCtrl;		/* łɓǂݍ܂Ăobt@Ԃ */
	}
	else
	{
		/* ǂݍ܂ĂȂꍇ */
		insideBuffCtrl = FindFreeBuff( );	/* obt@̋󂫂T */
		retCode = RF_OK;
		if( insideBuffCtrl == NULL )
		{
			/* gpobt@Ȃ */
			/* ł߂obt@f[^Ńobt@󂯂 */
			retCode = FlushNear( addr, &insideBuffCtrl );		/* foCXɏ */
		}
		if( retCode == RF_OK )
		{
			addr = ( addr / insideBuffCtrl->buffSize )
							 * insideBuffCtrl->buffSize;	/* obt@TCY̋Eɍ킹 */
			insideBuffCtrl->cardAddr = addr;				/* f[^AhXi[ */
			insideBuffCtrl->useFlag = TRUE;					/* gpɂ */
			insideBuffCtrl->updateFlag = FALSE;				/* XVԂɂ */
			*buffCtrl = insideBuffCtrl;

			if( useOrg != FALSE )
			{
				/* Vȃobt@Ƀf[^ǂݍ */
				retCode = waitResource( );
				if( retCode == RF_OK )
				{
					if( rfDriverInterface.readPoll  != NULL )
					{
						insideBuffCtrl->completeSize = 0;		/* TCY		*/
						insideBuffCtrl->justReadFlag = 1;		/* ǂݎ蒆			*/
						useDrvResource = insideBuffCtrl;		/* kick obt@		*/
					}
					retCode = drvRead( addr,
								  insideBuffCtrl->buffAddr,
								  insideBuffCtrl->buffSize );	/* f[^ǂݍ */
				 }
			}
		}
	}
	return retCode;
}

/****************************************************************************/
/* T  v																	*/
/*        obt@ǗăXg[W̃Rs[Ȃ				*/
/* p[^																*/
/*        distAddrFʐ̃AhX										*/
/*        srcAddr Fʌ̃AhX										*/
/*        buff    Fobt@												*/
/*        len     FRs[钷											*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*        Rs[̓obt@TCYPʂłȂBRs[钷ob	*/
/*       t@TCY菬Ăobt@TCY̓Rs[Ă܂B		*/
/****************************************************************************/
unsigned short RfbCopy( unsigned long distAddr, unsigned long srcAddr, unsigned short len )
{
	
	return physicalCopy( distAddr, srcAddr, len );
}

/****************************************************************************/
/* T  v																	*/
/*        IȃRs[													*/
/* p[^																*/
/*        distAddrFʐ̃AhX										*/
/*        srcAddr Fʌ̃AhX										*/
/*        buff    Fobt@												*/
/*        len     FRs[钷											*/
/* ߂l																	*/
/*        RF_OKF														*/
/*        RF_ERR_...Fs													*/
/*   																	*/
/*        Rs[̓obt@TCYPʂłȂBRs[钷ob	*/
/*       t@TCY菬Ăobt@TCY̓Rs[Ă܂B		*/
/****************************************************************************/
unsigned short physicalCopy( unsigned long distAddr, unsigned long srcAddr, unsigned short len )
{
	unsigned short err;
	T_RF_FILE_BUFF * pBuffCtrl;
	unsigned long diffAddr;

	if( buffCtrlUnify.canWriteFlag != FALSE )
	{
		do
		{
			err = CheckInAddr( srcAddr, &pBuffCtrl, TRUE );	/* f[^擾 */
			if( err != RF_OK )		goto ERR_EXIT;
			diffAddr = srcAddr - pBuffCtrl->cardAddr;	/* 擪AhXƂ̍␳ */
			pBuffCtrl->cardAddr = distAddr - diffAddr;	/* f[^̃AhXRs[ɏ */
			pBuffCtrl->updateFlag = TRUE;				/* eXVꂽƂ */
			err = reflectABuffer( pBuffCtrl );			/*  */
			if( err != RF_OK )		goto ERR_EXIT;
			if( ( pBuffCtrl->buffSize - (unsigned short)diffAddr ) < len )
			{
				/* ܂c肪̂ő̏Ȃ */
				len -= pBuffCtrl->buffSize - (unsigned short)diffAddr;
				srcAddr += pBuffCtrl->buffSize - (unsigned short)diffAddr;
				distAddr += pBuffCtrl->buffSize - (unsigned short)diffAddr;
			}
			else
			{
				len = 0;								/* Ŝ̃Rs[I */
			}
		}
		while( len != 0 );

		err = waitResource();							/* \[X҂	*/
	}
	else
	{
		err = RF_ERR_CANT_WRITE_FOR_BUFF;				/* obt@TCYŝ߃Rs[łȂ */
	}
ERR_EXIT:
	return err;
}

/****************************************************************************/
/* T  v																	*/
/*        obt@݉\ׂ									*/
/* p[^																*/
/*        Ȃ																*/
/* ߂l																	*/
/*        TRUE F݉\ł											*/
/*        FALSEF݂͂łȂ											*/
/*   																	*/
/****************************************************************************/
unsigned short RfbIsCanWrite( void )
{
	return (unsigned short)buffCtrlUnify.canWriteFlag;
}

/****************************************************************************/
/* T  v																	*/
/*        ő̂Qׂ̂̐T										*/
/* p[^																*/
/*        orgF̐														*/
/* ߂l																	*/
/*        org ȉōő̂Qׂ̂̐									*/
/*   																	*/
/*        16 rbg̒ԈʒuoCiŁAi[Qׂ̂	*/
/*       ̍őlTĂB												*/
/****************************************************************************/
unsigned short checkMaxPow( unsigned short org )
{
	unsigned short ref = 0x0100;
	unsigned short shiftNum = 8;
	unsigned short maxPow = 1;

	while( shiftNum != 0 )
	{
		shiftNum /= 2;
		if( org < ref )
		{
			ref >>= shiftNum;
		}
		else
		{
			maxPow = ref;
			ref <<= shiftNum;
		}
	}
	return maxPow;
}